#include <allegro.h>
#include <math.h>
#include <stdio.h>

#include "bullets.h"
#include "ship.h"
#include "roids.h"
#include "input.h"
#include "display.h"

int numBullets;
struct bullet_t bullets[40];

void bullet_destroy(int c)
{
	bullets[c] = bullets[numBullets - 1];
    numBullets--;
}

struct bullet_t bullet_spawn()
{
	struct bullet_t bullet;
    bullet.Vel = 180;
    bullet.xPos = ship.xPos+24;
    bullet.yPos = ship.yPos+24;
    bullet.ang = ship.ang+128;
    bullet.vis = 1;
    bullet.updates = 20;
    bullet.color = BULLET_COLOR;
    bullet.xSize = 2;
    bullet.ySize = 2;
    return bullet;
}

void bullets_init()
{
	numBullets = 0;
}

void bullets_update()
{
 	int c,angDeg,xVel,yVel;

    for (c = numBullets;(c < numBullets+fire) && (c < 40) && shield == 0; c++) {
        bullets[c] = bullet_spawn();
        numBullets++;
        fire -= 8;
	if (fire < 0) fire = 0;
    }

    for (c = 0 ; c < numBullets ; c++)
       if (bullets[c].vis == 1 && bullets[c].updates >= 0) {
         /*get angle in range...for some reason, I have no luck with mod */
   			while (bullets[c].ang > 255)
     			bullets[c].ang -= 256;
   			while (bullets[c].ang < 0)
     			bullets[c].ang += 256;

   			angDeg = bullets[c].ang * 360 / 256;

   			/* Get x and y velocities based on angle and velocity.
   			* Thanks to visiken for the theory and formulas
   		 	*/
   			xVel = bullets[c].Vel * cos(angDeg * (3.141593/180));
   			yVel = bullets[c].Vel * sin(angDeg * (3.141593/180));

    		/* set the bullet positions */
   			bullets[c].xPos += xVel/10;
   			bullets[c].yPos += yVel/10;

   			/* Handle screen wrap */
   			bullets[c].xPos = (bullets[c].xPos >= 640) ? 0 : bullets[c].xPos;
   			bullets[c].xPos = (bullets[c].xPos < 0) ? 640 : bullets[c].xPos;

   			bullets[c].yPos = (bullets[c].yPos >= 440) ? 0 : bullets[c].yPos;
   			bullets[c].yPos = (bullets[c].yPos < 0) ? 440 : bullets[c].yPos;

            bullets[c].updates--;
	   } else
    	bullet_destroy(c);

}

void bullets_shutdown()
{
}

void bullets_draw()
{
 	int c;
	for (c = 0 ; c < numBullets; c++)
       if (bullets[c].vis == 1) {
         rectfill(field,bullets[c].xPos,bullets[c].yPos,bullets[c].xPos+1,bullets[c].yPos+1,bullets[c].color);
	   }
}
