/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BULLETS_H
#define BULLETS_H

struct bullet_t {
	int xPos;
    int yPos;
    int Vel;
    int ang;
    int xSize;
    int ySize;
    int updates;
    int vis;
    int color;
    int hostile;	/* will be 1 if the bullet can harm the player */
};

#define HOSTILE 1;
#define BENIGN 0;

#define BULLET_COLOR makecol(231,158,0)

void bullets_init();
void bullets_shutdown();
void bullets_update();
void bullets_draw();
void bullet_destroy(int x);

extern struct bullet_t bullets[40];
extern int numBullets;

#endif
