/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Collision detection */

#include <allegro.h>
#include <stdio.h>

#include "collis.h"
#include "roids.h"
#include "ship.h"
#include "bullets.h"
#include "rules.h"
#include "fire.h"
#include "enemy.h"
#include "input.h"
#include "game.h"
#include "display.h"


void collis_init()
{
}

void collis_killship()
{
	int mini;
	lives--;
	spawn_fire(ship.xPos,ship.yPos,2);
    for (mini = 0 ; mini < 10 ; mini++) {
		game_miniframe();
	}
	ship.xPos = 640/2;
	ship.yPos = 440/2;
	ship.Vel = 0;
	ship.ang = 64;
	ship.xSize = 48;
	ship.ySize = 48;
	ship.safe = 30;
}

void collis_update()
{
   int c,x;
   /* nasty bugfix */
	if (enemy.vis == 0) numEnemy = 0;
	
	for (c = 0; c < numRoids;c++) {
			/* Handle shield and roids */
       		if (collis_detect(ship_to_collis(ship),roid_to_collis(roids[c])) == 1 && roids[c].safe <= 0) {
				if (shield == 1 && shieldPower > 0 && roids[c].safe <= 0 && ship.safe > 0) {
            		roid_break(c,20);
           			spawn_fire(roids[c].xPos,roids[c].yPos,1);
				} else if (ship.safe <= 0){
		    		roid_break(c,10);	
           			collis_killship();
           		}
       		}
       		
       		for (x = 0; x < numBullets; x++) {
       			/* Kill roid if bullet hits it */
	    		if (collis_detect(bullet_to_collis(bullets[x]),roid_to_collis(roids[c])) == 1) {
               		roid_break(c,20);
               		bullet_destroy(x);
               		spawn_fire(roids[c].xPos,roids[c].yPos,1);
            	}

          		/* Let hostile bullets kill the ship */
	    		if ((collis_detect(bullet_to_collis(bullets[x]),ship_to_collis(ship)) == 1) && (bullets[x].hostile == 1) && (ship.safe <= 0)) {
					collis_killship();
					bullet_destroy(x);
				}

 				if ((collis_detect(ship_to_collis(enemy),bullet_to_collis(bullets[x])) == 1) &&( bullets[x].hostile != 1) && (numEnemy > 0)) {
 					bullet_destroy(x);
					numEnemy = 0;
					rules_action(ENEMYKILL);
					spawn_fire(enemy.xPos,enemy.yPos,2);
 				}
			}
		}
	if (collis_detect(ship_to_collis(ship),ship_to_collis(enemy)) == 1 && enemy.safe <= 0 && ship.safe > 0 && numEnemy > 0) {
    	numEnemy = 0;
    	rules_action(ENEMYKILL);
        spawn_fire(enemy.xPos,enemy.yPos,2);
    } else if (collis_detect(ship_to_collis(ship),ship_to_collis(enemy)) == 1 && ship.safe <= 0 && numEnemy > 0) {
		numEnemy = 0;
		rules_action(ENEMYKILL);	
    	collis_killship();
	}
}

int collis_detect(struct collis_t fl1, struct collis_t fl2)
{
	if (fl1.xPos >= fl2.xPos && fl1.xPos <= fl2.xPos+fl2.xSize && fl1.yPos >= fl2.yPos && fl1.yPos <= fl2.yPos+fl2.ySize)
      return 1;
   	if (fl2.xPos >= fl1.xPos && fl2.xPos <= fl1.xPos+fl1.xSize && fl2.yPos >= fl1.yPos && fl2.yPos <= fl1.yPos+fl1.ySize)
      return 1;
    return 0;
}

struct collis_t roid_to_collis(struct roid_t inRoid)
{
	struct collis_t fly;
    fly.xPos = inRoid.xPos;
    fly.yPos = inRoid.yPos;
    fly.xSize = inRoid.xSize;
    fly.ySize = inRoid.ySize;
    return fly;
}

struct collis_t bullet_to_collis(struct bullet_t inBullet)
{
	struct collis_t fly;
    fly.xPos = inBullet.xPos;
    fly.yPos = inBullet.yPos;
    fly.xSize = inBullet.xSize;
    fly.ySize = inBullet.ySize;
    return fly;
}

struct collis_t ship_to_collis(struct ship_t inShip)
{
	struct collis_t fly;
    fly.xPos = inShip.xPos;
    fly.yPos = inShip.yPos;
    fly.xSize = inShip.xSize;
    fly.ySize = inShip.ySize;
    return fly;
}


void collis_shutdown()
{
}


