/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef COLLIS_H
#define COLLIS_H

#include "ship.h"
#include "roids.h"
#include "bullets.h"

/* structure for flying object. The ship, asteroids, and bullet all apply */
struct collis_t {
	int xPos;
    int yPos;
    int xSize;
    int ySize;
};

void collis_init();
void collis_shutdown();

struct collis_t roid_to_collis(struct roid_t inRoid);
struct collis_t ship_to_collis(struct ship_t inShip);
struct collis_t bullet_to_collis(struct bullet_t inBullet);

void collis_update();
int collis_detect(struct collis_t fl1, struct collis_t fl2);

#endif
