/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <allegro.h>
#include <stdio.h>
#include <time.h>
#include <math.h>

#include "enemy.h"
#include "ship.h"
#include "roids.h"
#include "bullets.h"
#include "display.h"
#include "fire.h"
#include "game.h"
#include "rules.h"

int numEnemy;
struct ship_t enemy;
BITMAP * enemySprite;

#define sqr(x) x*x

void enemy_init()
{
    if ((enemySprite = load_bmp(findfile("enemy.bmp"),NULL)) == NULL) {
       fprintf(stderr," Error loading enemy.bmp.");
       abnormal_exit(2);
    }
    enemy.sprite = enemySprite;
    enemy.xPos = 0;
    enemy.yPos = rand()%480;
    enemy.Vel = 0;
    enemy.ang = 128;
    enemy.xSize = 48;
    enemy.ySize = 48;
    enemy.safe = 50;
}

void enemy_shutdown()
{

}

void enemy_update()
{
   int x,y;
   if (enemy.vis == 1 && numEnemy > 0) {
   int xVel,yVel,angDeg, gunAng;
   x = (ship.xPos > enemy.xPos) ? ship.xPos - enemy.xPos : enemy.xPos - ship.xPos;
   y = (ship.yPos > enemy.yPos) ? ship.yPos - enemy.yPos : enemy.yPos - ship.yPos;
   
   gunAng =  (asin(sqrt(sqr(x) + sqr(y))/(x)));
    
    if (rand()%6 == 1) {
    	bullets[numBullets].Vel = 180;
    	bullets[numBullets].xPos = enemy.xPos+24;
    	bullets[numBullets].yPos = enemy.yPos+24;
    	bullets[numBullets].ang = gunAng * 360 / 256;
    	bullets[numBullets].vis = 1;
 	  	bullets[numBullets].updates = 20;
   		bullets[numBullets].color = makecol(0,255,0);
    	bullets[numBullets].xSize = 2;
    	bullets[numBullets].ySize = 2;
    	bullets[numBullets].hostile = 1;
    	numBullets++;
    }

/* goofy random motion */
  if (rand()%25 == 1)
	enemy.ang += 10;
  else if (rand()%25 == 2)
  	enemy.ang -= 10;

  if (rand()%40 > 20)
  	enemy.Vel += 10;
  else
  	enemy.Vel -= 10;
  	
 	

  /*get angle in range...for some reason, I have no luck with mod */
   while (enemy.ang > 255)
     enemy.ang -= 256;
   while (enemy.ang < 0)
     enemy.ang += 256;

   angDeg = enemy.ang * 360 / 256;

   /* handle terminal velocity */
   if (enemy.Vel > 90 || enemy.Vel < -150) enemy.Vel = (enemy.Vel > 90) ? 90 : -150 ;

   /* handle enemy decay */
   enemy.Vel = (enemy.Vel < 15 && enemy.Vel > -15) ? (enemy.Vel > 0) ? enemy.Vel - 1: ship.Vel + 1: (enemy.Vel > 0) ? ship.Vel - 4 : enemy.Vel + 4;
   enemy.Vel = (enemy.Vel < 4 && enemy.Vel > -4) ? 0 : enemy.Vel;

   /* Get x and y velocities based on angle and velocity.
   	* Thanks to visiken for the theory and formulas
    */
   xVel = enemy.Vel * cos(angDeg * (3.141593/180));
   yVel = enemy.Vel * sin(angDeg * (3.141593/180));

    /* set the enemy positions */
   enemy.xPos += xVel/10;
   enemy.yPos += yVel/10;

   /* Handle screen wrap */
   enemy.xPos = (enemy.xPos >= 640) ? 0 : enemy.xPos;
   enemy.xPos = (enemy.xPos < 0) ? 640 : enemy.xPos;

   enemy.yPos = (enemy.yPos >= 440) ? 0 : ship.yPos;
   enemy.yPos = (enemy.yPos < 0) ? 440 : enemy.yPos;

   if (enemy.safe >= 0) enemy.safe--;
  } else {
  	if (rand()%400 <= wave) {
   		enemy.vis = 1;
   		numEnemy++;
    	enemy.xPos = 0;
    	enemy.yPos = rand()%480;
    	enemy.Vel = 0;
   	 	enemy.ang = 128;
    	enemy.xSize = 48;
    	enemy.ySize = 48;
   		enemy.safe = 25;
   		enemy.vis = 1;
   	}
  }
  if (numEnemy <= 0)
  	enemy.vis = 0;
  if (enemy.vis == 0)
  	numEnemy = 0;
}

void enemy_draw()
{
if (enemy.vis == 1 && numEnemy > 0)
   rotate_sprite(field,enemy.sprite,enemy.xPos,enemy.yPos,itofix((enemy.ang > 128) ? enemy.ang - 128 : enemy.ang + 128));
}

