/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <allegro.h>
#include <stdio.h>

#include "fire.h"
#include "display.h"
#include "game.h"

BITMAP * fire1;
BITMAP * fire2;
BITMAP * fire3;

struct fire_t fires[15];
int numFires;

int spawn_fire(int x,int y,int size)
{
	fires[numFires].xPos = x;
    fires[numFires].yPos = y;
    fires[numFires].state = 10;
    fires[numFires].vis = 1;
    fires[numFires].size = size;
    return numFires++;
}

void fire_init()
{

    if ((fire1 = load_bmp(findfile("fire1.bmp"),NULL)) == NULL) {
        fprintf(stderr," Error loading fire1.bmp.");
        abnormal_exit(2);
    }
    if ((fire2 = load_bmp(findfile("fire2.bmp"),NULL)) == NULL) {
        fprintf(stderr," Error loading fire2.bmp.");
        abnormal_exit(2);
    }
    if ((fire3 = load_bmp(findfile("fire3.bmp"),NULL)) == NULL) {
        fprintf(stderr," Error loading fire3.bmp.");
        abnormal_exit(2);
    }
    fire1=load_bmp(findfile("fire1.bmp"),NULL);
    fire2=load_bmp(findfile("fire2.bmp"),NULL);
    fire3=load_bmp(findfile("fire3.bmp"),NULL);
    numFires = 0;
}

void fire_update()
{
	int c;
    for (c = 0; c < numFires && fires[c].vis == 1; c++) {
    	fires[c].state+= 3;
    }
    for (c = 0; c < numFires && fires[c].state > 32; c++) {
    	fires[c].vis = 0;
        numFires--;
        fires[c] = fires[numFires];
    }
}

void fire_shutdown()
{

}

void fire_draw()
{
	int c;
    for (c = 0; c < numFires && fires[c].vis == 1; c++) {
        switch (fires[c].state/10) {
          case 1:
               stretch_sprite(field,fire1,fires[c].xPos,fires[c].yPos,fire1->w*fires[c].size,fire1->h*fires[c].size);
               break;
          case 2:
               stretch_sprite(field,fire2,fires[c].xPos,fires[c].yPos,fire2->w*fires[c].size,fire2->h*fires[c].size);
               break;
          case 3:
               stretch_sprite(field,fire3,fires[c].xPos,fires[c].yPos,fire3->w*fires[c].size,fire3->h*fires[c].size);
               break;
          }
    }
}
