/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <allegro.h>

#include "input.h"
#include "game.h"
#include "ship.h"
#include "roids.h"
#include "display.h"
#include "rules.h"

int rightNum;
int leftNum;
int upNum;
int downNum;

int fire;
int shield;

int fps;

void input_init()
{
    fps = 2000;
}

void input_update()
{
    if (pauseGame == 1)
      while(!key[KEY_P] && !key[KEY_ESC]);

 	if (key[KEY_ESC])
 		end_game = 1;
#ifdef __LINUX__
    if (key[KEY_UP] || key[KEY_8_PAD])
      upNum += 1;
    if (key[KEY_LEFT] || key[KEY_4_PAD])
      leftNum += 1;
    if (key[KEY_DOWN] || key[KEY_2_PAD])
      downNum += 1;
    if (key[KEY_RIGHT] || key[KEY_6_PAD])
      rightNum += 1;
#endif
#ifndef __LINUX__
    if (key[KEY_UP])
      upNum += 1;
    if (key[KEY_LEFT])
      leftNum += 1;
    if (key[KEY_DOWN])
      downNum += 1;
    if (key[KEY_RIGHT])
      rightNum += 1;
#endif

    if (key[KEY_LSHIFT] || key[KEY_TAB])
      shield = 1;
    if (!key[KEY_LSHIFT] && !key[KEY_TAB])
      shield = 0;

    if (key[KEY_ENTER] || key[KEY_SPACE])
      fire += 1;

    if (key[KEY_F12])
		takeshot();

    if (key[KEY_P])
      pauseGame = (pauseGame == 0) ? 1:0;

    if (key[KEY_EQUALS] || key[KEY_PLUS_PAD])	/* increase approx fps */
      fps += 10;
    if (key[KEY_MINUS] || key[KEY_MINUS_PAD])   /* decrease approx fps */
      fps -= 10;

/* CHEATS */
    /* Note: The cheats are for debugging and ARE NOT supported
     * They CAN and WILL mess with the display (i.e. more than is norm.
     * possible for lives can fill the statusbar, etc...
     */
//#define NOCHEATS		//uncomment this line to disable cheats at compile
#ifndef NOCHEATS
    if (key[KEY_C] && key[KEY_L])   /* Add life */
      lives++;

    if (key[KEY_C] && key[KEY_K])   /* Kill Current ship */
      lives--;

    if (key[KEY_C] && key[KEY_S]) 	/* fill shields */
      shieldPower = 300;

    if (key[KEY_C] && key[KEY_W])   /* Warp */
      numRoids = 0;
#endif
}

void input_shutdown()
{
	remove_keyboard();
}


