/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef ROIDS_H
#define ROIDS_H

struct roid_t {
	int xPos;
	int yPos;
    int Vel;
    int ang;
    BITMAP * sprite; 	/* not used now...maybe later */
    int xSize;			/* used in collision detection routines */
    int ySize;          /* same as xSize */
    int size;       	/*0 = small, 1 = med, 2 = large */
    int vis;
    int safe;			/* how many more updates the roid is safe from death */
    };

void roid_break(int c, int safeTime);
void roids_init();
void roids_update();
void roids_shutdown();
void roids_draw();

extern BITMAP * roidSprite;
extern int numRoids;
extern struct roid_t roids[40];

#endif


