/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <allegro.h>
#include <stdio.h>

#include "display.h"
#include "game.h"
#include "rules.h"
#include "roids.h"
#include "ship.h"
#include "roids.h"
#include "bullets.h"

int score;
int lives;

int engine;
int gun;

int wave;
BITMAP * life;

void rules_init()
{
	engine = gun = 255;
    score = 0;
    wave = 1;
    lives = 5;
    if ((life = load_bmp(findfile("life.bmp"),NULL)) == NULL) {
	   fprintf(stderr," Error loading life.bmp.");
	   abnormal_exit(2);
    }
}

void rules_action(int act)
{
   switch (act) {
     case -1:
          lives--;
          break;
     case ROIDKILL:
          if (wave >= 8) score += 500; else score += wave+2*50;
          break;
     case ROIDSPLIT:
          if (wave >= 8) score += 100; else score += wave+2*10;
          break;
     case ENEMYKILL:
     	  score += 500*wave;
     	  break;
	default:
         break;
   }
}

void rules_shutdown()
{
}

void new_wave()
{
    score+=lives*100;
	roids_init();
    ship.safe = 50;
    bullets_init();
    wave++;
}

void rules_draw()
{
 	int x;

    textprintf(status,font,2,2,makecol(255,255,255),"%7i    Wave: %3i    Shield:",score,wave);

    for (x = 1; x <= shieldPower/10;x++)
    	vline(status,text_length(font,"XXXXXXX    Wave: XXX    Shield:") + 2*x,0,20,makecol(0,255,0));

	for (x = 1; x<= lives;x++)
       draw_sprite(status,life,SCREEN_WIDTH-(x*20+10),-10);
}

void rules_update()
{
	if (lives == 0)
      end_game = 1;
    if (numRoids <= 0)
      new_wave();
}
