/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* another "special" module...it takes control from main() and passes it to run_once, and then runs when it returns */

#include <allegro.h>
#include <stdio.h>

#include "game.h"
#include "display.h"
#include "title.h"

void title()
{
    BITMAP * title;
    PALETTE pal;

    game_init();
    install_keyboard();
    title = create_bitmap(640,480);
    if ((title = load_bmp(findfile("title.bmp"),pal)) == NULL) {
       fprintf(stderr,"Error loading title.bmp.\n");
       abnormal_exit(2);
    }
    set_palette(pal);

    fade_out(64);
    blit(title,screen,0,0,0,0,640,480);
    fade_in(pal,5);
    titleloop();
 }

void titleloop()
{
    for (;;) {
       if (key[KEY_ENTER] || key[KEY_N]) {
         	fade_out(5);
			run_once();
            remove_keyboard();
            title();
       }
 	   if (key[KEY_ESC])
         return;
	}
}
