/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifdef USE_LIBINI
#ifndef WIN32
#include <ini.h>
#else
#include "libini\ini.h"
#endif
#endif
#include "spk.h"
#include "video.h"
#include "config.h"
#include "multiplay.h"

extern Net *net;

static int USETRANS=1;

extern int CHANGE;
extern int USERUSKEY;
extern int BLOODYMENU;
extern int MODEMPORT;
extern int SOUND;
extern int MODSOUND;
extern int digvoices;
extern int modvoices;
extern int modvol;
extern char modname[128];
extern char HOSTNAME[256];
extern char PORT[256];
extern int MAP_WIDTH, MAP_HEIGHT;

extern int local_platoon_size;
extern char last_map_name[1000];
extern char last_unit_name[1000];


#ifdef USE_LIBINI
static INI_NODE *ini_file;
#else
static char *gen = "General";
static char *edit = "Editor";
#endif

void loadini() {
#ifdef USE_LIBINI
	if (ini_load(&ini_file, "ufo2000.ini") == INI_CALL_SUCCESSFUL) {
		ini_get_string(ini_file, "General", "port", PORT);
		ini_get_string(ini_file, "General", "server", HOSTNAME);
		ini_get_int(ini_file, "General", "width", &SCREEN2W);
		ini_get_int(ini_file, "General", "height", &SCREEN2H);
		ini_get_int(ini_file, "General", "map_width", &MAP_WIDTH);
		ini_get_int(ini_file, "General", "map_height", &MAP_HEIGHT);
		ini_get_truth(ini_file, "General", "russian", &USERUSKEY);
		ini_get_truth(ini_file, "General", "bloodymenu", &BLOODYMENU);
		if (rand() % 77 == 0)
			BLOODYMENU = 1 - BLOODYMENU;

		ini_get_truth(ini_file, "General", "sound", &SOUND);
		ini_get_int(ini_file, "General", "comport", &MODEMPORT);
		MODEMPORT--;
		ini_get_truth(ini_file, "General", "modules", &MODSOUND);
		ini_get_int(ini_file, "General", "digvoices", &digvoices);
		ini_get_int(ini_file, "General", "modvoices", &modvoices);
		ini_get_string(ini_file, "General", "modname", modname);
		ini_get_int(ini_file, "General", "modvolume", &modvol);

		/*if (ini_get_int(ini_file, "Platoon1", "size", &P1S) != INI_CALL_SUCCESSFUL)	  P1S=2;
		if (ini_get_int(ini_file, "Platoon1", "startcol", &P1X) != INI_CALL_SUCCESSFUL) P1X=5;
		if (ini_get_int(ini_file, "Platoon1", "startrow", &P1Y) != INI_CALL_SUCCESSFUL) P1Y=12;

		if (ini_get_int(ini_file, "Platoon2", "size", &P2S) != INI_CALL_SUCCESSFUL)	  P2S=2;
		if (ini_get_int(ini_file, "Platoon2", "startcol", &P2X) != INI_CALL_SUCCESSFUL) P2X=15;
		if (ini_get_int(ini_file, "Platoon2", "startrow", &P2Y) != INI_CALL_SUCCESSFUL) P2Y=12;
		*/
		if (ini_get_int(ini_file, "Editor", "platoon_size", &local_platoon_size) != INI_CALL_SUCCESSFUL) local_platoon_size=0;
		if (ini_get_string(ini_file, "Editor", "last_map_name", last_map_name) != INI_CALL_SUCCESSFUL)
			*last_map_name = 0;
		if (ini_get_string(ini_file, "Editor", "last_unit_name", last_unit_name) != INI_CALL_SUCCESSFUL)
			*last_unit_name = 0;
	}
#else
	set_config_file("ufo2000.ini");

	strcpy(PORT, get_config_string(gen, "port", "2000"));
	strcpy(HOSTNAME, get_config_string(gen, "server", "127.0.0.1"));
	MODEMPORT = get_config_int(gen, "comport", 2) - 1;

	SCREEN2W = get_config_int(gen, "width", 430);
	SCREEN2H = get_config_int(gen, "height", 280);
	MAP_WIDTH = get_config_int(gen, "map_width", 4);
	MAP_HEIGHT = get_config_int(gen, "map_height", 4);
	USERUSKEY = get_config_int(gen, "russian", 1);
	BLOODYMENU = get_config_int(gen, "bloodymenu", 0);
	if (rand() % 77 == 0)
		BLOODYMENU = 1 - BLOODYMENU;

	SOUND = get_config_int(gen, "sound", 1);
	MODSOUND = get_config_int(gen, "modules", 0);
	digvoices = get_config_int(gen, "digvoices", 16);
	modvoices = get_config_int(gen, "modvoices", 8);
	strcpy(modname, get_config_string(gen, "modname", "templsun.xm"));
	modvol = get_config_int(gen, "modvolume", 125);

	local_platoon_size = get_config_int(edit, "platoon_size", 0);
	strcpy(last_map_name, get_config_string(edit, "last_map_name", ""));
	strcpy(last_unit_name, get_config_string(edit, "last_unit_name", ""));

	/*SCREEN2W = 430;
	SCREEN2H = 280;
	MAP_WIDTH = 4;
	MAP_HEIGHT = 4;
	USERUSKEY = 1;
	BLOODYMENU = 0;


	SOUND = 0;
	MODSOUND = 0;
	digvoices = 16;
	modvoices = 8;

	local_platoon_size = 8;*/
#endif
}

void saveini() {
#ifdef USE_LIBINI
	ini_put_entry(ini_file, "", "General", ";ip address of server", "server", "%s", HOSTNAME);
	ini_put_entry(ini_file, "", "General", ";battle screen width", "width", "%d", SCREEN2W);
	ini_put_entry(ini_file, "", "General", ";battle screen height", "height", "%d", SCREEN2H);

	ini_put_entry(ini_file, "", "Editor", ";number of soldiers in editor, internal data", "platoon_size", "%d", local_platoon_size);
	ini_put_entry(ini_file, "", "Editor", ";internal data", "last_map_name", "%d", last_map_name);
	ini_put_entry(ini_file, "", "Editor", ";internal data", "last_unit_name", "%d", last_unit_name);

	ini_flush(ini_file, "ufo2000.ini");
	ini_free(ini_file);
#else
	set_config_string(gen, "server", HOSTNAME);
	set_config_int(gen, "width", SCREEN2W);
	set_config_int(gen, "height", SCREEN2H);

	set_config_int(edit, "platoon_size", local_platoon_size);
	set_config_string(edit, "last_map_name", last_map_name);
	set_config_string(edit, "last_unit_name", last_unit_name);
#endif
}

int selectplaymode() {
	SPK *back01 = new SPK("geograph/back01.scr");
	SPK *back03 = new SPK("geograph/back03.scr");

	install_int_ex(drawit_timer,  BPS_TO_TIMER(10) ); //ticks each second

	position_mouse(160, 100);
	set_mouse_range(0, 0, 319, 199);

	RGB pal[PAL_SIZE];
	setpal(pal, 0xC18);

	RGB_MAP rgb_table;
	COLOR_MAP trans_table_left;
	COLOR_MAP trans_table_right;
	int ttl=0, ttr=0;

	create_rgb_table(&rgb_table, pal, NULL);
	RGB_MAP *rgb_map_old = rgb_map;
	rgb_map = &rgb_table;

	//create_trans_table(&trans_table_left,  pal, 0, 0, 0, cf);
	//create_trans_table(&trans_table_right, pal, 0, 0, 0, cf);
	BITMAP *scr = create_bitmap(320, 200); clear(scr);
	BITMAP *left = create_bitmap(76, 149); clear(left);
	BITMAP *right = create_bitmap(97, 101); clear(right);
	back01->show(scr, 0, 0);
	blit(scr, left, 127, 28, 0, 0, left->w, left->h);
	blit(scr, right, 205, 98, 0, 0, right->w, right->h);

	int o;
	for (o=0;o<right->w*right->h;o++) {
		int v = spr_get(right, o);
		if ((v == 238) || (v == 239))
			spr_set(right, o, 0);
	}

	for (o=0;o<left->w*left->h;o++) {
		int v = spr_get(left, o);
		if ((v == 238) || (v == 239))
			spr_set(left, o, 0);
	}


	int DONE=0;
	int ishost=-1;
	int lp=0, rp=0;
	DRAWIT=1;
	text_mode(-1);

	while(!DONE) {
		if (CHANGE) {
			if (mouse_b & 1) {
				lp=1;
			}
			if (mouse_b & 2) {
				rp=1;
			}
			if (lp) {
				if (!(mouse_b & 1)) {
					if (mouse_inside(0, 0, 100, 150)) {
						ishost=1;
						break;
					}
					if (mouse_inside(200, 0, 320, 150)) {
						ishost=0;
						break;
					}
					lp=0;
					//break;
				}
			}
			if (rp) {
				if (!(mouse_b & 2)) {
					break;
				}
			}
			CHANGE=0;
			DRAWIT=1;
		}
		if (DRAWIT) {
			if (mouse_inside(0, 0, 100, 150)) {
				ttl++; ttr--;
			} else if (mouse_inside(200, 0, 320, 150)) {
				ttr++; ttl--;
			} else {
				ttr--; ttl--;
			}
			if (ttl<0) ttl=0; if (ttl>14) ttl=14;
			if (ttr<0) ttr=0; if (ttr>14) ttr=14;
if (USETRANS) {
			create_trans_table(&trans_table_left, pal, ttl*16, ttl*16, ttl*16, NULL);
			create_trans_table(&trans_table_right, pal, ttr*16, ttr*16, ttr*16, NULL);
}
			back03->show(scr, 0, 0);
			if (mouse_inside(0, 0, 100, 150))
				textout(scr, font, "Server", 0, 141, 1);
			if (mouse_inside(200, 0, 320, 150))
				textout(scr, font, "Client", 272, 141, 1);
if (USETRANS) {
			color_map = &trans_table_left;
			draw_trans_sprite(scr, left, 0,0);
			color_map = &trans_table_right;
			draw_trans_sprite(scr, right, 223, 48);
} else {
	if (ttl>0)
		draw_sprite(scr, left, 0,0);
	if (ttr>0)
		draw_sprite(scr, right, 223,48);
}
			draw_sprite(scr, mouser, mouse_x, mouse_y);
			stretch_blit(scr, screen, 0,0, 320, 200, 0,0, 640,400);

			DRAWIT=0;
		}

		if (keypressed()) {
			int c = readkey();
			switch (c >> 8) {
				case KEY_ESC:
					  DONE = 1;
					  break;
			}
		}
	}

	rgb_map = rgb_map_old;

	position_mouse(160, 100);

	remove_int(drawit_timer);
	delete(back01);
	delete(back03);
	destroy_bitmap(right);
	destroy_bitmap(left);
	destroy_bitmap(scr);

	fade_out(10);
	clear(screen);

	return ishost;
}

int setmodemplay() {
	int host = selectplaymode();
	net->gametype = MODEM;
	return host;
}

int setnetplay() {
	int host = selectplaymode();
	net->gametype = IPX;
	return host;
}

int setsocketplay() {
	int host = selectplaymode();
	net->gametype = SOCK;
	return host;
}

int sethotseatplay() {
	net->gametype = HOTSEAT;
	return 1;
}

int setdplayplay() {
	int host = selectplaymode();
	net->gametype = DPLAY;
	return host;
}


void configer() {
/*
	SPK *back14 = new SPK("geograph/back14.scr");

	RGB pal[PAL_SIZE];
	setpal(pal, 0xC18);

	back14->show(0, 0);
	stretch_blit(scr, screen, 0,0, 320, 200, 0,0, 640,400);

	readkey();
	fade_out(10);
	clear(screen);
	delete(back14);
*/
}



void configure() {
	configer();
	return;
/*
	SPK *back14 = new SPK("geograph/back14.scr");

	RGB pal[PAL_SIZE];
	setpal(pal, 0xC18);
	//back14->showspk(0, 0);

	install_int_ex(drawit_timer,  BPS_TO_TIMER(10) ); //ticks each second
	position_mouse(160, 100);
	set_mouse_range(0, 0, 319, 199);


	int DONE=0, lp=0, rp=0;

	while(!DONE) {
		if (CHANGE) {
			if (mouse_b & 1) {
				lp=1;
			}
			if (mouse_b & 2) {
				rp=1;
			}
			if (lp) {
				if (!(mouse_b & 1)) {
					if (mouse_inside(0, 0, 100, 150)) {
					}
					if (mouse_inside(200, 0, 320, 150)) {
					}
					lp=0;
				}
			}
			if (rp) {
				if (!(mouse_b & 2)) {
					break;
				}
			}
			CHANGE=0;
			DRAWIT=1;
		}
		if (DRAWIT) {
			if (mouse_inside(0, 0, 100, 150)) {
			} else if (mouse_inside(200, 0, 320, 150)) {
			} else {
			}

			back14->show(0, 0);
			draw_sprite(scr, mouser, mouse_x, mouse_y);
			stretch_blit(scr, screen, 0,0, 320, 200, 0,0, 640,400);

			DRAWIT=0;
		}

		if (keypressed()) {
			int c = readkey();
			switch (c >> 8) {
				//case KEY_LEFT: palofs-=1; break;
				//case KEY_UP:	if (palofs>=768) palofs-=768; break;
				//case KEY_RIGHT:palofs+=1; break;
				//case KEY_DOWN: palofs=palettes_size-768; break;
				case KEY_ESC:
					  DONE = 1;
					  break;
			}
			CHANGE=1;
		}
	}

	clear(screen);
	position_mouse(160, 100);

	remove_int(drawit_timer);
	//readkey();
	delete(back14);
*/
}





/*


	void configmenu();

extern int SOUND;
extern int MODSOUND;

int vol_proc(void*dp3,int d2) {
	setmodvol(d2);
	return(D_O_K);
}

int vol_proc2(void*dp3,int d2) {
	setdigvol(d2);
	return(D_O_K);
}

extern char modname[128];

void Icon::configmenu() {
	int omx = mouse_x, omy = mouse_y;

DIALOG config[]={
 //proc				x	y	w	h fgbg	k	flags 1 2  dp
 {d_ctext_proc,  160,  4,  0,  8, 0,1,  0 ,	  0,0,0, (void *)"Configer"},
 {d_button_proc, 256,104, 56, 14, 0,1, 'o',D_EXIT,0,0, (void *)"&Open"}, //1
 {d_button_proc, 256,184, 56, 14, 0,1, 'x',D_EXIT,0,0, (void *)"E&xit"}, //2
 {d_slider_proc, 272, 32, 24, 64, 0,1,  0 ,	  0,255,getmodvol(),NULL,vol_proc}, //3
 {d_slider_proc, 242, 32, 24, 64, 0,1,  0 ,	  0,255,getdigvol(),NULL,vol_proc2}, //4
 {d_button_proc, 256,120, 56, 14, 0,1, 'n',D_EXIT,0,0, (void *)"&Net"}, //5
 {d_text_proc,  0, 20,  0,  8, 0,1,  0 ,	  0,0,0, (void *)"Playing:"}, //6
 {d_text_proc,  70, 20,  0,  8, 0,1,  0 ,	  0,0,0, (void *)modname},  //7
 {NULL}
};
cfg:
config[3].d2 = getmodvol();
	if (!MODSOUND) {
		//config[1].flags |= D_DISABLED;
		config[3].flags |= D_DISABLED;
		*((char*)config[7].dp) = 0;
	} else {
		config[3].flags = 0;
		//config[7].dp = strdup();
	}

	if (!SOUND) {
		config[1].flags |= D_DISABLED;
		config[3].flags |= D_DISABLED;
		config[4].flags |= D_DISABLED;
	}
	//set_mouse_speed(1, 1);
	set_mouse_range(0, 0, 639, 399);
	//rectfill(screen, 0,0,319,199, 1);
	int sel = do_dialog(config,-1);

	if (sel == 1) {
		char file[80];
		strcpy(file, modname);

		if (file_select("Select MOD file",file,"S3M;MOD;XM;IT;JGM")) {
			if (modplay(file)) {
				MODSOUND=1;
			}
		}
		clear(screen);

		goto cfg;
	}
	if (sel == 5) { //net config
		;
	}
	//set_mouse_speed(2, 2);
	//set_mouse_range(0, 0, 319, 199);
	set_mouse_range(0, 0, SCREEN2W-1, SCREEN2H-1);
	position_mouse(omx, omy);
}
*/
