/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef EDITOR_H
#define EDITOR_H
#include "pck.h"
#include "spk.h"
#include "item.h"
#include "place.h"
#include "soldier.h"
#include "platoon.h"
#include "map.h"
#include "units.h"

class Editor {
private:
	Place armoury;
	Soldier *man;
	Platoon *plt;
	Map *m_map;

	SPK *tac01;
	BITMAP *b123, *b4, *b5;

	Item *sel_item;
	Item *dup_item;
	int sel_item_place;

	int load_clip();
public:
	Editor();

	void load();
	void save();
	void show(int NEXTPREV);
	int set_man(char *name);

	inline void build_Units(Units &local) { plt->build_Units(local); }
	inline void send_Units(Units &local) { plt->send_Units(local); }
	inline Platoon *platoon() { return plt; };

	void edit_soldier();

	void do_mapedit();
	BITMAP *terrain_bmp;
	int do_mapselect();
	void load_map();
	void save_map();
	void create_map();
};

#endif
