/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include "ldw.h"
#include "version.h"
#include "pck.h"
#include "explo.h"
#include "soldier.h"
#include "platoon.h"
#include "map.h"
#include "icon.h"
#include "inventory.h"
#include "sound.h"
#include "multiplay.h"
#include "wind.h"
#include "config.h"
#include "mainmenu.h"
#include "editor.h"
#include "about.h"
#include "video.h"
#include "keys.h"
#ifdef WIN32
#include <allegro/aintwin.h>
#include "../resource.h"
#endif

//#define DEBUG
#define MSCROLL 10
#define BACKCOLOR 0

extern int CONFIRM_REQUESTED;

Target target;
int HOST, DONE, TARGET, turn;
Mode MODE;
Wind *info;
BITMAP *info_background, *logo;

Net *net;
Map *map;
Icon *icon;
Inventory *inventory;
About *about;
Editor *editor;
Platoon *p1, *p2;
Platoon *platoon_local, *platoon_remote;
Soldier *sel_man=NULL;
Explosive elist;

int CHANGE=1;
//volatile int CHANGE=1;
volatile int MOVEIT=0;
volatile int FLYIT=0;
volatile int NOTICE=1;
int NOTICEremote=0;
int NOTICEdemon=0;

void mouser_proc(int flags) { CHANGE=1; } END_OF_FUNCTION(mouser_proc);
void timer_handler() { MOVEIT++; }		  END_OF_FUNCTION(timer_handler);
void timer_handler2() { FLYIT++; }		  END_OF_FUNCTION(timer_handler2);
void timer_handler3() { NOTICE++; }		 END_OF_FUNCTION(timer_handler3);

int keyboard_proc(int key) {
	if (key >> 8 == KEY_F10) {
		change_screen_mode();
		return 0;
	}
	return key;
}
END_OF_FUNCTION(keyboard_proc);

GEODATA mapdata;
PLAYERDATA pd1, pd2;
PLAYERDATA *pd_local, *pd_remote;
int local_platoon_size;
extern int RECALC_VISIBILITY;

//simple all of new - rem about rand in sol's constructors
//can diff on remote comps
void restartgame() {
	//map = new Map(4,4);
	//map->load("floor0.map", Map::cultivat);
	//map = new Map("GEODATA.DAT");
	map = new Map();
	p1 = new Platoon(1111, &pd1);
	p2 = new Platoon(2222, &pd2);

	int fh = open("cur_map.dat", O_CREAT|O_TRUNC|O_RDWR|O_BINARY, S_IRUSR|S_IWUSR);
	assert( fh != -1 );
	write(fh, &mapdata, sizeof(mapdata));
	close(fh);

	fh = open("cur_p1.dat", O_CREAT|O_TRUNC|O_RDWR|O_BINARY, S_IRUSR|S_IWUSR);
	assert( fh != -1 );
	write(fh, &pd1, sizeof(pd1));
	close(fh);

	fh = open("cur_p2.dat", O_CREAT|O_TRUNC|O_RDWR|O_BINARY, S_IRUSR|S_IWUSR);
	assert( fh != -1 );
	write(fh, &pd2, sizeof(pd2));
	close(fh);

	//srand(0); //workaround!!!
	//p1 = new Platoon(1111, P1S, P1Z, P1X, P1Y, 0);
	//p2 = new Platoon(2222, P2S, P2Z, P2X, P2Y, 4);
	//srand(time(NULL));

	/*map->place(0, P1X, P1Y+2)->put(new Item(HIGH_EXPLOSIVE));
	map->place(0, P2X, P2Y+2)->put(new Item(HIGH_EXPLOSIVE));

	map->place(0, P1X, P1Y+2)->put(new Item(LASER_PISTOL));
	map->place(0, P2X, P2Y+2)->put(new Item(LASER_PISTOL));

	map->place(0, P1X, P1Y+2)->put(new Item(LASER_GUN));
	map->place(0, P2X, P2Y+2)->put(new Item(LASER_GUN));*/

	elist.reset();
	if (HOST) {
		platoon_local = p1;
		platoon_remote = p2;
		MODE = MAP3D;
	} else {
		platoon_local = p2;
		platoon_remote = p1;
		MODE = WATCH;
	}

	//sel_man = NULL;
	sel_man = platoon_local->captain();
	map->center(sel_man);
	DONE=0; TARGET=0; turn=0;
   RECALC_VISIBILITY=1;
}

int initgame() {
	if (!net->init())
		return 0;
	install_int_ex(timer_handler,  BPS_TO_TIMER(15) ); //ticks each second
	install_int_ex(timer_handler2, BPS_TO_TIMER(30) ); //ticks each second
	install_int_ex(timer_handler3, BPS_TO_TIMER(1)  ); //ticks each second
	//mouse_callback = mouser_proc;

	reset_video();
	restartgame();
	resize_screen2(0, 0);
	//clear_to_color(screen, 58); //!!!!!

	return 1;
}

void closegame() {
	//mouse_callback = NULL;
	delete p1;
	delete p2;
	delete map;

	remove_int(timer_handler3);
	remove_int(timer_handler2);
	remove_int(timer_handler);
	net->close();
}

int print_y=0;
Wind *print_win=NULL;

void print(char *str) {
//#ifdef WIN32
	if (print_win != NULL) {
		print_win->printstr(str);
		print_win->printstr("\r\n");
	} else {
		text_mode(-1);
		textout(screen, font, str, 0, print_y, 255);
		print_y += 10;
	}
//#else
//	cprintf("%s\r\n", str);
//#endif
}


#define FADE_SPEED 20

void initmain(int argc, char *argv[]) {
	//if (argc>1) HOST=0; else HOST=1;

	memset(&mapdata, 0, sizeof(mapdata));
	if (argc>1) {
		int fh = open(argv[1], O_RDONLY | O_BINARY);
		assert( fh != -1 );
		read(fh, &mapdata, sizeof(mapdata));
		close(fh);
	} else {
		int fh = open("geodata.dat", O_RDONLY | O_BINARY);
		assert( fh != -1 );
		read(fh, &mapdata, sizeof(mapdata));
		close(fh);
	}


	srand(time(NULL));

	set_uformat(U_ASCII);
	allegro_init();

	set_window_title("UFO 2001"); //allegro proc
#ifdef WIN32
	//SetWindowText(allegro_wnd, "UFO 2001");
	HICON hi = LoadIcon(allegro_inst, MAKEINTRESOURCE(IDI_ICON));
	SetClassLong(allegro_wnd, GCL_HICON, (LPARAM)hi);
#endif

	set_video_mode();
	set_palette(black_palette);
	PALETTE pal;
	BITMAP *text_back = load_bitmap("text_back.pcx", pal);
	//set_palette(pal);
	blit(text_back, screen, 0,0,0,0, text_back->w, text_back->h);
	fade_in(pal, FADE_SPEED);
	//destroy_bitmap(text_back);
	print_win = new Wind(text_back, 15, 300, 625, 390, 255);
	print("allegro_init");

	print("loadini");
	loadini();
	print("install_timer");
	install_timer();
	print("install_mouse");
	install_mouse();
	print("install_keyboard");
	install_keyboard();
	print("initsound");
	initsound();
	print("initvideo");
	initvideo();
	print("initmainmenu");
	initmainmenu();

	LOCK_VARIABLE(CHANGE); LOCK_FUNCTION(mouser_proc);
	LOCK_VARIABLE(MOVEIT); LOCK_FUNCTION(timer_handler);
	LOCK_VARIABLE(FLYIT);  LOCK_FUNCTION(timer_handler2);
	LOCK_VARIABLE(NOTICE); LOCK_FUNCTION(timer_handler3);
   LOCK_FUNCTION(keyboard_proc);

	print("initpck units");
	Soldier::initpck();
	print("initpck terrain");
	Map::initpck();
	print("init obdata");
	Item::initobdata();
	print("init bigobs");
	Item::initbigobs();

	print("init logo");
	PALETTE ppp;
	logo = load_bitmap("logo.pcx", ppp);
	//info_background = load_bitmap("background.pcx", ppp);
	info_background = create_bitmap(640,400); clear(info_background);

	draw_sprite(info_background, logo, 640-logo->w, SCREEN2H);
	//blit(info_background, screen, 0,0, 0,0, 640, 400);

	print("new info");
	//info = new Wind(info_background, 0, SCREEN2H, 640, 390, 1, " Messages ");
	info = new Wind(info_background, 5, SCREEN2H+5, 630, 390-5, 1);
	//info = new Wind(0, 0, 79, 23, " Messages ", 0x07, 1);
	//info = new Wind(0, 0, 79, (400-SCREEN2H)/8-2, " Messages ", 0x07, 1);
	print("new icon");
	icon = new Icon((SCREEN2W-320)/2, SCREEN2H-56);
	print("new inventory");
	inventory = new Inventory();
	print("new about");
	about = new About();
	print("new editor");
	editor = new Editor();
	print("new net");
	net = new Net();

	mouse_callback = mouser_proc;
	//keyboard_callback = keyboard_proc;

//#ifdef WIN32
	//readkey();
	fade_out(FADE_SPEED);
	clear(screen);
//#endif
}

#ifdef DJGPP
#include <lsck/copyrite.h>
#endif

#ifdef USE_JGMOD
#include <jgmod.h>
#endif

void closemain() {
	saveini();
	destroy_bitmap(logo);
	destroy_bitmap(info_background);
/*	for(int i=0;i<obdata_num;i++) {
		delete []obdata[i];
	}
	delete []obdata;*/
	//closenet();
	//closesound();
	delete (net);
/*#ifdef WIN32
	set_gfx_mode(GFX_DIRECTX_WIN, 320, 200, 0, 0);
	readkey();
#endif*/
	allegro_exit();
	printf("\nUFO 2000 remake\nCopyright Sanami  (C) %s %s\n%s version\n\n",__TIME__,__DATE__,UFO_VERSION_STRING);
#ifdef DJGPP
	printf("DJGPP 2.03, ");
#endif
	printf("Allegro %s", ALLEGRO_VERSION_STR);
#ifdef USE_JGMOD
	printf(", JGMOD %s", JGMOD_VERSION_STR);
#endif
#ifdef USE_LIBINI
	printf(", LibINI 1.1");
#endif
#ifdef DJGPP
	printf(", COMLib 1.0");
	printf(", Jonipx");
	printf("\n%s", __lsck_get_version());
#endif

	printf("\n\nYakutsk nightware");

	printf("\n\nhttp://sourceforge.net/projects/ufo2000/");
	printf("\nhttp://pages.ykt.ru/ufo2000/");
	exit(0);
}

int build_crc() {
	char buf[200000]; memset(buf, 0, sizeof(buf));
	int buf_size = 0;

	p1->eot_save(buf, buf_size);
	p2->eot_save(buf, buf_size);
	map->eot_save(buf, buf_size);

	int fh = open("eot_save.txt", O_CREAT|O_TRUNC|O_RDWR|O_BINARY, S_IRUSR|S_IWUSR);
	assert( fh != -1 );
	buf_size = write(fh, buf, buf_size);
	close(fh);

	return crc16(buf);
	//return 2000;
}


extern int RECALC_VISIBILITY;

void next_turn(int crc) {
	CONFIRM_REQUESTED = 0;
	int bcrc;
	if (crc != -1) {
		//!!!compare for remote crc
		bcrc = build_crc();
		if (crc != bcrc) {
			info->printstr("wrong wholeCRC\n");
			char str[100];
			sprintf(str, "crc=%d, bcrc=%d\n", crc, bcrc);
			info->printstr(str);
		}
	}

	turn++;

	if (MODE == WATCH)
		MODE=MAP3D;
	else
		MODE=WATCH;

	if (net->gametype == HOTSEAT) {
		icon->show_eot();
		info->redraw_full();

		Platoon *pt = platoon_local;
		platoon_local = platoon_remote;
		platoon_remote = pt;

		sel_man = platoon_local->captain();
		if (sel_man!=NULL)
			map->center(sel_man);
		map->clearseen();
		MODE=MAP3D;
		RECALC_VISIBILITY = 1; // !!!!!!!!!!!!!!!!!
	}

	if (crc == -1) {
		//!!!build map&man crc
		bcrc = build_crc();
		net->send_endturn(bcrc);
	}

	if (turn%2 == 0) {
		map->step(); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		platoon_local->restore();
		platoon_remote->restore();
	}

	elist.step(crc);
	char str[100];
	sprintf(str, "Next turn. local = %d, remote = %d soldiers\n",
			  platoon_local->num_of_men(), platoon_remote->num_of_men());
	info->printstr(str, 192);
}

int GAMELOOP = 0;

void gameloop() {
	char sendbuf[1000];
	int sendbuf_len=0;
	int mouse_leftr=1, mouse_rightr=1, select_y=0;

	clear_keybuf();
	GAMELOOP = 1;
   RECALC_VISIBILITY = 1;

	while(!DONE) {
		net->check();
		if (REDRAW) {
			info->redraw_full();
			REDRAW = 0;
		}

		if (NOTICE) {
			if (NOTICEdemon) {
				net->send_notice();
				char str[10];
				sprintf(str, "%d", NOTICEremote);
				info->writestr(0, 10, str);
			}
			NOTICEremote++;
			NOTICE=0;
		}

		if (FLYIT) {
			platoon_local->bullmove();//!!!! bull of dead?
			platoon_remote->bullmove();

			FLYIT=0;
		}

		if (MOVEIT) {
			//map->clearvis();
			if (FLAGS & F_CLEARSEEN)
				map->clearseen();

			map->smoker();
			platoon_remote->move(0);
			platoon_local->move(1); //!!sel_man may die

			select_y=(select_y+1)%3;
			CHANGE=1;
			MOVEIT=0;
		}

		if (CHANGE) { //////////////////////////build screen
			CHANGE=0;
			clear_to_color(screen2, BACKCOLOR);

			switch (MODE) {
				 case UNIT_INFO:
						if (sel_man != NULL)
							sel_man->draw_unibord(SCREEN2W/2 - 160, SCREEN2H/2 - 100);
						else
							MODE = MAP3D;
						break;
				 case MAP2D:
						map->draw2d();
						break;
				 case WATCH:///////////////////////////////////////////////
				 case MAP3D:
						map->set_sel(mouse_x, mouse_y);
						map->draw();

						if (key[KEY_LCONTROL]) {// && (FLAGS & F_SHOWROUTE)) {
							if (sel_man != NULL) {
								if (!sel_man->ismoving()) {
									if (TARGET)
										sel_man->draw_bullet_way();
									else
										map->draw_path_from(sel_man);
								}
							}
						}

						p1->bulldraw();
						p2->bulldraw();

						//map->drawline(sel_man->z, sel_man->x, sel_man->y,
						//				map->sel_lev, map->sel_col, map->sel_row);

						if (sel_man != NULL)
							sel_man->draw_selector(select_y);

						icon->draw();

						if (sel_man!=NULL)
							sel_man->draw_enemy_seen();

						if (MODE==WATCH)
							textprintf(screen2, font, 0, 0, 1, "%s", "WATCH");
						break;
				 case MAN:
						if (sel_man!=NULL)
							inventory->draw();
						else {
							MODE = MAP3D;
							//map->cell[map->sel_col][map->sel_row].place.put(icon->sel_item);
							//icon->sel_item = NULL;
						}
						break;
			}
			draw_sprite(screen2, mouser, mouse_x, mouse_y);

			blit(screen2, screen, 0,0, 0,0, screen2->w, screen2->h);
			//stretch_blit(screen2, screen, 0,0, 320, 200, 0,0, 640,400);
			//map->svga2d(350, 50);
			map->svga2d();

			if (FLAGS & F_SHOWLOFCELL) {
				map->show_lof_cell();
			}
		}

		if ((MODE==MAP3D)||(MODE==WATCH)) {
			if (map->scroll(mouse_x, mouse_y))
				CHANGE=1;
			/*if (mouse_x==0)	{map->move( MSCROLL, 0); CHANGE=1;}
			if (mouse_x>=319) {map->move(-MSCROLL, 0); CHANGE=1;}
			if (mouse_y==0)	{map->move( 0, MSCROLL); CHANGE=1;}
			if (mouse_y>=199) {map->move( 0,-MSCROLL); CHANGE=1;}*/
		}

		if ((mouse_b & 1)&&(mouse_leftr)) { //left
			mouse_leftr=0;
			switch (MODE) {
				 case UNIT_INFO:
						MODE = MAP3D;
						break;
				 case WATCH:
						break;
				 case MAP2D:
						if (map->center2d(mouse_x, mouse_y))
							MODE = MAP3D;
						break;
				 case MAP3D:
						if (sel_man!=NULL) {
							if (sel_man->center_enemy_seen())
								break;
						}

						if (TARGET) {
							if ( icon->inside(mouse_x, mouse_y) ) {
								//TARGET=0;
								icon->execute(mouse_x, mouse_y);
								break;
							}

							if (sel_man!=NULL)
								sel_man->try_shoot();
						} else
							if ( !icon->inside(mouse_x, mouse_y) ) {
								if (sel_man!=NULL) {
									Soldier *ssman = map->sel_man();
									if (ssman == NULL) {
										if (!sel_man->ismoving()) {
											sel_man->wayto(map->sel_lev, map->sel_col, map->sel_row);
										}
									} else {
										if (!platoon_local->belong(ssman)) {
											if (!sel_man->ismoving()) {
												sel_man->wayto(map->sel_lev, map->sel_col, map->sel_row);
											}
										}

										if (!sel_man->ismoving()) {
											if (platoon_local->belong(ssman))
												sel_man = ssman;
										}
										if (FLAGS & F_SEL_ANY_MAN)
											sel_man = ssman;
									}
								} else {
									Soldier *ss = map->sel_man();
									if ((ss!=NULL)&&(platoon_local->belong(ss)))
										sel_man = ss;
										//net_send("_sel_man");
									if (FLAGS & F_SEL_ANY_MAN) {
										if (ss!=NULL)
											sel_man = ss;
									}
								}
							} else {
								icon->execute(mouse_x, mouse_y);
							}
						break;
				 case MAN:
						inventory->execute();
						break;
			}
		}

		if ((mouse_b & 2)&&(mouse_rightr)) { //right
			mouse_rightr=0;
			switch (MODE) {
				 case UNIT_INFO:
						MODE = MAP3D;
						break;
				 case WATCH:
						break;
				 case MAP2D:
						map->center2d(mouse_x, mouse_y);
						MODE = MAP3D;
						break;
				 case MAP3D:
						if (TARGET)
							TARGET=0;
						else {
							if (sel_man != NULL) {
								if (!sel_man->ismoving()) {
									sel_man->faceto(map->sel_col, map->sel_row);
							   
									//if (sel_man->curway == -1)
									//	sel_man->open_door();
									if (!sel_man->ismoving())
										sel_man->open_door();
								} else if (sel_man->is_marching()) {
									//sel_man->finish_march();
                           sel_man->break_march();
                           //sel_man->waylen = sel_man->curway - 1;
								}
							}
						}
						break;
				 case MAN:
						inventory->close();
						break;
			}
		}

		if (!(mouse_b & 1)) {
			mouse_leftr=1;
			CHANGE=1;
		}

		if (!(mouse_b & 2)) {
			mouse_rightr=1;
			CHANGE=1;
		}

		if (USERUSKEY) {
			if (key[KEY_RCONTROL])
				keyswitch();
			if (!key[KEY_RCONTROL])
				crel = 1;
		}

		if (keypressed()) {
			int c = readkey();

			if (c == KEY_X << 8) {
				//DONE=1;
				closemain();
			}

			switch (c >> 8) {
				case KEY_PGUP:
					  if (map->sel_lev < map->level - 1) {
						  map->sel_lev++;
						  //mouse_y -= 24;
						  position_mouse(mouse_x, mouse_y-24);
					  }
					  break;
				case KEY_PGDN:
					  if (map->sel_lev > 0) {
						  map->sel_lev--;
						  //mouse_y += 24;
						  position_mouse(mouse_x, mouse_y+24);
					  }
					  break;
				case KEY_PLUS_PAD:
					  resize_screen2(10,10);
					  break;
				case KEY_MINUS_PAD:
					  resize_screen2(-10,-10);
					  break;
				case KEY_LEFT:
					  resize_screen2(-10,0);
					  //map->move(MSCROLL*2,0);
					  break;
				case KEY_UP:
					  resize_screen2(0,-10);
					  //map->move(0,MSCROLL*2);
					  break;
				case KEY_RIGHT:
					  resize_screen2(10,0);
					  //map->move(-MSCROLL*2,0);
					  break;
				case KEY_DOWN:
					  resize_screen2(0,10);
					  //map->move(0,-MSCROLL*2);
					  break;
				case KEY_F1:
					  if (FLAGS & F_RAWMESSAGES) {
						  FLAGS &= ~F_RAWMESSAGES;
					  } else {
							FLAGS |= F_RAWMESSAGES;
					  }
					  break;
				/*case KEY_F2: ////////////need nomove check
					  if (askmenu("SAVE GAME")) {
						  build_crc();
						  //p1->save("p1.sav");
						  //p2->save("p2.sav");
						  //map->save("map.sav");
						  position_mouse(160, 100);
					  }
					  break;*/
				/*case KEY_F3: ////////////need nomove check
					  if (askmenu("LOAD GAME")) {
						  //map->load("map.sav");
						  //p1->load("p1.sav");
						  //p2->load("p2.sav");
						  if ((HOST)&&(turn%2==0))
							  MODE=MAP3D;
						  else
							  MODE=WATCH;
						  position_mouse(160, 100);
						  sel_man = platoon_local->captain();
					  }
					  break;*/
				case KEY_F4:
					  info->redraw_full();
					  break;
				case KEY_F5:
					  if (askmenu("RESTART GAME")) {
						  //restartgame();
						  net->send_restart();
						  //position_mouse(160, 100);
					  }
					  break;
				/*case KEY_F6:
					  //if (askmenu("CONFIRM RESTART GAME")) {
						  net->send_restart(1);
						  //position_mouse(160, 100);
					  //}
					  break;*/
				case KEY_F9:
					  if (FLAGS & F_SEL_ANY_MAN) {
						  if (MODE == WATCH)
							  MODE = MAP3D;
						  else
							  MODE = WATCH;
					  }
					  break;
				case KEY_F10:
					  change_screen_mode();
					  break;
				case KEY_F11:
					  if (NOTICEdemon) {
						  if (askmenu("STOP NOTIFY"))
							  NOTICEdemon = 0;
					  } else {
						  if (askmenu("START NOTIFY")) {
							  NOTICEdemon = 1;
							  NOTICEremote = 0;
						  }
					  }
					  break;
				case KEY_F12:
					  if (askmenu("SNAPSHOT")) {
						  savescreen();
					  }
					  break;
				case KEY_ESC:
					  if (askmenu("EXIT GAME"))
						  DONE = 1;
					  break;
				/*case KEY_TAB:
					  blit(screen_text, screen, 0,0, 0,0, screen_text->w, screen_text->h);
					  break;*/
				/*case KEY_F6:
					  if (askmenu("LOAD LOG FOR REPLAY"))
						  net->replay_load("ufo2000replay.log");
					  break;*/
				/*case KEY_SPACE:
					  net->replay();
					  break;*/
				case KEY_BACKSPACE:
					  if (sendbuf_len > 0) {
						  sendbuf[--sendbuf_len] = 0;
						  if (sendbuf_len<0) {
							  sendbuf_len=0;
							  sendbuf[0]=0;
						  }
						  rectfill(screen, 0, 392, 640, 400, 0);
						  textprintf(screen, font, 0, 392, 1, "%s", sendbuf);
						  /*text_mode(0);
						  for (int i=0; i<sendbuf_len; i++)
							  textprintf(screen, font, i*8, 392, 1, "%c", sendbuf[i]);*/
					  }
					  break;
				case KEY_ENTER:
					  if (sendbuf_len > 0) {
						  //if (FLAGS & F_RAWMESSAGES == 0) {
							  info->printstr(sendbuf, 48);
							  info->printchr('\n');
						  //}
						  net->send_message(sendbuf);
						  sendbuf_len = 0;
						  rectfill(screen, 0, 392, 640, 400, 0);
					  }
					  break;
				default:
					  c &= 0xff;
					  if (USERUSKEY)
						  c = keymaper(c);

					  if ((c >= ' ') && (sendbuf_len<78)) {
						  sendbuf[sendbuf_len++] = c;
						  sendbuf[sendbuf_len] = 0;
						  textprintf(screen, font, 0, 392, 1, "%s", sendbuf); //unishit
						  /*text_mode(0);
						  for (int i=0; i<sendbuf_len; i++)
							  textprintf(screen, font, i*8, 392, 1, "%c", sendbuf[i]);*/
					  }
			}
			CHANGE=1;
		}
	}
	GAMELOOP = 0;
	net->send_quit();

	fade_out(10);
	//readkey();
	clear(screen);
}

void faststart() {
	HOST = sethotseatplay();

	//initgame();
	install_int_ex(timer_handler,  BPS_TO_TIMER(15) ); //ticks each second
	install_int_ex(timer_handler2, BPS_TO_TIMER(30) ); //ticks each second
	install_int_ex(timer_handler3, BPS_TO_TIMER(1)  ); //ticks each second

	reset_video();

	//restartgame();

	int fh = open("cur_map.dat", O_RDONLY|O_BINARY);
	assert( fh != -1 );
	read(fh, &mapdata, sizeof(mapdata));
	close(fh);

	fh = open("cur_p1.dat", O_RDONLY|O_BINARY);
	assert( fh != -1 );
	read(fh, &pd1, sizeof(pd1));
	close(fh);

	fh = open("cur_p2.dat", O_RDONLY|O_BINARY);
	assert( fh != -1 );
	read(fh, &pd2, sizeof(pd2));
	close(fh);

	map = new Map();
	p1 = new Platoon(1111, &pd1);
	p2 = new Platoon(2222, &pd2);

	//map->place(0, 0, 0)->put(new Item(KASTET));
	//map->place(0, 0, 0)->put(new Item(KNIFE));

	elist.reset();
	if (HOST) {
		platoon_local = p1;
		platoon_remote = p2;
		MODE = MAP3D;
	} else {
		platoon_local = p2;
		platoon_remote = p1;
		MODE = WATCH;
	}

	sel_man = platoon_local->captain();
	map->center(sel_man);
	DONE=0; TARGET=0; turn=0;

	resize_screen2(0, 0);
	clear_to_color(screen, 58); //!!!!!
	gameloop();
	closegame();
	closemain();
}

/*


LRESULT CALLBACK Abo(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message) {
		case WM_INITDIALOG:
			return (TRUE);

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
				EndDialog(hDlg, TRUE);
				return (TRUE);
			}
			break;
	}

	return FALSE;
}

*/



int main(int argc, char *argv[]) {
	FLAGS = 0;
	//FLAGS |= F_CLEARSEEN; //clear seen every time
	//FLAGS |= F_SHOWROUTE; //show pathfinder matrix
	//FLAGS |= F_SHOWLOFCELL; //show cell's LOF & BOF
	//FLAGS |= F_SHOWLEVELS; //show all level
	//FLAGS |= F_FASTSTART;  //skip
	FLAGS |= F_FULLSCREEN; //start fullscreen mode
	//FLAGS |= F_RAWMESSAGES; //show raw net packets
	//FLAGS |= F_SEL_ANY_MAN; //allow select any man
	FLAGS |= F_SWITCHVIDEO; //allow switch full/window screen mode
	//FLAGS |= F_PLANNERDBG; //mission planner debug mode
	//FLAGS |= F_ENDLESS_TU; //endless soldier's time units

#ifdef __BEOS__
int counti;
char datapath[256];
for (counti=strlen(argv[0]) ; argv[0][counti]!='/' ; counti--);
strncpy(datapath, argv[0], counti);
chdir(datapath);
#endif

	initmain(argc, argv);

	if (FLAGS & F_FASTSTART) {
		faststart();
	}

	int mm=2, h = -1;
	//0 quit 1 about 2 edit 3 hot 4 mdm 5 tcp/ip 6 ipx
	while ( (mm=do_mainmenu())!=0 ) {
		h = -1;
		switch(mm) {
			case 1:
				  about->show();
				  continue;
			case 2:
				  //editor->show(1);
              editor->do_mapedit();
				  continue;
			case 3:
				  h = sethotseatplay();
				  break;
			case 4:
#ifdef WIN32
				  h = setdplayplay();
				  //h = setsocketplay();
#else
				  h = setsocketplay();
#endif
				  break;
			case 5:
				  h = setnetplay();
				  break;
			case 6:
				  h = setmodemplay();
				  break;
			default:
				  continue;
		}
		if (h == -1) continue;
		HOST = h;

		if (initgame()) {
			gameloop();
			closegame();
		}
	}

	closemain();
	return 0;
}
END_OF_MAIN();
