/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifdef WIN32
char HOSTNAME[256] = "10.0.0.2";
char PORT[256] = "2000";

int initsocketgame() {return 0;}
void closesocketgame() {}
int packet_recv_socket(char *pkt) {return 0;}
void packet_send_socket(char *pkt) {}
void packet_send_socket(char *pkt, int size) {}

#else


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#ifdef DJGPP
#include <lsck/lsck.h>
#endif
#include "ldw.h"
#include "wind.h"
#include "netsock.h"
#ifdef WIN32
#include <winsock2.h>
#define EWOULDBLOCK   WSAEWOULDBLOCK
#define SHUT_RDWR     SD_BOTH 
#else
#include <unistd.h>
//#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#endif


extern Wind *info_win;
//extern int SEND;
extern int HOST;

struct sockaddr_in in, peer_in;
//char HOSTNAME[256] = "127.0.0.1";
char HOSTNAME[256] = "10.0.0.2";
char PORT[256] = "2000";

#ifdef WIN32
static WSADATA wsaData;
static SOCKET sock, hostsock;
#else
static int sock, hostsock;
#endif

int initsocketgame() {
#ifdef WIN32
	if (WSAStartup(MAKEWORD(1,1),&wsaData) == SOCKET_ERROR) {
		info_win->printstr("can't start winsock\n");
		//WSACleanup();
		return 0;
	}
#endif
	if (HOST) {
		//printf ("Enter port number: ");
		//gets (PORT);
		memset (&in, 0, sizeof(struct sockaddr_in));
		hostsock = socket(AF_INET, SOCK_STREAM, 0);
		if (hostsock > 0) {
			info_win->printstr("socket created\n");
		} else {
			info_win->printstr("can't create socket\n");
			return 0;
		}

		in.sin_family = AF_INET;
		in.sin_addr.s_addr = INADDR_ANY;
		in.sin_port = htons (atoi(PORT));
		if (bind(hostsock, (struct sockaddr *)&in, sizeof(struct sockaddr_in)) == -1) {
			info_win->printstr("can't bind\n");
			return 0;
		}
		if (listen(hostsock, 5) == -1) {
			info_win->printstr("can't listen\n");
			return 0;
		}
#ifdef WIN32
		unsigned long arg = 1234;
		ioctlsocket(hostsock, FIONBIO, &arg);
#else
		fcntl(hostsock, F_SETFL, O_NONBLOCK);
#endif
		info_win->printstr("accept");

		int oldsec=0;
		time_t ltime;
		struct tm *time_of_day;

#ifdef WIN32
		int len = sizeof(struct sockaddr_in);
#else
		int len = sizeof(struct sockaddr_in);
#endif
		while (1) {
			if (key[KEY_ESC]) {
				//readkey();
				info_win->printstr("\naccept canceled\n");
				return 0;
			}
			sock = accept(hostsock, (struct sockaddr *)&peer_in,  &len);
			if (sock == -1) {
#ifdef WIN32
				if (WSAGetLastError() == EWOULDBLOCK) {
#else
				if (errno == EWOULDBLOCK) {
#endif
					time( &ltime );
					time_of_day = localtime( &ltime);
					if (time_of_day->tm_sec != oldsec) {
						oldsec = time_of_day->tm_sec;
						info_win->printchr('.');
					}
				} else {
					info_win->printstr( strerror(errno) ); //verbose output of errno
					readkey(); //wait until key pressed
					info_win->printstr("\ncan't accept\n");
					return 0;
				}
			} else
				break;
		}
		char str[100];
		sprintf (str, "\nconnected %s\n", inet_ntoa(peer_in.sin_addr));
		info_win->printstr(str);

	} else {
		sock = socket(AF_INET, SOCK_STREAM, 0);

		if (sock > 0) {
			info_win->printstr("socket created\n");
		} else {
			info_win->printstr("can't create socket\n");
			return 0;
		}

//printf ("Enter IP address: ");
//gets (HOSTNAME);

		struct hostent *hent = gethostbyname(HOSTNAME);
		if (hent == NULL) {
			info_win->printstr("can't gethostbyname\n");
			return 0;
		}
		unsigned long int haddress = ((struct in_addr *) hent->h_addr)->s_addr;

		memset(&in, 0, sizeof(struct sockaddr_in));
		in.sin_family = AF_INET;
		in.sin_addr.s_addr = haddress;
		in.sin_port = htons(atoi(PORT));

		char str[100];
		sprintf(str, "connecting to %s\n", inet_ntoa(in.sin_addr));
		info_win->printstr(str);

		if (connect(sock, (struct sockaddr *) &in, sizeof(struct sockaddr_in)) == -1) {
			info_win->printstr("can't connect\n");
			return 0;
		}
		info_win->printstr("connected\n");
	}

#ifdef WIN32
	unsigned long arg = 1234;
	ioctlsocket(sock, FIONBIO, &arg);
#else
	fcntl(sock, F_SETFL, O_NONBLOCK);
#endif
	
	return 1;
}

void closesocketgame() {
//	shutdown(sock, SHUT_RDWR);
//	if (HOST)
	//	shutdown(hostsock, SHUT_RDWR);
	close(sock);
	if (HOST)
		close(hostsock);
#ifdef WIN32
	WSACleanup();
#endif
}

int packet_recv_socket(char *pkt) {
	//info_win->printstr("\nrecv start");
	int t = recv(sock, pkt, 1000, 0);
	//info_win->printstr("\nrecv end");

	if (t == -1) {
		if (errno == EWOULDBLOCK) {
			return 0;
		}
	}
	if (t == 0)
		return 0;
	if (t > 0) {
		pkt[t] = 0;
		//return 1;
		return t;
	}
	//SEND = 0;
	return 0;
}

void packet_send_socket(char *pkt) {
	//if (SEND) {
		if (send(sock, pkt, strlen(pkt) + 1, 0) == -1) { //send don't block?
			//if (errno != EWOULDBLOCK) {
	 //		  SEND = 0;
			//}
		}
	//}
}

void packet_send_socket(char *pkt, int size) {
	//if (SEND) {
		if (send(sock, pkt, size, 0) == -1) { //send don't block?
			//if (errno != EWOULDBLOCK) {
	 //		  SEND = 0;
			//}
		}
	//}
}

#endif
