/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include "packet.h"

/*
#define COMMAND_NUM 27

enum Command {CMD_MESSAGE=-2, CMD_NONE=-1,
				  CMD_NOTICE=0, CMD_QUITGAME, CMD_ENDTURN,			  //3
				  CMD_OPENDOOR, CMD_CHANGEPOSE, CMD_PRIMEGRENADE,	 //6
				  CMD_DETONATE_ITEM, CMD_EXPLODE,
				  CMD_UNLOAD_AMMO, CMD_LOAD_AMMO,
				  CMD_TAKE_ITEM, CMD_DROP_ITEM,
				  CMD_MOVE, CMD_FACE,										  //14
				  CMD_THROW_ITEM, CMD_BEAM_LASER, CMD_FIRE_GUN,		//17
				  CMD_ADD_UNIT, CMD_UNIT_DATA_SIZE, CMD_UNIT_DATA,	//20
				  CMD_SELECT_UNIT, CMD_DESELECT_UNIT,					 //22
				  CMD_MAP_DATA,												  //23
				  CMD_FINISH_PLANNER,										  //24
				  CMD_RESTARTGAME,											//25
				  CMD_PUNCH, CMD_AIMEDTHROW                        //27
				 };
*/
char *Packet::strCommand[COMMAND_NUM] = {
				  "NOTE", "QUIT", "TURN",
				  "DOOR", "POSE", "PRIM",
				  "DETO", "EXPL",
				  "UNLO", "LOAD",
				  "TAKE", "DROP",
				  "MOVE", "FACE",
				  "THRU", "BEAM", "FIRE",
				  "ADUN", "PDSZ", "PDAT",
				  "SEUN", "DEUN",
				  "MDAT",
				  "STRT",
				  "REST",
				  "PNCH", "AMTR"
				  /*"NOTICER", "QUITGAME", "ENDTURN",
				  "OPENDOOR", "CHANGEPOSE", "PRIME",
				  "DETONATE", "EXPLODE",
				  "UNLOAD", "LOADAMMO",
				  "TAKEITEM", "DROPITEM",
				  "MOVE", "FACE",
				  "THROW", "BEAM", "FIRE",
				  "ADDUNIT", "PDSIZE", "PDATA",
				  "SEUNIT", "DEUNIT",
				  "MAPDATA"*/
				 };


//float	-9.999999  only
//  pi	  3.1415926
Packet::Packet() {
	reset();
}

void Packet::reset() {
	cur = 0; size = 0;
	memset(data, 0, sizeof(data));
}

void Packet::str2pkt(char *str) {
	reset();
	strcpy(data, str);
	size = strlen(data);
}

void Packet::create(char *header) {
	reset();
	assert( strchr(header, '_') == NULL);
	int len = sprintf(data+size, "%s_", header);
	size += len;
}

void Packet::create(Command cmd) {
	reset();
	int len = sprintf(data+size, "_Xcom_%s_", strCommand[(int)cmd]);
	size += len;
}

Command Packet::command(char *str) {
	cur = 0;
	if (strstr(str, "_Xmes_") != NULL) {
		strcpy(data, strstr(str, "_Xmes_") + 6);
		return CMD_MESSAGE;
	}

	if (strstr(str, "_Xcom_") != NULL)
		for(int i=0; i<COMMAND_NUM; i++) {
			char *pkt = strstr(str, strCommand[i]);

			if (pkt != NULL) {
				strcpy(data, pkt + strlen(strCommand[i]) + 1);
				return (Command)i;
			}
		}
	//strcpy(data, str);
	return CMD_NONE;
}

//01234567890123
//23_Xcom_TURN_
//		  8	2
//^		 ^	^
//pkt - buf
Command Packet::command(char *buf, int buf_size) {
	memset(data, 0, sizeof(data));
	cur = 0;
	if (strstr(buf, "_Xmes_") != NULL) {
		strcpy(data, strstr(buf, "_Xmes_") + 6);
		return CMD_MESSAGE;
	}

	if (strstr(buf, "_Xcom_") != NULL)
		for(int i=0; i<COMMAND_NUM; i++) {
			//char *pkt = strstr(buf, strCommand[i]);
			char *xcom = strstr(buf, "_Xcom_");
			char *pkt = NULL;
			if (!memcmp(xcom + strlen("_Xcom_"), strCommand[i], strlen(strCommand[i])))
				pkt = strstr(buf, strCommand[i]);

			if (pkt != NULL) {
				//buf_size -= pkt + strlen(strCommand[i]) + 1 - buf;//!!!!!!!
				memcpy(data, pkt + strlen(strCommand[i]) + 1,  buf_size);
				size = buf_size;
				return (Command)i;
			}
		}
	//strcpy(data, str);
	return CMD_NONE;
}

void Packet::push(char *buf, int buf_size) {
	for(int n=0; n<buf_size; n++)
		data[size++] = buf[n];
	data[size++] = '_';
}

void Packet::pop(char *buf, int buf_size) {
	for(int n=0; n<buf_size; n++)
		buf[n] = data[cur++];
	cur++;
}

Packet& Packet::operator<<(char *i) {
	assert( strchr(i, '_') == NULL);
	//int len = sprintf(data+size, "%s_", i);
	//size += len;
	int n = 0;
	while (i[n])
		data[size++] = i[n++];
	data[size++] = '_';
	return *this;
}

Packet& Packet::operator>>(char *i) {
	int n = 0;
	while (data[cur] != '_')
		i[n++] = data[cur++];
	i[n] = 0; cur++;
	return *this;
}

Packet& Packet::operator<<(int i) {
	int len = sprintf(data+size, "%d_", i);
	size += len;
	return *this;
}

Packet& Packet::operator>>(int &i) {
	sscanf(data+cur, "%d_", &i);

	int len = 0;
	while (data[cur+len] != '_')
		len++;

	cur += len+1;
	//printf("value=%d, len=%d, cur=%d\n", i, len, cur);
	return *this;
}

Packet& Packet::operator<<(float i) {
	int len = sprintf(data+size, "%f_", i);
	size += len;
	return *this;
}

Packet& Packet::operator>>(float &i) {
	sscanf(data+cur, "%f_", &i);
	/*char *end = strchr(data+cur, '_');
	assert( end != NULL );
	int len = end - (data+cur);*/
	int len = 0;
	while (data[cur+len] != '_')
		len++;

	cur += len+1;
	//printf("value=%f, len=%d, cur=%d\n", i, len, cur);
	return *this;
}


BQ::BQ(int sz) {
	m_size = sz;
	m_beg = 0; m_end = 0;
	m_dat = new char *[m_size];
	m_dat_size = new int[m_size];
	for(int i=0; i<m_size; i++)
		m_dat[i] = NULL;
}

BQ::~BQ() {
	for(int i=0; i<m_size; i++)
		if (m_dat[i] != NULL)
			delete []m_dat[i];
	delete []m_dat_size;
}

void BQ::put(char *str) {
	m_dat[m_end++] = strdup(str);
	m_end %= m_size;
	if (m_end == m_beg) {
		delete m_dat[m_beg];
		m_dat[m_beg] = NULL;
		m_beg++;
		m_beg %= m_size;
	}
}

void BQ::put(char *buf, int buf_size) {
	m_dat[m_end] = new char[buf_size+1];
	memcpy(m_dat[m_end], buf, buf_size);
	m_dat_size[m_end] = buf_size;
	m_end++;
	m_end %= m_size;
	if (m_end == m_beg) {
		delete m_dat[m_beg];
		m_dat[m_beg] = NULL;
		m_dat_size[m_beg] = 0;
		m_beg++;
		m_beg %= m_size;
	}
}

int BQ::get(char *str) {
	if (m_beg == m_end)
		return 0;
	strcpy(str, m_dat[m_beg]);
	delete m_dat[m_beg];
	m_dat[m_beg] = NULL;
	m_dat_size[m_beg] = 0;
	m_beg++;
	m_beg %= m_size;
	return 1;
}

int BQ::get(char *buf, int &buf_size) {
	if (m_beg == m_end)
		return 0;
	buf_size = m_dat_size[m_beg];
	memcpy(buf, m_dat[m_beg], buf_size);
	buf[buf_size] = 0;
	delete m_dat[m_beg];
	m_dat[m_beg] = NULL;
	m_dat_size[m_beg] = 0;
	m_beg++;
	m_beg %= m_size;
	return 1;
}
