/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef PLATOON_H
#define PLATOON_H
#include "soldier.h"
#include "units.h"

struct PLAYERDATA {
	int size;
	MANDATA md[20];
	ITEMDATA id[20];
	int lev[20], col[20], row[20];
};

class Platoon {
private:
	Soldier *man;
	int ID;
	int size;
public:
	Platoon(int PID, int num);
	Platoon(int PID, int num, int *z, int *x, int *y);
	Platoon(int PID, int num, int *z, int *x, int *y, MANDATA *mdat, ITEMDATA *idat);
	Platoon(int PID, PLAYERDATA *pd);
	~Platoon();
	void destroy();

	void move(int ISLOCAL);
	void restore();
	void bullmove();
	void bulldraw();

	int belong(Soldier *some);
	int belong(Bullet *some);
	Soldier *findman(int SID);
	Soldier *findman(char *sname);
	Soldier *findnum(int N);
	Soldier *next_not_moved_man(Soldier *sel_man);
	Place *find_item(Item *it, int &lev, int &col, int &row);
	int check_for_hit(int z, int x, int y);
	void apply_hit(int z, int x, int y, int type);

	int nobullfly();
	int nomoves();

	int realsize();
	int freeNID();
	void del(int SID);
	//void add();
	//void create(int PID, int psize);

	inline Soldier *captain() { return man; }
	inline int num_of_men() { return size; }

	void save_MANDATA(char *fn);
	void load_MANDATA(char *fn);
	void save_ITEMDATA(char *fn);
	void load_ITEMDATA(char *fn);
	void save_FULLDATA(char *fn);
	void load_FULLDATA(char *fn);

	void build_Units(Units &local);
	void send_Units(Units &local);

	int eot_save(char *buf, int &buf_size);
};

#endif
