/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "ldw.h"
#include "video.h"
#include "spk.h"

SPK::SPK() {
	m_dat = NULL;
	m_datlen = 0;
};

SPK::SPK(char *pckfname) {
	m_dat = NULL;
	m_datlen = 0;

	load(pckfname);
}

SPK::~SPK() {
	if (m_dat != NULL)
		delete []m_dat;
}

void SPK::load(char *fname) {
	int fh = open(fname, O_RDONLY | O_BINARY);
	assert( fh != -1 );
	m_datlen = filelength(fh);
	//m_datlen = 0xFFFF;//lseek(fh, 0, SEEK_END);
	m_dat = new unsigned char[m_datlen];
	m_datlen = read(fh, m_dat, m_datlen);
	close(fh);
	//printf("\n%s %d %d", fname, fh, m_datlen); fflush(NULL);
	//readkey();
}

void SPK::show(BITMAP *_dest, int _x, int _y) {
	//textprintf(_dest, font, 0, 100, 1, "%d", m_datlen);
	//readkey();

	BITMAP *bmp = create_bitmap(320, 200);
	clear(bmp);
	short header[4];
	int j = 0;

	for(int i=0; i<m_datlen; i++) {
		unsigned char a = m_dat[i];

		if (a == 0xff) {
			memcpy(header, m_dat+i, 8);
			i+=7;
			j = j + header[1] * 2;
		} else {
			spr_set(bmp, j++, a);
		}

		if (j >= 64000) break;
	}
	draw_sprite(_dest, bmp, _x, _y);
	destroy_bitmap(bmp);
}

void SPK::show_strech(BITMAP *_dest, int _x, int _y, int _w, int _h) {
	BITMAP *bmp = create_bitmap(320, 200);
	clear(bmp);
	short header[4];
	int j = 0;

	for(int i=0; i<m_datlen; i++) {
		unsigned char a = m_dat[i];

		if (a == 0xff) {
			memcpy(header, m_dat+i, 8);
			i+=7;
			j = j + header[1] * 2;
		} else {
			spr_set(bmp, j++, a);
		}

		if (j >= 64000) break;
	}
	//stretch_blit(bmp, _dest, 0,0, 320,200, 0,0, _dest->w, _dest->h);
	stretch_blit(bmp, _dest, 0,0, 320,200, 0,0, _w, _h);
	destroy_bitmap(bmp);
}

void SPK::show_pck(BITMAP *_dest, int _x, int _y) {
	BITMAP *bmp = create_bitmap(320, 200);
	clear(bmp);
	short header[4];
	int j = 0;

	for(int i=4; i<m_datlen; i++) {
		unsigned char a = m_dat[i];

		if (a == 0xff) {
			memcpy(header, m_dat+i, 8);
			i+=7;
			j = j + header[1] * 2;
		} else {
			spr_set(bmp, j++, a);
		}

		if (j >= 64000) break;
	}
	draw_sprite(_dest, bmp, _x, _y);
	destroy_bitmap(bmp);
}
