/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef VIDEO_H
#define VIDEO_H
#include <allegro.h>
#ifdef WIN32
#include <winalleg.h>
#endif
#include "font.h"

extern BITMAP *screen2;
extern int SCREEN2W, SCREEN2H;
extern BITMAP *screen_text;
extern BITMAP *mouser, *selector;

extern int REDRAW;
extern volatile int DRAWIT;
extern void drawit_timer();

void initvideo();
void change_screen_mode();
void set_video_mode();
void reset_video();
void initpal(char *fname);
void setpal(RGB pal[PAL_SIZE], int pofs);

inline void spr_set(BITMAP *dest, int ofs, char val) {
	*((char *)dest->dat+ofs) = val;
}

inline int spr_get(BITMAP *dest, int ofs) {
	return *((char *)dest->dat+ofs);
}

inline int mouse_inside(int x1, int y1, int x2, int y2) {
	return ((mouse_x>=x1)&&(mouse_x<=x2) && (mouse_y>=y1)&&(mouse_y<=y2));
}

void savescreen();
void resize_screen2(int vw, int vh);
int askmenu(char *mess);

unsigned short crc16(char *data_p);

extern unsigned long FLAGS;
#define F_CLEARSEEN       0x0001
#define F_SHOWROUTE       0x0002
#define F_SHOWLOFCELL     0x0004
#define F_SHOWLEVELS      0x0008
#define F_FASTSTART       0x0010
#define F_FULLSCREEN      0x0020
#define F_RAWMESSAGES     0x0040
#define F_SEL_ANY_MAN     0x0080
#define F_SWITCHVIDEO     0x0100
#define F_PLANNERDBG      0x0200
#define F_ENDLESS_TU      0x0400

#endif
