/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: All game drawing functions
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
//#include "tmake.h"
#include "draw.h"
#include "level.h"
#include "shrap.h"
#include "play.h"
#include "unpack.h"
#include "circ.h"

void drawScreen()
{
  register int y;
  int sprFlash=0,x,z,x2,y2,x3,y3;
  float sc;
  static int drawFlicker=0;
  #ifdef xop_debug
  char text[64];
  #endif

  drawFlicker++;

  clear(buffer);

  // set background scroll position

  bgPosX=(player.x+16)/3.33;

  if(bgPosX<0)
    bgPosX=0;
  if(bgPosX>120)
    bgPosX=120;

  // draw things, backgrounds, player

  for(x=0; x<tCount; x++)
  {
    y=oSort[x].num;

    if(y>=maxthing) // special for non-things (player, bg, shrapnel)
    {
      if(y==600)
      {
        if(player.stat!=-1)
          drawPlayer();
      }

      if(y==700)
        drawShrapnel(0);

      if(y==701)
        drawShrapnel(1);

      for(z=0; z<bgCount; z++)
      {
        if(y==800+z)
        {
          if(bg[z].e[0].effect==0)
            drawBackground(z,buffer);
          else
            drawBgEffect(z,buffer);

          drawShadows(z);
        }
      }

      goto skip;
    }

    thingDefP=thingDef+thing[y].type;

    if(thing[y].sprite==888 || sprMain[thing[y].sprite]==NULL)
      goto skip;

    if(thingDefP->com[THINGDEF_FLICKER]==1 && drawFlicker%2==0)
      goto skip;

    if(thing[y].flash==1)
    {
      if(sprMain[thing[y].sprite+maxsprite2]!=NULL && thing[y].sprite+maxsprite2<maxsprite)
      {
        thing[y].sprite+=maxsprite2;
        sprFlash=1;
      }
    }

    for(z=0; z<maxtcirc; z++) // circles below thing
      if(thing[y].circ[z]!=-1 && circ[thing[y].circ[z]].pos==0)
        drawCircle(y,z);

    // draw the thing

    if(thingDefP->com[THINGDEF_TRANS]==1) // transparent sprite
    {
      draw_trans_sprite(buffer,sprMain[thing[y].sprite],
      calctX(thing[y].x+thing[y].offX,thing[y].z)-bgPosX,
      calctY(thing[y].y+thing[y].offY,thing[y].z));
      goto skipTrans;
    }

    if(thing[y].z==0 && thing[y].zScale==0) // thing doesn't need any scaling
    {
      if(thing[y].rot==0 && thing[y].sprRot==0) // no rotation, no z scaling
        draw_sprite(buffer,sprMain[thing[y].sprite],(thing[y].x+thing[y].offX)-bgPosX,thing[y].y+thing[y].offY);
      else // rotation, no z scaling
      {
        if(thingDefP->com[THINGDEF_ROTCENTX]==0 && thingDefP->com[THINGDEF_ROTCENTY]==0)
        {
          if(thing[y].rot==64)
            draw_sprite_h_flip(buffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
          else if(thing[y].rot==128)
            draw_sprite_v_flip(buffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
          else if(thing[y].rot==192)
            draw_sprite_vh_flip(buffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
          else
            rotate_sprite(buffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY,ftofix(thing[y].rot)); // rotated sprite
        }
        else
          pivot_sprite(buffer,sprMain[thing[y].sprite],
                       thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY,
                       thingDefP->com[THINGDEF_ROTCENTX],thingDefP->com[THINGDEF_ROTCENTY],ftofix(thing[y].rot)); // pivoted sprite
      }
    }
    else if(thing[x].z>zdepth0 && thing[x].z<zdepth) // thing needs to be scaled to z
    {
      x2=calctX(thing[y].x+thing[y].offX,thing[y].z)-bgPosX; // x pos
      y2=calctY(thing[y].y+thing[y].offY,thing[y].z); // y pos

      if(thing[y].rot==0 && thing[y].sprRot==0) // no rotation, z scaling
      {
        x3=thing[y].zScale+calctX(thing[y].x+thing[y].offX+sprMain[thing[y].sprite]->w,thing[y].z)-bgPosX; // x pos + sprite size
        y3=thing[y].zScale+calctY(thing[y].y+thing[y].offY+sprMain[thing[y].sprite]->h,thing[y].z); // y pos + sprite size

        stretch_sprite(buffer,sprMain[thing[y].sprite],x2,y2,x3-x2,y3-y2);
      }
      else // rotation, z scaling
      {
        // sc=calctXF(sprMain[thing[y].sprite]->w,thing[y].z*-1)/(float)sprMain[thing[y].sprite]->w;
        //sc+=calctYF(sprMain[thing[y].sprite]->h,thing[y].z*-1)/(float)sprMain[thing[y].sprite]->h;
        //sc/=2;

         sc=(float)(thing[y].zScale+sprMain[thing[y].sprite]->w)/((zdepth*sprMain[thing[y].sprite]->w)/(zdepth+thing[y].z));
        sc+=(float)(thing[y].zScale+sprMain[thing[y].sprite]->h)/((zdepth*sprMain[thing[y].sprite]->h)/(zdepth+thing[y].z));
        sc/=1.94;

        if(sc<0)
          sc=0;

        if(thingDefP->com[THINGDEF_ROTCENTX]==0 && thingDefP->com[THINGDEF_ROTCENTY]==0) // rotated and scaled sprite (ack)
        {
          rotate_scaled_sprite(buffer,sprMain[thing[y].sprite],x2,y2,ftofix(thing[y].rot),ftofix(sc));
        }
        else
        {
          pivot_scaled_sprite(buffer,sprMain[thing[y].sprite],x2,y2,
                         thingDefP->com[THINGDEF_ROTCENTX],thingDefP->com[THINGDEF_ROTCENTY],
                         ftofix(thing[y].rot),ftofix(sc));
        }
      }
    }

    skipTrans:

    if(sprFlash==1)
    {
      thing[y].sprite-=maxsprite2;
      sprFlash=0;
    }

    for(z=0; z<maxtcirc; z++) // circles above thing
      if(thing[y].circ[z]!=-1 && circ[thing[y].circ[z]].pos==1)
        drawCircle(y,z);

    if(showRects==1)
    {
      rect(buffer,calctX(thing[y].x+thing[y].hrX1,thing[y].z)-bgPosX,
                  calctY(thing[y].y+thing[y].hrY1,thing[y].z),
                  calctX(thing[y].x+thing[y].hrX2,thing[y].z)-bgPosX,
                  calctY(thing[y].y+thing[y].hrY2,thing[y].z),colMagenta);
    }

    #ifdef xop_debug
    /*if(thing[y].type==play.dalType)
    {
      sprintf(text,"%f %f",thing[y].sy,thing[y].slimit);
      drawText(buffer,text,calctX(thing[y].x+thing[y].hrX2,thing[y].z)-bgPosX,calctY(thing[y].y+thing[y].hrY2,thing[y].z),0);
    }*/
    #endif

    skip:;
  }

  // draw thing shield display

  if(showShield!=-1)
  {
    if(thing[showShield].shield>0 && thing[showShield].stat!=-1 && thing[showShield].stat!=1)
    {
      sc=thing[showShield].shield*(128/thing[showShield].sMax);

      rectfill(buffer,1,292,129,296,colBlack);
      rectfill(buffer,1,292,1+(int)sc,296,colLightGray);
      rect(buffer,1,292,129,296,colWhite);
    }
    else
      showShield=-1; // if the thing had died at some point, disable the shield display
  }

  // draw continue stuff

  if(player.dir==-1)
  {
    blit(sprPlay[12],buffer,0,0,60,120,160,32);

    rectfill(buffer,42,155,238,167,0);
    rect(buffer,    43,156,237,166,colWhite);

    if(gOpt.skillMode==5)
      drawText(buffer,"Your crotch has been bruitalized!",9,157,0);
    else if(gOpt.skillMode==6)
      drawText(buffer,"ALL YOUR XOP ARE BELONG TO US!",21,157,0);
    else
      drawText(buffer,"Press ENTER to continue!",45,157,0);
  }

  // draw begin simulation intro

  if(introCount>-260)
  {
    if(gStat==0)
      drawTransform(3,introCount); // begin level
    if(gStat==1)
      drawTransform(4,introCount); // end level
    if(gStat==2)
      drawTransform(5,introCount); // warning
  }

  // draw game over sign

  if(player.dir<=-2)
    draw_sprite(buffer,sprPlay[7],60,120);

  // draw pause

  if(pauseStat==1 && player.dir!=-1)
    draw_sprite(buffer,sprPlay[9],60,120);

  // calculate quake stuff

  if(quakeAmt>0)
  {
    x2=(rand()%quakeAmt)-(quakeAmt*2);
    y2=(rand()%quakeAmt)-(quakeAmt*2);
  }
  else
  {
    x2=0; y2=0;
  }

  // splat it on da screen

  acquire_bitmap(screen);

  blit(buffer,screen,0+x2,0+y2,sXoff,sYoff,280,300);

  #ifdef xop_debug
  redrawStatus=1;
  #endif
  if(redrawStatus==1)
  {
    drawStatus();
    blit(bufStat,screen,0,0,sXoff+1,sYoff-19,278,18);
    redrawStatus=0;
  }

  if(palOk==1)
    set_pallete(pal);

  release_bitmap(screen);
}

void drawStatus()
{
  int x,y;
  static char text[64];

  clear(bufStat);

  drawText(bufStat,"LIVES   :",1,2,0);
  y=play.lives;
  if(y>5)
    y=5;
  for(x=0; x<y; x++)
     draw_sprite(bufStat,sprPlay[10],74+(x*9),0);

  drawText(bufStat,"R.SHIELD:",1,10,0);
  y=play.refNum;
  if(y>5)
    y=5;
  for(x=0; x<y; x++)
    draw_sprite(bufStat,sprPlay[11],74+(x*9),10);

  sprintf(text,"SCORE:%i", (unsigned int)play.score);
  drawText(bufStat,text,120,2,0);

  sprintf(text,"DAL  :%i", play.dal);
  drawText(bufStat,text,120,10,0);

  if(gOpt.gameMode==0)
    sprintf(text,"%i %i %i", play.dalComboBonus, play.wpn[play.wpn1].level,play.wpn[play.wpn2].level);
  if(gOpt.gameMode==1)
    sprintf(text,"%i", play.dalComboBonus);
  #ifdef xop_debug
  sprintf(text,"%s %i", text, tCount);
  //sprintf(text,"%s %i %i", text,tMax,sMax);
  #endif
  drawText(bufStat,text,277-(strlen(text)*8),10,64);
}

void drawCircle(int tNum, int cNum)
{
  int x2=0,y2=0,x3=0,y3=0,a=0,b=0,theC=0,fColor=0,oColor=0;

  theC=thing[tNum].circ[cNum];

  // calculate circle size

  x3=calctX(circ[theC].size,thing[tNum].z*-1)/6;

  if(circ[theC].vib==1)
  {
    if(gCount%2==0)
      x3++;
    else
      x3+=2;
  }

  if(circ[theC].vib==2)
  {
    x3+=rand()%6;
    x3-=rand()%6;
  }

  if(circ[theC].vib==3)
  {
    x3+=rand()%3;
    x3-=rand()%3;
  }

  if((x3>0) || circ[theC].type==1)
  {
    if(circ[theC].trans!=0) // if transparent
      setTrans(1);

    if(thing[tNum].rot==0 || thing[tNum].rot==64 || thing[tNum].rot==128 || thing[tNum].rot==192)
    {
      x2=circ[theC].x; y2=circ[theC].y;

      if(circ[theC].type==1)
      {
        x3=circ[theC].x2; y3=circ[theC].y2;
      }
    }
    else
    {
      a=thing[tNum].w2; b=thing[tNum].h2;

      rotPos(circ[theC].x-a,circ[theC].y-b,thing[tNum].rot/41);
      x2=rx+a; y2=ry+b;

      if(circ[theC].type==1)
      {
        rotPos(circ[theC].x2-a,circ[theC].y2-b,thing[tNum].rot/41);
        x3=rx+a; y3=ry+b;
      }
    }

    if(thing[tNum].z==0)
    {
      x2+=thing[tNum].x;
      y2+=thing[tNum].y;

      if(circ[theC].type==1)
      {
        x3+=thing[tNum].x;
        y3+=thing[tNum].y;
      }
    }
    else
    {
      x2=calctX(thing[tNum].x+x2,thing[tNum].z);
      y2=calctY(thing[tNum].y+y2,thing[tNum].z);

      if(circ[theC].type==1)
      {
        x3=calctX(thing[tNum].x+x3,thing[tNum].z);
        y3=calctY(thing[tNum].y+y3,thing[tNum].z);
      }
    }

    fColor=circ[theC].fColor;
    oColor=circ[theC].oColor;

    if(circ[theC].type==0) // draw a circle
    {
      if(circ[theC].trans==0 || circ[theC].trans==1)
      {
        if(circ[theC].fColor!=0)
          circlefill(buffer,x2-bgPosX,y2,x3,fColor);
        if(circ[theC].oColor!=0)
          circle(buffer,x2-bgPosX,y2,x3,oColor);
      }
      if(circ[theC].trans==2)
      {
        for(a=10; a<20; a++)
        {
          circlefill(buffer,x2-bgPosX,y2,x3-(a/10),fColor);
        }
        if(circ[theC].oColor!=0)
          circle(buffer,x2-bgPosX,y2,x3,oColor);
      }
    }
    if(circ[theC].type==1) // draw a line
    {
      line(buffer,x2-bgPosX,y2,x3-bgPosX,y3,fColor);
    }

    if(circ[theC].trans!=0) // if transparent, change back
      setTrans(0);
  }
}

void drawPlayer()
{
  int x2,x3,y2,y3,x,y,z;

  // draw player

  if(play.invunStat!=0 && gCount%2==0)
    goto skipPdraw;

  for(z=0; z<maxtcirc; z++) // circles below thing
  {
    y=player.circ[z];
    if(circ[y].life!=-1)
    {
      if(circ[y].pos==0)
      {
        x3=(calctX(circ[y].size,player.z*-1)/6)+circ[y].vib;

        if(x3>0 && x3<32)
        {
          x2=circ[y].x+player.x;
          y2=circ[y].y+player.y;

          circlefill(buffer,x2-bgPosX,y2,x3,circ[y].fColor);
          circle(buffer,x2-bgPosX,y2,x3,circ[y].oColor);
        }
      }

      if(circ[y].life!=-2)
      {
        circ[y].life--;

        if(circ[y].life==0)
          circ[y].life=-1;
      }

      if(circ[y].vib==1)
        circ[y].vib=2;
      else
        circ[y].vib=1;
    }
  }

  if(player.z==0)
    draw_sprite(buffer,sprPlay[player.sprite],player.x-bgPosX,player.y);
  else
  {
    x2=calctX(player.x,player.z)-bgPosX;
    x3=calctX(player.x+sprPlay[player.sprite]->w,player.z)-bgPosX;
    y2=calctY(player.y,player.z);
    y3=calctY(player.y+sprPlay[player.sprite]->h,player.z);

    stretch_sprite(buffer,sprPlay[player.sprite],x2,y2,x3-x2,y3-y2);
  }

  for(z=0; z<maxtcirc; z++) // circles above thing
  {
    y=player.circ[z];
    if(circ[y].life!=-1 && circ[y].pos==1)
    {
      x3=(calctX(circ[y].size,player.z*-1)/6)+circ[y].vib;

      if(x3>0 && x3<32)
      {
        x2=circ[y].x+player.x;
        y2=circ[y].y+player.y;

        circlefill(buffer,x2-bgPosX,y2,x3,circ[y].fColor);
        circle(buffer,x2-bgPosX,y2,x3,circ[y].oColor);
      }
    }
  }

  // draw player shield

  x2=(player.x+12)-bgPosX;
  y2=(player.y+16);

  if(play.sTimer!=0)
  {
    z=16;
    if(play.sTimer%2==0) z--;

    x=24; y=22;
                      if(play.health>=100) { x=15; y=11; }
    if(play.health>=75 && play.health<=99) { x=27; y=25; z-=1; }
    if(play.health>=50 && play.health<=74) { x=24; y=22; z-=2; }
    if(play.health>=25 && play.health<=49) { x=21; y=19; z-=3; }
    if(play.health>=0  && play.health<=24) { x=19; y=17; z-=4; }

    circle(buffer,x2,y2,z,x);
    circle(buffer,x2,y2,z-1,y);
  }

  if(showRects==1)
    rect(buffer,(player.x-bgPosX)+9,player.y+15,(player.x-bgPosX)+15,player.y+21,colMagenta);

  skipPdraw:

  // draw reflect shields

  x2=(player.x+12)-bgPosX;
  y2=(player.y+16);

  for(x=0; x<4; x++)
  {
    if(rs[x].stat!=-1 && gCount%2!=0)
    {
      for(y=0; y<=1; y++)
      {
        circle(buffer,x2,y2-y,(int)rs[x].size-0,colWhite);
        circle(buffer,x2,y2-y,(int)rs[x].size-1,colWhite);
        circle(buffer,x2,y2-y,(int)rs[x].size-2,11);
        circle(buffer,x2,y2-y,(int)rs[x].size-3,11);
        circle(buffer,x2,y2-y,(int)rs[x].size-4,9);
        circle(buffer,x2,y2-y,(int)rs[x].size-5,9);
      }

      if(showRects==1)
      {
        y=rs[x].size;
        rect(buffer,x2-y,y2-y,x2+y,y2+y,colMagenta);
      }
    }

    if(rs[x].stat!=-1)
    {
      setTrans(1);
      if(gCount%2!=0)
        circlefill(buffer,x2,y2,(int)rs[x].size-9,9);
      else
        circlefill(buffer,x2,y2,(int)rs[x].size-9,53);
      setTrans(0);
    }
  }
}

void drawShadows(int theBg)
{
  register int x; int y,z;

  setTrans(1);

  if(player.stat!=-1 && player.drawShadow==theBg)
  {
    z=calctX(sprPlay[player.sprite]->w/4,player.z);
    if(z>0)
      circlefill(buffer,calctX(player.x+actPlay[player.act].w2,bg[theBg].ground)-bgPosX,calctY(player.y+actPlay[player.act].h2,bg[theBg].ground),z,16);
  }

  for(x=0; x<tCount; x++)
  {
    y=oSort[x].num;

    if(y<maxthing)
    {
      if(thing[y].drawShadow==theBg)
      {
        thingDefP=thingDef+thing[y].type;

        z=calctX(sprMain[thing[y].sprite]->w/4,thing[y].z);

        if(thingDefP->com[THINGDEF_SHADOW]==1) // default shadow
          goto drawShadow;    
        if(thingDefP->com[THINGDEF_SHADOW]==2) // bigger shadow
          z*=1.2;
        if(thingDefP->com[THINGDEF_SHADOW]==3) // oversized shadow
          z*=2.4;
        if(thingDefP->com[THINGDEF_SHADOW]==4) // tiny shadow
          z/=2.4;
        if(thingDefP->com[THINGDEF_SHADOW]==5) // bigass shadow
          z*=3.2;

        drawShadow:;

        if(z>0 && z<256)
          circlefill(buffer,calctX(thing[y].x+thing[y].w2,bg[theBg].ground)-bgPosX,calctY(thing[y].y+thing[y].h2,bg[theBg].ground),z,colBlack);
      }
    }
  }

  setTrans(0);
}

void drawBackground(int theBg, BITMAP *theBmp)
{
  int a,x2,y2,x3;
  register int x,y,z;

  for(y=0-(bg[theBg].mapH+8); y<bg[theBg].mapH+4; y++)
  {
    y2=(y*bg[theBg].tsize)+bg[theBg].scoff;
    a=(((bg[theBg].mapH-y)+bg[theBg].toff)*bg[theBg].mapW);
    if(a<0)
      a=0;
    if(a>=bg[theBg].mapHt*bg[theBg].mapW)
      a=0;

    for(x=0; x<bg[theBg].mapW; x++)
    {
      z=tileStat[bg[theBg].map[x+a]].tile;

      if(z<0 || z>=maxtile || z==TILE_EMPTY || z==TILE_SOLID)
        continue;

      if(tile[z])
      {
        x2=((x*bg[theBg].tsize)+bg[theBg].hoff)-bgPosX;

        if(y2+tile[z]->h<0) // if it's too high up on the screen, skip this tile
          continue;

        if(bg[theBg].hoff==0) // if no horizontal movement
        {
          if(x2+tile[z]->w<0 || x2>280) // if it's too far to the left or right, skip this tile
            continue;
        }

        if(bg[theBg].hoff!=0) // if horizontal movement
        {
          x3=x2+bgPosX;

          if(x3+tile[z]->w>=bg[theBg].mapWp)
          {
            if(tileStat[bg[theBg].map[x+a]].trans==1)
              draw_trans_rle_sprite(theBmp,tile[z],x2,y2);
            else
              draw_rle_sprite(theBmp,tile[z],x2,y2);

            x2-=bg[theBg].mapWp;
          }
          if(x3<0)
          {
            if(tileStat[bg[theBg].map[x+a]].trans==1)
              draw_trans_rle_sprite(theBmp,tile[z],x2,y2);
            else
              draw_rle_sprite(theBmp,tile[z],x2,y2);

            x2+=bg[theBg].mapWp;
          }
        }

        if(tileStat[bg[theBg].map[x+a]].trans==1)
          draw_trans_rle_sprite(theBmp,tile[z],x2,y2);
        else
          draw_rle_sprite(theBmp,tile[z],x2,y2);
      }
    }
  }
}

void drawBgEffect(int theBg, BITMAP *destBmp)
{
  int x,y,z,dest=0;
  float wX,wX2,wXgrav;

  if(bg[theBg].stat!=-1)
  {
    clear(bgBuffer);
    drawBackground(theBg,bgBuffer);
  }

  for(z=0; z<4; z++)
  {
    if(bg[theBg].e[z].effect==1) // wavyness
    {
      dest=0;
      wX=bg[theBg].e[z].eVar[0];
      wXgrav=bg[theBg].e[z].eVar[1];
      wX2=bg[theBg].e[z].eVar[2]/100;
      x=bg[theBg].e[z].eVar[3];

      for(y=0; y<300; y+=2)
      {
        if(wX>=0)
          wXgrav-=wX2;
        else
          wXgrav+=wX2;

        wX+=wXgrav;

        blit(bgBuffer,bgBuffer,0,y,wX,y,320,2);

        if(x==1)
        {
          rectfill(bgBuffer,-1,y,wX-1,y+1,colTrans);
          rectfill(bgBuffer,wX+321,y,321,y+1,colTrans);
        }
        if(x==2)
        {
          blit(bgBuffer,bgBuffer,wX,y,wX+320,y,320,2);
        }
      }
    }

    if(bg[theBg].e[z].effect==2) // curvyness
    {
      dest=1;
      wX=bg[theBg].e[z].eVar[0];
      wXgrav=bg[theBg].e[z].eVar[1];

      clear(bgBuffer2);
      for(y=0; y<300; y+=4)
      {
        if(wX>=0)
          wXgrav-=bg[theBg].e[z].eVar[2]/100;
        else
          wXgrav+=bg[theBg].e[z].eVar[2]/100;

        wX+=wXgrav;

        masked_stretch_blit(bgBuffer,bgBuffer2,
        0,y,320,4,             // source
        wX/2,y,320-(wX/2),4);  // dest
      }
    }
  }

  if(dest==0)
  {
    if(bg[theBg].e[0].eVar[7]==0)
      draw_sprite(destBmp,bgBuffer,0,0);
    if(bg[theBg].e[0].eVar[7]==1)
      draw_trans_sprite(destBmp,bgBuffer,0,0);
  }
  if(dest==1)
  {
    if(bg[theBg].e[0].eVar[7]==0)
      draw_sprite(destBmp,bgBuffer2,0,0);
    if(bg[theBg].e[0].eVar[7]==1)
      draw_trans_sprite(destBmp,bgBuffer2,0,0);
  }
}

void drawShrapnel(int shPos)
{
  register int x,z; int y;
  int x2,y2,y3;

  for(x=0; x<sMax; x++)
  {
    if(sh[x].type!=-1 && sh[x].hiDraw==shPos)
    {
      if(sh[x].z==0)
      { x2=sh[x].x; y2=sh[x].y; }
      else
      { x2=calctX(sh[x].x,sh[x].z); y2=calctY(sh[x].y,sh[x].z); }
      x2-=bgPosX;

      if(x2>3 && y2>3 && x2<276 && y2<296)
      {
        z=sh[x].pDrop;

        y=sh[x].col[sh[x].colShow];
        if(y==-1)
          y=rand()%255;
        if(y==15)
          y=29;

        y3=sh[x].colShow+1;
        if(y3==4)
          y3=0;
        y3=sh[x].col[y3];
        if(y3==-1)
          y3=rand()%255;

        if(z==0)
        {
          putpixel8(buffer,x2,y2,y);

          if(sh[x].type==2)
          {
            putpixel8(buffer,x2+1,y2,y3);
          }

          if(sh[x].type==3)
          {
            putpixel8(buffer,x2+1,y2,y);
            putpixel8(buffer,x2,y2+1,y);
            putpixel8(buffer,x2+1,y2+1,y);
          }

          if(sh[x].type==4)
          {
            putpixel8(buffer,x2-1,y2,y);
            putpixel8(buffer,x2,y2-1,y3);
            putpixel8(buffer,x2+1,y2,y3);
            putpixel8(buffer,x2,y2+1,y);
          }
        }
        else
        {
          if(rand()%z>=2)
            putpixel8(buffer,x2,y2,y);

          if(sh[x].type==2)
          {
            if(rand()%z>=2)
              putpixel8(buffer,x2+1,y2,y3);
          }

          if(sh[x].type==3)
          {
            if(rand()%z>=2)
              putpixel8(buffer,x2+1,y2,y);
            if(rand()%z>=2)
              putpixel8(buffer,x2,y2+1,y);
            if(rand()%z>=2)
              putpixel8(buffer,x2+1,y2+1,y);
          }

          if(sh[x].type==4)
          {
            if(rand()%z>=2)
              putpixel8(buffer,x2-1,y2,y);
            if(rand()%z>=2)
              putpixel8(buffer,x2,y2-1,y3);
            if(rand()%z>=2)
              putpixel8(buffer,x2+1,y2,y3);
            if(rand()%z>=2)
              putpixel8(buffer,x2,y2+1,y);
          }
        }
      }
    }
  }
}

void drawTransform(int theTrans, int speed)
{
  int x,y,z;

  if(theTrans==2) // sweep up & down
  {
    if(speed<=0)
      return;

    blit(screen,buffer,sXoff,sYoff,0,0,280,320);

    y=0;
    resetCounter();
    for(;;)
    {
      while(sCount>0)
      {
        rectfill(buffer,0,y,280,y+speed,0);
        rectfill(buffer,0,(300-(y+speed)),280,(300-y),0);

        y+=speed;
        if(y>=160)
          return;

        waitCounter();
      }

      if(sCountDrawOk==1)
      {
        blitToScreen();
        sCountDrawOk=0;
      }
    }
  }

  if(theTrans==3) // begin simulation effect
  {
    rectfill(buffer,0,-2,280,speed,colWhite);

    for(y=speed; y<speed+16; y++)
    {
      for(x=0; x<280; x++)
      {
        if(rand()%3==1)
          putpixel(buffer,x,y,colWhite);
      }
    }

    for(y=speed; y<speed+32; y++)
    {
      for(x=0; x<280; x++)
      {
        if(rand()%5==1)
          putpixel(buffer,x,y,colWhite);
      }
    }

    for(y=speed; y<speed+64; y++)
    {
      for(x=0; x<280; x++)
      {
        if(rand()%10==1)
          putpixel(buffer,x,y,colWhite);
      }
    }

    if(introSign<=30)
      draw_sprite(buffer,sprPlay[6],5,32);

    z=140-(strlen(lvlDesc)*4);
    drawText(buffer,lvlDesc,z,60,0);
    rect(buffer,z-2,58,141+((strlen(lvlDesc)-2)*4),69,colGray);
    rect(buffer,z-1,59,140+((strlen(lvlDesc)-2)*4),68,colBlack);

    if(circ[1].vib==1)
      circ[1].vib=2;
    else
      circ[1].vib=1;

    if(circ[3].vib==1)
      circ[3].vib=2;
    else
      circ[3].vib=1;

    drawPlayer();
  }

  if(theTrans==4) // end simulation effect
  {
    rectfill(buffer,0,speed,280,302,15);

    for(y=speed-16; y<speed; y++)
    {
      for(x=0; x<280; x++)
      {
        if(rand()%3==1)
          putpixel(buffer,x,y,colWhite);
      }
    }

    for(y=speed-32; y<speed; y++)
    {
      for(x=0; x<280; x++)
      {
        if(rand()%5==1)
          putpixel(buffer,x,y,colWhite);
      }
    }

    for(y=speed-64; y<speed; y++)
    {
      for(x=0; x<280; x++)
      {
        if(rand()%10==1)
          putpixel(buffer,x,y,colWhite);
      }
    }

    if(introSign<=30)
      draw_sprite(buffer,sprPlay[8],5,32);
  }

  if(theTrans==5) // warning
  {
    if(gCount%2==0)
      draw_sprite(buffer,sprPlay[13],5,32);
  }
}

void drawTextCenter(BITMAP *targetBmp, char *text, int locY, int yOffset)
{
  drawText(targetBmp,text,(SCREEN_W/2)-(strlen(text)*4),locY,yOffset);
}

void drawText(BITMAP *targetBmp, char *text, int locX, int locY, int yOffset)
{
  int x,y,c,cLocX,cLocY,locXstart;

  locXstart=locX;

  y=strlen(text);
  for(x=0; x<y; x++)
  {
    if(text[x]==NULL)
      return;

    c=text[x];

    cLocY=(int)(c/16)<<3;
    cLocX=(c-(cLocY*2))<<3;

    blit(xopfont, targetBmp, cLocX, cLocY+yOffset, locX, locY, 8, 8);

    locX+=8;

    if(c==10) // return
    {
      locX=locXstart;
      locY+=8;
    }
  }
}

void displayMemory()
{
  #ifdef xop_debug
  int offY,offYnext,x;
  unsigned long mSize;
  char text[40];

  offY=0; offYnext=16;

  clear(buffer);
  mSize=0;
  displayMemoryAdd(888);

  mSize=(512*sizeof(int))+sizeof(sprID)+sizeof(sndPlay)+sizeof(gOpt)+sizeof(hs)+sizeof(hs2);
  sprintf(text,"misc        : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(tileStat);
  sprintf(text,"tileStat    : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(play)+sizeof(player)+(sizeof(tObj)*maxthing);
  sprintf(text,"things      : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(circ);
  sprintf(text,"circles     : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=(sizeof(shrapObj)*maxshrap);
  sprintf(text,"shrapnel    : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(timer);
  sprintf(text,"timers      : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(oSort);
  sprintf(text,"oSort       : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(actPlay)+(sizeof(actObj)*maxact);
  sprintf(text,"acts        : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(script)+sizeof(shrapDef)+sizeof(shotDef)+sizeof(thingDef)+sizeof(thingAct)
       +sizeof(moveDef)+sizeof(circleDef)+sizeof(linkDef)+sizeof(expDef)+sizeof(playDef);
  sprintf(text,"datObjs     : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(fNameList)+sizeof(fNamePos)+sizeof(inFile);
  sprintf(text,"packfile    : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(bg);
  for(x=0; x<maxbg; x++)
  {
    if(bg[x].stat!=-1)
    {
      mSize+=bg[x].mapW*bg[x].mapHt;
      mSize+=bg[x].mapHt;
    }
  }
  sprintf(text,"bg          : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=(sizeof(COLOR_MAP)*3)+sizeof(RGB_MAP);
  sprintf(text,"color maps  : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=(buffer->w*buffer->h)+sizeof(buffer)
       +(bgBuffer->w*bgBuffer->h)+sizeof(bgBuffer)
       +(bgBuffer2->w*bgBuffer2->h)+sizeof(bgBuffer2)
       +(bufStat->w*bufStat->h)+sizeof(bufStat)
       +(cursor->w*cursor->h)+sizeof(cursor)
       +(xopfont->w*xopfont->h)+sizeof(xopfont)
       +(borderBmp->w*borderBmp->h)+sizeof(borderBmp)+sizeof(sprPlay);
  for(x=0; x<32; x++)
    if(sprPlay[x])
      mSize+=sprPlay[x]->w*sprPlay[x]->h;
  sprintf(text,"system BMPs : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(sprMain);
  for(x=0; x<maxsprite; x++)
    if(sprMain[x])
      mSize+=sprMain[x]->w*sprMain[x]->h;
  sprintf(text,"game BMPs   : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(tile);
  for(x=0; x<maxtile; x++)
    if(tile[x])
      mSize+=tile[x]->size;
  sprintf(text,"tile RLEs   : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  mSize=sizeof(snd)+sizeof(gMusic);
  for(x=0; x<maxsound; x++)
    if(snd[x])
      mSize+=snd[x]->len;
  sprintf(text,"sounds      : %i", (int)mSize/1024);
  drawText(buffer,text,0,offY,64);
  displayMemoryAdd(mSize);
  offY+=offYnext;

  sprintf(text,"total       : %i", (int)displayMemoryAdd(0)/1024);
  drawText(buffer,text,0,offY,64);
  offY+=offYnext;

  blit(buffer,screen,0,0,sXoff,sYoff,280,300);

  while(key[KEY_M])
  {
    screenShot();
  }
  #endif
}

unsigned long displayMemoryAdd(unsigned int theMem)
{
  #ifdef xop_debug
  static unsigned long total;

  if(theMem==888)
  {
    total=0;
    return total;
  }

  total+=theMem;

  return total;
  #endif

  return 0;
}
