/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Data loading functions (act, dat, def)
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

#include "loadpng.h"
#include "main.h"
#include "system.h"
//#include "thing.h"
//#include "tmake.h"
#include "draw.h"
#include "level.h"
//#include "input.h"
//#include "shrap.h"
#include "play.h"
#include "file.h"
#include "unpack.h"
//#include "menu.h"

void readActObj(char *path, actObj theAct[], BITMAP *theSpr[], int useID)
{
  char temp;
  int x,y,sprW,sprH;
  FILE *datfile;

  x=0;

  #ifndef xop_release
  if((datfile=fopen(path,"r"))==NULL)
    bombOut(3,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  while(!feof(datfile))
  {
    temp=getc(datfile);
    if(temp==91)
    {
      theAct[x].sprite=getNum(datfile);
      theAct[x].timerLimit=getNum(datfile);
      theAct[x].next=getNum(datfile);

      if(theAct[x].next==888)
        theAct[x].next=x+1;

      if(useID==1) // associate sprite with it's ID
      {
        for(y=0; y<maxsprite2; y++)
        {
          if(theAct[x].sprite==sprID[y] && sprID[y]!=-1)
          {
            theAct[x].sprite=y;
            goto foundID;
          }
        }
        theAct[x].sprite=0;

        foundID:;
      }

      if(theAct[x].sprite>=maxsprite2 || theAct[x].sprite<0)
        theAct[x].sprite=0;

      if(theSpr[theAct[x].sprite]!=NULL)
      {
        sprW=theSpr[theAct[x].sprite]->w;
        sprH=theSpr[theAct[x].sprite]->h;
      }
      else
      {
        sprW=1;
        sprH=1;
        theAct[x].sprite=0;
      }

      temp=getc(datfile);

      theAct[x].hrX1=getNum(datfile);
      theAct[x].hrY1=getNum(datfile);
      theAct[x].hrX2=getNum(datfile);
      theAct[x].hrY2=getNum(datfile);

      if(theAct[x].hrX1==666) // if set to 666, will auto-create the hit rectangle
      {
        theAct[x].hrX1=0;
        theAct[x].hrY1=0;
        theAct[x].hrX2=sprW;
        theAct[x].hrY2=sprH;
      }

      temp=getc(datfile);

      theAct[x].c0x=getNumPos(datfile);
      theAct[x].c0y=getNumPos(datfile);
      theAct[x].c1x=getNumPos(datfile);
      theAct[x].c1y=getNumPos(datfile);
      theAct[x].c2x=getNumPos(datfile);
      theAct[x].c2y=getNumPos(datfile);

      temp=getc(datfile);

      theAct[x].offX=getNumPos(datfile);
      theAct[x].offY=getNumPos(datfile);

      if(theAct[x].offX>600)
        theAct[x].offX=((sprW/2)*-1)+(theAct[x].offX-600);
      if(theAct[x].offY>600)
        theAct[x].offY=((sprH/2)*-1)+(theAct[x].offY-600);

      temp=getc(datfile);

      theAct[x].movement=getNum(datfile);

      theAct[x].hrY1+=theAct[x].offY;
      theAct[x].hrY2+=theAct[x].offY;

      //make right-sided action object

      theAct[x].hrX1b=theAct[x].hrX1;
      theAct[x].hrX1b+=theAct[x].offX;
      theAct[x].hrX2b=sprW-theAct[x].hrX1b;

      theAct[x].hrX1b=theAct[x].hrX2;
      theAct[x].hrX1b+=theAct[x].offX;
      theAct[x].hrX1b=sprW-theAct[x].hrX1b;

      // finish stuff with left-sided action object

      theAct[x].hrX1+=theAct[x].offX;
      theAct[x].hrX2+=theAct[x].offX;

      // make height, width vars

      theAct[x].hrW=theAct[x].hrX2-theAct[x].hrX1;
      theAct[x].hrH=theAct[x].hrY2-theAct[x].hrY1;

      theAct[x].w2=sprW/2;
      theAct[x].h2=sprH/2;

      x++;
    }
  }

  fclose(datfile);
}

void readDatFile(char *path, datObj theDat[], int error)
{
  char temp;
  int x,y,datSize=sizeof(theDat)/sizeof(datObj);
  FILE *datfile;

  #ifndef xop_release
  if((datfile=fopen(path,"r"))==NULL)
    bombOut(error,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  for(x=0; x<datSize; x++) // mark all data as unloaded
    theDat[x].loaded=0;

  y=0;
  while(!feof(datfile))
  {
    temp=getc(datfile);

    if(temp==91)
    {
      theDat[y].com[0]=getNumPosDat(datfile); // get first number found
      x=1;
      while(!feof(datfile) && x<maxdatcom)    // get remaining numbers
      {
        temp=getc(datfile);

        if(temp==91)
        {
          theDat[y].com[x]=getNumPosDat(datfile);
          x++;
        }
      }

      theDat[y].loaded=1;
      y++;
    }
  }

  fclose(datfile);
}

void loadImage(char *path, int offset, int error)
{
  register int x,y;
  int iNum,temp,sprStat,fSpr;
  char fName[32];
  char fPath[80];
  FILE *datfile;

  #ifndef xop_release
  if((datfile=fopen(path, "r"))==NULL)
    bombOut(4,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  iNum=offset;
  while(!feof(datfile))
  {
    temp=getc(datfile);
    
    if(temp==91) // found a file name
    {
      for(x=0; x<32; x++)
        fName[x]=NULL;

      sprID[iNum]=getNum(datfile);   // get id var
      sprStat=getNum(datfile);       // get status var

      x=0;
      while(!feof(datfile))   // get file name
      {
        temp=getc(datfile);
        if(temp==93)          // end of file name
          break;
        fName[x]=temp;
        x++;
      }

      if(sprMain[iNum]!=NULL)
        bombOut(29,iNum);

      #ifndef xop_release
      sprintf(fPath,"%s%s",getPath("png/game/"),fName); // reads files directly from disk
      sprMain[iNum]=load_png(fPath,pal);
      #endif

      #ifdef xop_release
      seekFile(fName);
      sprMain[iNum]=load_png_file(inFile,pal);
      #endif

      if(sprMain[iNum]==NULL)
      {
        fclose(datfile);
        bombOutText(1,fName);
      }

      if(sprStat==1) // create flash sprite
      {
        fSpr=iNum+maxsprite2;
        sprMain[fSpr]=create_bitmap(sprMain[iNum]->w,sprMain[iNum]->h);
        clear_to_color(sprMain[fSpr],colTrans);
        draw_trans_sprite(sprMain[fSpr],sprMain[iNum],0,0);

        for(y=0; y<sprMain[iNum]->h; y++) // fix 0 color pixels
        {
          for(x=0; x<sprMain[iNum]->w; x++)
          {
            if(_getpixel(sprMain[iNum],x,y)==colTrans)
              _putpixel(sprMain[fSpr],x,y,colTrans);
          }
        }
      }

      iNum++;

      if(iNum==maxsprite2)
      {
        fclose(datfile);
        bombOut(27,iNum);
      }
    }
  }

  fclose(datfile);

  for(y=0; y<maxsprite2; y++) // check for duplicate IDs
  {
    for(x=0; x<maxsprite2; x++)
    {
      if(sprID[x]==sprID[y] && sprID[x]!=-1 && sprID[y]!=-1 && x!=y)
        bombOut(23,sprID[x]);
    }
  }
}

void loadTile(char *path, int error)
{
  register int x;
  int iNum,temp;
  char fName[32];
  char fPath[80];
  FILE *datfile;
  BITMAP *tmpBMP=NULL;

  #ifndef xop_release
  if((datfile=fopen(path, "r"))==NULL)
    bombOut(5,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  iNum=0;
  while(!feof(datfile))
  {
    temp=getc(datfile);
    
    if(temp==91) // found a file name
    {
      for(x=0; x<32; x++)
        fName[x]=NULL;

      // get tileStat stuff

      tileStat[iNum].next=getc(datfile)-33; tileStat[iNum].origNext=tileStat[iNum].next; temp=getc(datfile);
      tileStat[iNum].tlimit=getNum(datfile); tileStat[iNum].origTlimit=tileStat[iNum].tlimit; tileStat[iNum].timer=0;
      tileStat[iNum].trans=getNum(datfile);
      tileStat[iNum].tile=iNum; tileStat[iNum].origTile=iNum;

      x=0;
      while(!feof(datfile)) // get file name
      {
        temp=getc(datfile);
        if(temp==93)
          break;
        fName[x]=temp;
        x++;
      }

      #ifndef xop_release
      sprintf(fPath,"%s%s",getPath("png/tile/"),fName); // reads files directly from disk
      tmpBMP=load_png(fPath,pal);
      #endif

      #ifdef xop_release
      seekFile(fName);
      tmpBMP=load_png_file(inFile,pal);
      #endif

      if(tmpBMP!=NULL)
      {
        tile[iNum]=get_rle_sprite(tmpBMP);
        destroy_bitmap(tmpBMP);
      }

      if(tile[iNum]==NULL)
      {
        fclose(datfile);
        bombOutText(1, fName);
      }

      iNum++;
    }
  }

  fclose(datfile);
}

void loadSound(char *path, int error)
{
  register int x;
  int iNum,temp;
  char fPath[64],fName[32];
  FILE *datfile;

  #ifndef xop_release
  if((datfile=fopen(path, "r"))==NULL)
    bombOut(4,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  iNum=0;
  while(!feof(datfile))
  {
    temp=getc(datfile);
    
    if(temp==91) // found a file name
    {
      for(x=0; x<32; x++)
        fName[x]=NULL;
      for(x=0; x<64; x++)
        fPath[x]=NULL;

      x=0;
      while(!feof(datfile)) // get file name
      {
        temp=getc(datfile);
        if(temp==93)
          break;
        fName[x]=temp;
        x++;
      }

      #ifndef xop_release
      sprintf(fPath,"%s/%s",getPath("wav"),fName);
      snd[iNum]=load_wav(fPath);
      #endif

      #ifdef xop_release
      unpackFile(fName,"xop.wav");
      snd[iNum]=load_wav("xop.wav");
      #endif

      if(snd[iNum]==NULL)
      {
        remove("xop.wav");
        fclose(datfile);
        bombOutText(1,fName);
      }

      iNum++;
    }
  }

  remove("xop.wav");
  fclose(datfile);
}

void saveOptions()
{
  FILE *datfile;

  if((datfile=fopen("xopopt.dat","w"))==NULL)
    bombOut(20,0);

  putNum(gOpt.expMode, datfile);
  putNum(gOpt.randMode, datfile);
  putNum(gOpt.skillMode, datfile);
  putNum(gOpt.soundVol, datfile);
  putNum(gOpt.musicVol, datfile);
  putNum(gOpt.vMode, datfile);

  fclose(datfile);
}

void loadOptions()
{
  FILE *datfile;
  int temp;

  gOpt.expMode=0;
  gOpt.randMode=0;
  gOpt.skillMode=2;
  gOpt.soundVol=192;
  gOpt.musicVol=112;
  gOpt.vMode=0;

  play.keydef[KEY_UP01]=KEY_UP;
  play.keydef[KEY_DOWN01]=KEY_DOWN;
  play.keydef[KEY_LEFT01]=KEY_LEFT;
  play.keydef[KEY_RIGHT01]=KEY_RIGHT;
  play.keydef[KEY_ACTION01]=KEY_Z;
  play.keydef[KEY_ACTION02]=KEY_X;
  play.keydef[KEY_ACTION03]=KEY_C;
  play.keydef[KEY_ACTION04]=KEY_V;

  play.joydef[JOY_ACTION01]=0;
  play.joydef[JOY_ACTION02]=1;
  play.joydef[JOY_ACTION03]=2;
  play.joydef[JOY_ACTION04]=3;

  if(access("xopopt.dat",0))
    return;

  if((datfile=fopen("xopopt.dat","r"))==NULL)
    return;

  temp=getc(datfile);
  if(temp==EOF)
  {
    fclose(datfile);
    return;
  }

  gOpt.expMode=getNum(datfile);
  gOpt.randMode=getNum(datfile);
  gOpt.skillMode=getNum(datfile);
  gOpt.soundVol=getNum(datfile);
  gOpt.musicVol=getNum(datfile);
  gOpt.vMode=getNum(datfile);

  fclose(datfile);
}

void saveHiscore()
{
  int x,y,encNum[4];
  FILE *datfile;

  if((datfile=fopen("xophi.dat","wb"))==NULL)
    bombOut(25,0);

  putc(64,datfile);

  for(x=0; x<3; x++)
  {
    encNum[x]=(rand()%32)+2;
    putc(encNum[x],datfile);
  }

  for(x=0; x<hsSize; x++)
  {
    putc(hs[x].name[0]+encNum[0],datfile); putc(34+rand()%92,datfile);
    putc(hs[x].name[1]+encNum[1],datfile); putc(34+rand()%92,datfile);
    putc(hs[x].name[2]+encNum[2],datfile); putc(34+rand()%92,datfile);

    putc(hs[x].skill+encNum[0],datfile);
    putc(hs[x].lComp+encNum[2],datfile);

    y=(int)(hs[x].score/65535);
    putc(y,datfile);
    putc((int)(hs[x].score-(y*65535)),datfile);
  }

  for(x=0; x<hsSize; x++)
  {
    putc(hs2[x].name[0]+encNum[0],datfile); putc(34+rand()%92,datfile);
    putc(hs2[x].name[1]+encNum[1],datfile); putc(34+rand()%92,datfile);
    putc(hs2[x].name[2]+encNum[2],datfile); putc(34+rand()%92,datfile);

    putc(hs2[x].skill+encNum[0],datfile);
    putc(hs2[x].lComp+encNum[2],datfile);

    y=(int)(hs2[x].score/65535);
    putc(y,datfile);
    putc((int)(hs2[x].score-(y*65535)),datfile);
  }

  fclose(datfile);
}

void loadHiscore()
{
  int x,y,encNum[4];
  FILE *datfile;

  if((datfile=fopen("xophi.dat","rb"))==NULL) // make a highscore file
  {
    newHiscore:

    for(x=0; x<hsSize; x++)
    {
      sprintf(hs[x].name,"XOP");
      hs[x].skill=2;
      hs[x].lComp=1;
      hs[x].score=500+(x*500);

      sprintf(hs2[x].name,"XOP");
      hs2[x].skill=2;
      hs2[x].lComp=1;
      hs2[x].score=10000;
    }

    saveHiscore();

    return;
  }
  else                                        // load the highscore file
  {
    x=getc(datfile);
    if(x!=64)
    {
      fclose(datfile);
      goto newHiscore;
    }

    encNum[0]=getc(datfile);
    encNum[1]=getc(datfile);
    encNum[2]=getc(datfile);

    for(x=0; x<hsSize; x++)
    {
      hs[x].name[0]=getc(datfile)-encNum[0]; y=getc(datfile);
      hs[x].name[1]=getc(datfile)-encNum[1]; y=getc(datfile);
      hs[x].name[2]=getc(datfile)-encNum[2]; y=getc(datfile);
      hs[x].name[3]=NULL;

      hs[x].skill=getc(datfile)-encNum[0];
      hs[x].lComp=getc(datfile)-encNum[2];
      hs[x].score=getc(datfile)*65535;
      hs[x].score+=getc(datfile);
    }

    for(x=0; x<hsSize; x++)
    {
      hs2[x].name[0]=getc(datfile)-encNum[0]; y=getc(datfile);
      hs2[x].name[1]=getc(datfile)-encNum[1]; y=getc(datfile);
      hs2[x].name[2]=getc(datfile)-encNum[2]; y=getc(datfile);
      hs2[x].name[3]=NULL;

      hs2[x].skill=getc(datfile)-encNum[0];
      hs2[x].lComp=getc(datfile)-encNum[2];
      hs2[x].score=getc(datfile)*65535;
      hs2[x].score+=getc(datfile);
    }

    fclose(datfile);
  }
}

/*__inline*/ int getNum(FILE *theFile)
{
  int temp,x;

  temp =(getc(theFile)-48)*100;
  temp+=(getc(theFile)-48)*10;
  temp+=(getc(theFile)-48);

  x=getc(theFile);

  return temp;
}

/*__inline*/ int getNumPos(FILE *theFile)
{
  int temp,x;

  x=getc(theFile);

  temp =(getc(theFile)-48)*100;
  temp+=(getc(theFile)-48)*10;
  temp+=(getc(theFile)-48);

  if(x==45)
    temp*=-1;

  x=getc(theFile);

  return temp;
}

/*__inline*/ int getNumPosDat(FILE *theFile)
{
  int temp,x;

  x=getc(theFile);

  temp =(getc(theFile)-48)*100;
  temp+=(getc(theFile)-48)*10;
  temp+=(getc(theFile)-48);

  if(x==45)
    temp*=-1;

  return temp;
}

/*__inline*/ void putNum(int theNum, FILE *theFile)
{
  int temp;

  putc(91,theFile);

  temp=theNum/100;
  putc(temp+48,theFile);

  temp=theNum-(temp*100);
  temp/=10;
  putc(temp+48,theFile);

  temp=theNum%10;
  putc(temp+48,theFile);
}
