/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: background/timer/tile loops, level loading functions
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
#include "tmake.h"
#include "draw.h"
#include "level.h"
#include "input.h"
#include "shrap.h"
#include "play.h"
#include "file.h"
#include "unpack.h"
#include "menu.h"
#include "circ.h"

void doBackground()
{
  register int a; int b;
  float pMove;

  bgCount=0;

  for(a=0; a<maxbg; a++)
  {
    if(bg[a].stat!=-1)
    {
      pMove=(zdepth*play.speed)/(zdepth-bg[a].ground);

      // x movement

      bg[a].hoff+=bg[a].hspeed;

      if(bg[a].hoff>=bg[a].mapWp)
        bg[a].hoff-=bg[a].mapWp;
      else if(bg[a].hoff<0-bg[a].mapWp)
        bg[a].hoff+=bg[a].mapWp;

      // y movement

      bg[a].scoff+=pMove;
      bg[a].scoff+=bg[a].speed;

      if(bg[a].scoff>=bg[a].tsize)
      {
        b=bg[a].toff+bg[a].mapH;
        if(bg[a].script[b]!=0)
          runScript(bg[a].script[b]); // run the script on this tile row

        bg[a].toff++; // increment tile count
        bg[a].scoff-=bg[a].tsize;
      }

      if(bg[a].toff==bg[a].mapHt-(bg[a].mapH*2)) // if it's the end of the tile map
      {
        bg[a].stat=-1;
        bgCount--;
      }
    }

    oSort[bgCount].num=a;
    oSort[bgCount].key=bg[a].ground;
    bgCount++;
  }

  qsort(oSort, bgCount, sizeof(sortObj),(int(*)(const void *, const void *)) comp);
}

void doTiles()
{
  register int x; int y;

  for(x=0; x<maxtile; x++)
  {
    if(tileStat[x].tile!=TILE_EMPTY)
    {
      if(tileStat[x].next!=TILE_EMPTY)
      {
        tileStat[x].timer++;
        if(tileStat[x].timer==tileStat[x].tlimit)
        {
          y=tileStat[x].next;
          if(y>0 && y<maxtile)
          {
            tileStat[x].timer=0;
            tileStat[x].tlimit=tileStat[y].origTlimit;
            tileStat[x].tile=tileStat[y].origTile;
            tileStat[x].next=tileStat[y].origNext;
          }
        }
      }
    }
  }
}

void doTimer()
{
  register int x; int y,z,a,tX,tY,tZ,temp;

  for(x=0; x<maxtimer; x++)
  {
    if(timer[x].timer!=-1)
    {
      timer[x].timer--;      // count down timer

      if(timer[x].timer<=0)  // activate
      {
        if(timer[x].scriptAct<900)  // script
        {
          if(timer[x].tLookup==555) // special for 27 (delayed thing create)
          {
            y=timer[x].scriptAct;

            temp=script[y].com[10];
            script[y].com[10]=0;
            makeThing(y);
            script[y].com[10]=temp;
            timer[x].tLookup=0;
          }
          else
            runScript(timer[x].scriptAct);
        }
        else //explosion
        {
          timer[x].scriptAct-=900;

          if(timer[x].tLookup==-1) // don't need to lookup thing position
            makeExp(timer[x].x,timer[x].y,timer[x].z,timer[x].scriptAct);
          else // lookup thing position, change to center if needed
          {
            y=timer[x].tLookup;
            z=timer[x].scriptAct;
            a=thingAct[expDef[z].com[15]].com[THINGACT_INITACT];

            if(expDef[z].com[0]==888 || expDef[z].com[0]==999) // centered
              tX=((thing[y].x+thing[y].w2)-(actMain[a].w2+actMain[a].offX))-expDef[z].com[3]/2;
            else
              tX=thing[y].x+expDef[z].com[0];

            if(expDef[z].com[1]==888 || expDef[z].com[1]==999) // centered
              tY=((thing[y].y+thing[y].h2)-(actMain[a].h2+actMain[a].offY))-expDef[z].com[4]/2;
            else
              tY=thing[y].y+expDef[z].com[1];

            tZ=thing[y].z+expDef[z].com[2];

            if(thing[y].stat!=-1)
              makeExp(tX,tY,tZ,z);
          }
        }

        timer[x].timer=-1;   // deactivate the timer
      }
    }
  }
}

void doMisc()
{
  register int x;

  // calculate the max thing limit, total number of player shots and hittable things

  tMax=0;
  tPshotCount=0;
  tPshotHitCount=0;
  for(x=0; x<maxthing; x++)
  {
    if(thing[x].stat!=-1)
    {
      tMax=x;

      if(thingDef[thing[x].type].com[THINGDEF_ISPSHOT]!=0)
        tPshotCount++;
      if(thingDef[thing[x].type].com[THINGDEF_HITPSHOT]!=0)
        tPshotHitCount++;
    }
  }
  tMax+=16;
  if(tMax>maxthing)
    tMax=maxthing;

  // calculate the max shrap limit

  sMax=0;
  for(x=0; x<maxshrap; x++)
  {
    if(sh[x].type!=-1)
    {
      sMax=x;
    }
  }
  sMax+=16;
  if(sMax>maxshrap)
    sMax=maxshrap;

  if(introCount>-260) // begin/end level anim
  {
    if(gStat==1)
      player.y-=3;

    introSign+=2;
    if(introSign==60)
      introSign=0;

    introCount-=5;

    if(introCount<=-260) // end of animation
    {
      if(gStat==1)
      {
        endLevel();
        return;
      }

      if(gStat==2)
        gStat=0;
    }
  }

  // sound play stuff

  for(x=0; x<maxsound; x++)
  {
    if(sndPlay[x]>0)
      sndPlay[x]--;
  }

  // animated pallete

  pal[245].r++;
  if(pal[245].r==63)
    pal[245].r=0;

  pal[246].r++;
  if(pal[246].r==63)
    pal[246].r=0;

  // randomness

  if(gCount%256==0)
    srand(abs(time(NULL)));
}

void makeTimer(int iTimer, int iScriptAct, int itLookup)
{
  int y;

  if(iTimer<=0)
    iTimer=1;

  for(y=0; y<maxtimer; y++)
  {
    if(timer[y].timer==-1)
    {
      timer[y].timer=iTimer;
      timer[y].scriptAct=iScriptAct;
      timer[y].tLookup=itLookup;
      return;
    }
  }
}

void loadLevel(int lvlnum)
{
  static int argh=0;
  int x,y,z,dalCount;
  char path[128];
  char lvlname[8];
  FILE *datfile;

  if(lvlnum==0)
    sprintf(lvlname,"levelA");
  else if(lvlnum==1)
    sprintf(lvlname,"levelB");
  else if(lvlnum==2)
    sprintf(lvlname,"levelC");
  else if(lvlnum==3)
    sprintf(lvlname,"levelD");
  else if(lvlnum==4)
    sprintf(lvlname,"levelE");
  else if(lvlnum==5)
    sprintf(lvlname,"levelF");
  else if(lvlnum==6)
    sprintf(lvlname,"levelG");
  else if(lvlnum==7)
    sprintf(lvlname,"levelH");
  else if(lvlnum==8)
    sprintf(lvlname,"levelI");
  else if(lvlnum==9)
    sprintf(lvlname,"levelJ");
  else if(lvlnum==10)
    sprintf(lvlname,"levelK");
  else if(lvlnum==11)
    sprintf(lvlname,"levelL");
  else if(lvlnum==12)
    sprintf(lvlname,"levelM");
  else if(lvlnum==13)
    sprintf(lvlname,"levelN");
  else if(lvlnum==14)
    sprintf(lvlname,"levelO");
  else if(lvlnum==15)
    sprintf(lvlname,"levelP");
  else
    bombOut(26,lvlnum);

  sprintf(path,"Loading level %i ...",lvlnum+1);
  drawText(screen,path,sXoff+2,sYoff+2,64);

  // clear stuff

  for(x=0; x<maxthing; x++)
  {
    thing[x].stat=-1;
    thing[x].sprite=0;
  }
  for(x=0; x<maxbg; x++)
    bg[x].stat=-1;
  for(x=0; x<maxtimer; x++)
    timer[x].timer=-1;
  for(x=0; x<maxshrap; x++)
    sh[x].type=-1;
  for(x=4; x<maxcirc; x++)
    circ[x].life=-1;
  for(x=0; x<4; x++)
    rs[x].stat=-1;
  for(x=0; x<maxsound; x++)
    sndPlay[x]=0;

  flashMode=0;
  if(lvlnum==1)
    flashMode=1;

  tMax=0;
  quakeAmt=0;
  introCount=600;
  introSign=0;
  pauseStat=0;
  gCount=0;
  gStat=0;
  redrawStatus=1;
  bgPosX=60;
  showShield=-1;
  if(gOpt.lComp!=0)
    shieldAdd+=0.4;

  // setup player

  player.x=188;
  player.y=256;
  player.z=0;
  player.sx=0;
  player.sy=0;
  player.sz=0;
  player.stat=0;
  player.type=0;
  player.dir=0;
  play.invunStat=0;
  play.eCreated=0; play.eDestroyed=0;
  play.sCreated=0; play.sDestroyed=0;
  play.lostLife=1;
  play.silvDal=0;
  play.refBtn=0;
  play.wpnBtn=0;
  play.speed=0;
  play.dalCombo=0;
  play.dalComboBonus=0;

  copyActP(1);

  for(x=0; x<8; x++)
    play.wpn[x].timer=0;

  createWeapon(play.curWpn);

  // load sprites

  drawText(screen,"Loading sprites             ",sXoff+2,sYoff+10,64);

  for(x=sprMainOff; x<maxsprite; x++) // get rid of all sprites that aren't in sprite.dat
  {
    if(sprMain[x])
    {
      destroy_bitmap(sprMain[x]);
      sprMain[x]=NULL;
    }
  }
  for(x=sprMainOff; x<maxsprite2; x++)
    sprID[x]=-1;

  if(flashMode==0)
  {
    color_map=&flash_table_white;
    set_trans_blender(0,0,0,255);
  }
  if(flashMode==1)
  {
    color_map=&flash_table_red;
    set_trans_blender(0,0,0,255);
  }

  sprintf(path,"level/%s/%sspr.dat",lvlname,lvlname);
  loadImage(getPath(path),sprMainOff,22);
  color_map=&trans_table;
  set_trans_blender(0,0,0,128);

  // load tiles

  drawText(screen,"Loading tiles   ",sXoff+2,sYoff+10,64);

  for(x=0; x<maxtile; x++) // get rid of old tiles
  {
    if(tile[x])
    {
      destroy_rle_sprite(tile[x]);
      tile[x]=NULL;
    }

    tileStat[x].tile=TILE_EMPTY;
    tileStat[x].origTile=TILE_EMPTY;
    tileStat[x].next=TILE_EMPTY;
  }
  sprintf(path,"level/%s/%stile.dat",lvlname,lvlname);
  loadTile(getPath(path),5);

  // load data

  #ifndef xop_debug  
  readActObj(getPath("data/main.act"),actMain,sprMain,1);
  #endif

  #ifdef xop_debug
  loadGameData();  // this is so any modified game files will be reloaded
  #endif

  // load scripts

  drawText(screen,"Loading level data",sXoff+2,sYoff+10,64);

  for(x=0; x<maxscript; x++)
  {
    for(y=0; y<maxdatcom; y++)
      script[x].com[y]=0;
  }
  sprintf(path,"level/%s/%sscr.dat",lvlname,lvlname);
  readDatFile(getPath(path),script,1);

  // load maps

  for(x=0; x<maxbg; x++)
  {
    sprintf(path,"level/%s/%smap%i.dat",lvlname,lvlname,x);

    #ifndef xop_release
    if(!access(getPath(path),0))
      loadBgMap(x,getPath(path));
    #endif

    #ifdef xop_release
    if(verifyFile(getPath(path))==0)
      loadBgMap(x,getPath(path));
    #endif
  }

  // load map name

  sprintf(path,"level/%s/%sdesc.dat",lvlname,lvlname);

  #ifndef xop_release
  if((datfile=fopen(getPath(path),"r"))==NULL)
    bombOut(33,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(getPath(path));
  #endif

  x=0;
  while(!feof(datfile))
  {
    lvlDesc[x]=getc(datfile);
    x++;
  }
  lvlDesc[x]=NULL;

  fclose(datfile);

  // play music

  drawText(screen,"Loading music     ",sXoff+2,sYoff+10,64);

  sprintf(path,"mod/%s.xm",lvlname);
  //openMOD(getPath(path));

  // set up pallete

  setGamePal();
  pal[245].r=0; pal[245].g=0; pal[245].b=0;
  pal[246].r=32; pal[246].g=0; pal[246].b=0;

  clear(buffer);
  clear(bufStat);

  if(argh==0)
    argh=1;

  #ifdef xop_debug
  dalCount=0;
  for(x=0; x<bg[0].mapHt-8; x++)
  {
    if(bg[0].script[x]!=0) // is there a script here?
    {
      if(script[bg[0].script[x]].com[0]==1) // is this script a thing creator?
      {
        if(thingAct[script[bg[0].script[x]].com[1]].com[THINGACT_POWEXP]!=0) // does this thing explode w/ powerup?
        {
          y=thingAct[script[bg[0].script[x]].com[1]].com[THINGACT_POWEXP]; // set to the powerup expDef

          if(expDef[y].com[15]==play.dalType || expDef[y].com[15]==play.dalSilvType)
            z=100;
          else
            z=500;

          dalCount+=(script[bg[0].script[x]].com[10]*(expDef[y].com[16]+1))*z; // (number of enemies * number of DAL) * dal points
        }
      }
    }
  }
  #endif

  //bombOut(13,dalCount);
}



void loadBgMap(int theBg, char *path)
{
  int x,y,z;
  char temp;
  FILE *datfile;

  #ifndef xop_release
  if((datfile=fopen(path,"rb"))==NULL)
    bombOut(2,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  // read in initial settings

  temp=getc(datfile);

  bg[theBg].hspeed=(float)getNumPos(datfile)/10;
  bg[theBg].speed=(float)getNumPos(datfile)/10;
  bg[theBg].ground=getNumPos(datfile);
  bg[theBg].gDepth=getNumPos(datfile);
  bg[theBg].tsize=getNumPos(datfile);
  bg[theBg].mapW=getNumPos(datfile);
  bg[theBg].noShadow=getNumPos(datfile);

  //bg[theBg].mapWp=bg[theBg].mapW*bg[theBg].tsize;
  bg[theBg].mapWp=400;
  bg[theBg].mapH=300/bg[theBg].tsize;

  bg[theBg].scoff=0;
  bg[theBg].toff=0;
  bg[theBg].hoff=0;
  bg[theBg].stat=1;

  // reset background effect vars

  for(x=0; x<4; x++)
  {
    bg[theBg].e[x].effect=0;
    for(y=0; y<8; y++)
      bg[theBg].e[x].eVar[y]=0;
  }

  // read the entire map, counting the number of spaces
  // this becomes the total height of the map

  bg[theBg].mapHt=0;
  while(!feof(datfile))
  {
    temp=getc(datfile);

    if(temp==32)
      bg[theBg].mapHt++;
  }

  // allocate memory to the map and script list

  free(bg[theBg].map);
  if((bg[theBg].map=(unsigned char *)malloc(bg[theBg].mapW*bg[theBg].mapHt))==NULL)
  {
    fclose(datfile);
    bombOut(17,bg[theBg].mapW*bg[theBg].mapHt);
  }

  free(bg[theBg].script);
  if((bg[theBg].script=(unsigned char *)malloc(bg[theBg].mapHt))==NULL)
  {
    fclose(datfile);
    bombOut(17,bg[theBg].mapHt);
  }

  // rewind and skip initial settings

  rewind(datfile);
  for(x=0; x<37; x++)
    getc(datfile);

  // read the data from the map file into the map and script list

  y=0;
  while(!feof(datfile))
  {
    // read row of tiles

    z=y*bg[theBg].mapW;
    for(x=0; x<bg[theBg].mapW; x++)
      bg[theBg].map[x+z]=getc(datfile)-33;

    // read script call for this tile

    x=getNumPos(datfile);
    if(x<0 || x>=256)
    {
      fclose(datfile);
      bombOut(30,y);
    }
    bg[theBg].script[y]=(unsigned char)x; getc(datfile);

    y++;
  }

  // run script on first line

  runScript(bg[theBg].script[0]);

  fclose(datfile);
}







/*
void loadBgMap(int theBg, char *path)
{
  int x,y,z;
  char temp;
  FILE *datfile;

  #ifndef xop_release
  if((datfile=fopen(path,"rb"))==NULL)
    bombOut(2,0);
  #endif

  #ifdef xop_release
  datfile=openPackedFile(path);
  #endif

  // read in initial settings

  temp=getc(datfile);

  bg[theBg].hspeed=(float)getNumPos(datfile)/10;
  bg[theBg].speed=(float)getNumPos(datfile)/10;
  bg[theBg].ground=getNumPos(datfile);
  bg[theBg].gDepth=getNumPos(datfile);
  bg[theBg].tsize=getNumPos(datfile);
  bg[theBg].mapW=getNumPos(datfile);
  bg[theBg].noShadow=getNumPos(datfile);

  //bg[theBg].mapWp=bg[theBg].mapW*bg[theBg].tsize;
  bg[theBg].mapWp=400;
  bg[theBg].mapH=300/bg[theBg].tsize;

  bg[theBg].scoff=0;
  bg[theBg].toff=0;
  bg[theBg].hoff=0;
  bg[theBg].stat=1;

  // read the entire map, counting the number of spaces
  // this becomes the total height of the map

  bg[theBg].mapHt=0;
  while(!feof(datfile))
  {
    temp=getc(datfile);

    if(temp==' ')
      bg[theBg].mapHt++;
  }

  // rewind and skip initial settings (36 characters)
  rewind(datfile);
  for(x=0; x<35; x++)
    temp=getc(datfile);

  bombOut(13,bg[theBg].mapW);

  // allocate memory to the map and script list

  free(bg[theBg].map);
  if((bg[theBg].map=(unsigned char *)malloc(bg[theBg].mapW*bg[theBg].mapHt))==NULL)
  {
    fclose(datfile);
    bombOut(17,bg[theBg].mapW*bg[theBg].mapHt);
  }

  free(bg[theBg].script);
  if((bg[theBg].script=(unsigned char *)malloc(bg[theBg].mapHt))==NULL)
  {
    fclose(datfile);
    bombOut(17,bg[theBg].mapHt);
  }

  // read the data from the map file into the map and script list

  y=0;
  while(!feof(datfile))
  {
    z=y*bg[theBg].mapW;
    for(x=0; x<bg[theBg].mapW; x++)
      bg[theBg].map[x+z]=getc(datfile)-33;

    x=getNumPos(datfile);
    if(x<0 || x>=256)
    {
      fclose(datfile);
     bombOut(30,y);
   }
    bg[theBg].script[y]=(unsigned char)x;


//bg[theBg].script[y]=getNumPos(datfile);
//x=getc(datfile);
  
    y++;
  }

  // reset background effect vars

  for(x=0; x<4; x++)
  {
    bg[theBg].e[x].effect=0;
    for(y=0; y<8; y++)
      bg[theBg].e[x].eVar[y]=0;
  }

  // run script on first line

  runScript(bg[theBg].script[0]);

  fclose(datfile);
}

*/

void runScript(int theScr)
{
  int x=0,y,z,scrAct;
  char modPath[16];

  if(theScr<0 || theScr>maxscript)
    return;

  scrAct=script[theScr].com[0];

  if(scrAct<=0)
    return;

  if(scrAct==1)  // Make a thing
  {
    if(script[theScr].com[27]==0)
      makeThing(theScr);
    else
    {
      for(x=0; x<=script[theScr].com[10]; x++)
      {
        if(script[theScr].com[27]<900)
          makeTimer(script[theScr].com[27]*x,theScr,555);
        else
          makeTimer(((script[theScr].com[27]-900)*x)+(12-rand()%24),theScr,555);
      }
    }

    goto skipStuff;
  }

  if(scrAct==2)  // Set speed
  {
    if(script[theScr].com[1]<=0)
      play.speed=0;
    else if(script[theScr].com[1]>=900)
      play.speed=(float)(script[theScr].com[1]-900)/100;
    else
      play.speed=(float)script[theScr].com[1]/10;

    if(play.speed>=0 && play.speed<=0.5)
    {
      circ[1].size=3;
      circ[3].size=3;
    }

    if(play.speed>=0.6 && play.speed<=1)
    {
      circ[1].size=5;
      circ[3].size=5;
    }

    if(play.speed>=1.1 && play.speed<=1.5)
    {
      circ[1].size=7;
      circ[3].size=7;
    }
  }

  if(scrAct==3) // set music
  {
    
  }

  if(scrAct==4)
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].tid==script[theScr].com[1])
        showShield=x;
    }
  }

  if(scrAct==5) // repeat script
  {
    for(x=0; x<=script[theScr].com[1]; x++)
    {
      makeTimer(script[theScr].com[2]*x,script[theScr].com[3],0);
    }
  }

  if(scrAct==6) // set background layer y speed
    bg[script[theScr].com[2]].speed=(float)script[theScr].com[1]/10;

  if(scrAct==7) // set background layer x speed
    bg[script[theScr].com[2]].hspeed=(float)script[theScr].com[1]/10;

  if(scrAct==8) // set background layer ground
    bg[script[theScr].com[2]].ground=script[theScr].com[1];

  if(scrAct==9) // add to quake amt
    quakeAmt+=script[theScr].com[1];

  if(scrAct==10) // activate a shrapnel def
    makeShrapDef(script[theScr].com[1],script[theScr].com[2],script[theScr].com[3],script[theScr].com[4],0);

  if(scrAct==11) // activate a random script
  {
    if(gOpt.randMode==0)
    {
      runScript(script[theScr].com[1]);
    }
    if(gOpt.randMode==1)
    {
      x=(rand()%4)+1;
      runScript(script[theScr].com[x]);
    }
  }

  if(scrAct==12) // activate multiple scripts
  {
    runScript(script[theScr].com[1]);
    runScript(script[theScr].com[2]);
    runScript(script[theScr].com[3]);
    runScript(script[theScr].com[4]);
  }

  if(scrAct==13) // set shot type of a thing type
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].type==script[theScr].com[2])
      {
        thing[x].sType=script[theScr].com[1];
      }
    }
  }

  if(scrAct==14) // kill all things of this type
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].type==script[theScr].com[1])
      {
        killThing(x);
      }
    }
  }

  if(scrAct==15) // set shot type of thing with this tid
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].tid==script[theScr].com[2])
      {
        thing[x].sType=script[theScr].com[1];
      }
    }
  }

  if(scrAct==16) // kill all things with this tid
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].tid==script[theScr].com[1])
      {
        killThing(x);
      }
    }
  }

  if(scrAct==17) // delay then run script
  {
    makeTimer(script[theScr].com[1],script[theScr].com[2],0);
  }

  if(scrAct==18)
  {
    
  }

  if(scrAct==19) // play a sound
  {
    playSample(script[theScr].com[1],script[theScr].com[2]);
  }

  if(scrAct==20 && play.lives!=0) // win the level
  {
    openMOD(getPath("mod/endlevel.xm"));

    destroyWeapon(play.curWpn);

    gStat=1;
    introCount=600;
  }

  if(scrAct==21) // set background effect
  {
    if(bg[x].stat!=-1)
    {
      x=script[theScr].com[1];
      y=script[theScr].com[2];

      bg[x].e[y].effect=script[theScr].com[3];

      for(z=0; z<8; z++)
        bg[x].e[y].eVar[z]=script[theScr].com[4+z];
    }
  }

  if(scrAct==22) // set background draw range
  {
    bg[script[theScr].com[2]].mapH=(300*script[theScr].com[1])/bg[script[theScr].com[2]].tsize;
  }

  if(scrAct==23) // skip ahead tile rows
  {
    bg[script[theScr].com[2]].toff+=script[theScr].com[1];
  }

  if(scrAct==24) // rewind tile rows
  {
    bg[script[theScr].com[2]].toff-=script[theScr].com[1];
  }

  if(scrAct==25) // skip ahead to first found tile row with 1 for script call
  {
    x=bg[script[theScr].com[2]].toff;

    while(x<bg[script[theScr].com[2]].mapHt)
    {
      if(bg[script[theScr].com[2]].script[x]==script[theScr].com[1])
      {
        bg[script[theScr].com[2]].toff=x-bg[script[theScr].com[2]].mapH;
        goto foundCall;
      }

      x++;
    }
    foundCall:;
  }

  if(scrAct==26) // rewind to first found tile row with 1 for script call
  {
    x=bg[script[theScr].com[2]].toff;

    while(x>0)
    {
      if(bg[script[theScr].com[2]].script[x]==script[theScr].com[1])
      {
        bg[script[theScr].com[2]].toff=x;
        goto foundCall2;
      }

      x--;
    }
    foundCall2:;
  }

  if(scrAct==27) // boss warning
  {
    sprintf(modPath,"mod/boss0%i.xm",script[theScr].com[1]);
    //openMOD(getPath(modPath));

    gStat=2;
    introCount=600;
  }

  if(scrAct==28) // add to bg ground
  {
    bg[script[theScr].com[2]].ground+=script[theScr].com[1];
    bg[script[theScr].com[2]].gDepth+=script[theScr].com[1];
  }

  if(scrAct==29) // convert all shots to dal
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].type>0 && thing[x].type<maxdat2 && thing[x].stat==0)
      {
        if(thingDef[thing[x].type].com[THINGDEF_ISESHOT]!=0)
        {
          thing[x].type=play.dalType;
          copyActT(x,thingDef[play.dalType].com[THINGDEF_INITACT]);
          thing[x].tlimit+=rand()%8;

          thing[x].z=0;

          thing[x].sx=0;
          thing[x].sy=((rand()%20)*-1)/10;
          thing[x].sz=0;

          thing[x].gx=0;
          thing[x].gy=0.02;

          thing[x].rot=0;
          thing[x].srot=0;

          thing[x].shield=0.2;
        }
      }
    }
  }

  if(scrAct==250) // special end level thing
  {
    stopMOD();

    script[maxscript-1].com[0]=29;
    runScript(maxscript-1);

    script[maxscript-1].com[0]=20;

    makeTimer(480,maxscript-1,0);
  }

  skipStuff:

  x=script[theScr].com[31];
  if(x==888)
    x=theScr+1;
  if(x>0 && x!=theScr)
    runScript(x);
}