/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Main code file, all #includes, main()
*/

#define alleg_flic_unused
#define alleg_gui_unused
#define alleg_datafile_unused

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

#include "main.h"
#include "system.h"
#include "level.h"
#include "unpack.h"
#include "menu.h"
#include "play.h"
#include "file.h"
#include "input.h"
#include "draw.h"

/////////////////////////////

int main(int argc, char **argv)
{
  int x;
  char compare[16];
  char gPath[16];


#ifdef __BEOS__
int counti;
char datapath[256];
for (counti=strlen(argv[0]) ; argv[0][counti]!='/' ; counti--);
strncpy(datapath, argv[0], counti);
chdir(datapath);
#endif

  // allegro stuff

  allegro_init();

  install_timer();
  install_keyboard();
  install_mouse();

  // variables and command line stuff

  invun=0;
  powerup=0;
  backDoor=0;
  backDoorLevel=0;
  soundOff=0;

  srand(abs(time(NULL)));

  gOpt.noSound=0;
  gOpt.noMusic=0;
  gOpt.noJoyDetect=0;
  gOpt.vMode=0;
  gOpt.lSkip=0;

  sprintf(gOpt.game,"xop");

  if(soundOff==1)
  {
    gOpt.noSound=1;
    gOpt.noMusic=1;
  }

  // load options

  loadOptions();

  if(argc!=0)
  {
    for(x=0; x<argc; x++)
    {
      sprintf(compare,"-nosound");
      if(strcmp(argv[x], compare)==0)
      {
        gOpt.noSound=1;
        gOpt.noMusic=1;
      }

      sprintf(compare,"-nomusic");
      if(strcmp(argv[x], compare)==0)
        gOpt.noMusic=1;

      sprintf(compare,"-nojoy");
      //if(strcmp(argv[x], compare)==1)
        gOpt.noJoyDetect=1;

      sprintf(compare,"-res");
      if(strcmp(argv[x], compare)==0 && x+1<argc)
        gOpt.vMode=atoi(argv[x+1]);

      // special stuff

      sprintf(compare,"-god");
      if(strcmp(argv[x], compare)==0)
        invun=1;

      sprintf(compare,"-power");
      if(strcmp(argv[x], compare)==0)
        powerup=1;

      sprintf(compare,"-game");
      if(strcmp(argv[x], compare)==0 && x+1<argc)
        sprintf(gOpt.game,argv[x+1]);

      sprintf(compare,"-level");
      if(strcmp(argv[x], compare)==0 && x+1<argc)
        gOpt.lSkip=atoi(argv[x+1]);
    }
  }

  // init sound and graphics

  if(gOpt.noSound==0)
  {
    reserve_voices(24,-1);

    if(install_sound(DIGI_AUTODETECT, MIDI_NONE, 0)!=0) 
    {
      reserve_voices(-1, -1);

      if(install_sound(DIGI_AUTODETECT, MIDI_NONE, 0)!=0)
      {
        allegro_message("Ack!  XOP was unable to initialize sound.  You can still play with sound disabled.\n\n");
        gOpt.noSound=1;
        gOpt.noMusic=1;
      }
    }

    if(gOpt.noMusic==0)
    {
      if(install_mod(12)<0)
      {
        bombOut(18,0);
      }
    }
  }

  if(setScreenRes(0,gOpt.vMode)!=0)
    bombOut(8,0);

  // init joystick

  play.control=1;

  if(gOpt.noJoyDetect==0)
  {
    doJoyDetect(JOY_TYPE_AUTODETECT,1);

    #ifdef DJGPP
    if(play.control==1)
      doJoyDetect(JOY_TYPE_SIDEWINDER,1);

    if(play.control==1)
      doJoyDetect(JOY_TYPE_WINGWARRIOR,1);
    #endif
  }

  play.origCont=play.control;

  // load main packfile

  sprintf(gPath,"%s.dat",gOpt.game);
  #ifdef xop_release
  openPackfile(gPath);
  #endif

  // splash screen

  #ifndef xop_debug
  splashScreen();
  #endif

  // initsystem

  initSystem();

  set_mod_volume(gOpt.musicVol);

  if(backDoor==0)
    mainMenuInit();
  else
  {
    play.wpn1=0;
    play.wpn2=5;
    play.curWpn=0;

    initGame();
    loadLevel(backDoorLevel);
    gameLoop();
  }

  return 0;
}

END_OF_MAIN();