#ifndef xop_h_main
#define xop_h_main

// defines

#define xop_release    // uses xop.dat instead of normal file loads
//#define xop_debug      // show memory usage, display tCount

#define maxact         1024
#define maxthing       512
#define maxshrap       2048
#define maxscript      256
#define maxdat         128
#define maxdat2        256
#define maxdatcom      32
#define maxtimer       256
#define maxbg          16
#define maxcirc        128
#define maxtcirc       8

#define maxsprite      1024
#define maxsprite2     512
#define maxscspr       16     // max sprites for weapon select bitmap array
#define maxtile        128
#define maxsound       64

#define zdepth         256
#define zdepth0        -256

#define hsSize         10

// key

#define KEY_UP01 1
#define KEY_DOWN01 2
#define KEY_LEFT01 3
#define KEY_RIGHT01 4
#define KEY_ACTION01 5
#define KEY_ACTION02 6
#define KEY_ACTION03 7
#define KEY_ACTION04 8

// joy

#define JOY_ACTION01 1
#define JOY_ACTION02 2
#define JOY_ACTION03 3
#define JOY_ACTION04 4

// control

#define CONTROL_KEYBOARD 1
#define CONTROL_JOYSTICK 2

// input

#define INPUT_U  0
#define INPUT_D  1
#define INPUT_L  2
#define INPUT_R  3
#define INPUT_A1 4
#define INPUT_A2 5
#define INPUT_A3 6
#define INPUT_A4 7

// movement

#define MOVE_STILL 0
#define MOVE_UP    1
#define MOVE_DOWN  2
#define MOVE_LEFT  3
#define MOVE_RIGHT 4

#define STAT_NULL    -1
#define STAT_NORMAL   0
#define STAT_DYING    1
#define STAT_SHOOTING 2
#define STAT_HIT      3

// act list

#define ACT_STILL 0
#define ACT_LEFT 1
#define ACT_RIGHT 2
#define ACT_UNLEFT 3
#define ACT_UNRIGHT 4

// collision types

#define COLLISION_NONE   0 // does not collide with anything
#define COLLISION_PLAYER 1 // collides with player
#define COLLISION_ENEMY  2 // collides with enemy
#define COLLISION_BOTH   3 // collides with player and enemy

// thing def command types

#define THINGDEF_INITACT   0
#define THINGDEF_DAMLINK   1
#define THINGDEF_COLLISION 2
#define THINGDEF_COLDAMAGE 3
#define THINGDEF_RSINVUN   4
#define THINGDEF_LINKTYPE  5
#define THINGDEF_ZDEPTH    6
#define THINGDEF_FLICKER   7
#define THINGDEF_SHADOW    8
#define THINGDEF_TRANS     9
#define THINGDEF_POINTS    10
#define THINGDEF_LINKCLR   11
#define THINGDEF_SDEAD     12
#define THINGDEF_HITPSHOT  13
#define THINGDEF_SHOTSPEED 14
#define THINGDEF_PPCOL     16
#define THINGDEF_HIGHDRAW  17
#define THINGDEF_ADDSPEED  18
#define THINGDEF_DSPEED    19
#define THINGDEF_EC1       20
#define THINGDEF_ABOMB     21
#define THINGDEF_FC        22
#define THINGDEF_ROTCENTX  23
#define THINGDEF_ROTCENTY  24
#define THINGDEF_PLAYWPN   26
#define THINGDEF_RANGEAMT  27
#define THINGDEF_POWERUP   28
#define THINGDEF_ISESHOT   29
#define THINGDEF_ISPSHOT   30
#define THINGDEF_NOBOUND   31

// thing act command types

#define THINGACT_INITACT   0
#define THINGACT_POWEXP    1
#define THINGACT_DMGAMT    2
#define THINGACT_EXPTYPE   4
#define THINGACT_CLEAREXP  5
#define THINGACT_DEATHACT  9
#define THINGACT_SHRAPTYPE 11
#define THINGACT_DEATHSND  12
#define THINGACT_GROUNDHIT 15
#define THINGACT_LINKOFFX  19
#define THINGACT_LINKOFFY  20
#define THINGACT_RDISABLE  21
#define THINGACT_FIREACT   24
#define THINGACT_HITACT    25
#define THINGACT_HITSND    26
#define THINGACT_SHOTOFFX  27
#define THINGACT_SHOTOFFY  28
#define THINGACT_HITAMT    29
#define THINGACT_DEATHAMT  30
#define THINGACT_DCIRC     31

// playDef stuff

#define PLAYDEF_SPEED1       0
#define PLAYDEF_SPEED2       1

#define PLAYDEF_SHOTTYPE     0
#define PLAYDEF_SHOTTYPE2    1
#define PLAYDEF_BOMBTYPE     2
#define PLAYDEF_RSHOTTYPE    3
#define PLAYDEF_DALTYPE      4
#define PLAYDEF_VELOLINK     5
#define PLAYDEF_IMPLINK      6

// links

#define LINK_STATIC        0
#define LINK_STATICKEEP    1
#define LINK_SEMIFIXED     2
#define LINK_FREE          3
#define LINK_CHAIN         4
#define LINK_SNAKE         5
#define LINK_CHAINSNAKE    6

// tiles

#define TILE_SOLID        92
#define TILE_EMPTY        93

// player weapons

#define WEAPON_BOTS       0 // 4 bots, randomly bounce around player and fire, the longer fire button is held the less distance they move from player
#define WEAPON_VELOCITY   1 // rotates in 360 around player
#define WEAPON_LASER      2 // moves in -45 to 45 degree arc
#define WEAPON_MISSLES    3 // randomly swerve around like special weapon from gunbird 2, work using rot modifies speed/direction, rot speed and rot gravity
#define WEAPON_IMPLOSION  4 // latches onto enemy, crushes them, work using chainsnake link?
#define WEAPON_PLASMA     5 // plasma stream, move in direction player is steering (left, right)

#endif