/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Player functions
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
#include "tmake.h"
#include "draw.h"
#include "level.h"
#include "input.h"
#include "shrap.h"
#include "play.h"
//#include "file.h"
//#include "unpack.h"
#include "menu.h"
#include "circ.h"

void doPlayer()
{
  int x,y,d,x2,y2;
  static int cd1,cd2;
  static char cdText[8];
  float b,c;

  if(player.tlimit!=666 && player.stat!=-1)
  {
    player.timer++;

    if(player.timer==player.tlimit)
    {
      if(player.next==play.actlist[ACT_STILL] && player.stat!=MOVE_STILL)
        player.stat=MOVE_STILL;

      copyActP(player.next);
    }
  }

  // timers

  if(play.sTimer!=0)
    play.sTimer--;

  if(play.shotTimer!=0)
    play.shotTimer--;

  if(play.bombTimer!=0)
    play.bombTimer--;

  if(play.wpn[play.curWpn].timer!=0)
    play.wpn[play.curWpn].timer--;

  if(play.invunStat!=0)
    play.invunStat--;

  if(play.dalCombo!=0 && gOpt.gameMode==0)
    play.dalCombo--;
  if(play.dalCombo==0)
  {
    play.dalComboBonus=0;  redrawStatus=1;
  }

  if(play.curWpn==WEAPON_LASER)
  {
    if(play.wpn[play.curWpn].distance==0)
      play.wpn[play.curWpn].angle+=1.8;
    else
      play.wpn[play.curWpn].angle-=1.8;

    if(play.wpn[play.curWpn].angle>=32)
      play.wpn[play.curWpn].distance=1;
    if(play.wpn[play.curWpn].angle<=-32)
      play.wpn[play.curWpn].distance=0;
  }

  if(gOpt.gameMode==1)
    play.lives=999;

  if(player.dir>=1) // lost a life
  {
    player.dir++;

    if(player.dir>=100)
    {
      if(play.lives==0) // show continue screen
      {
        pauseStat=1;
        player.dir=-1;

        cd1=9; cd2=80;
      }
      else              // restore player
      {
        play.health=1;
        play.invunStat=160;
        player.dir=0;
        player.stat=0;
        play.refNum=3; redrawStatus=1;
        play.shotTimer=0;
        play.shotNum=0;

        player.y=256;

        if(play.curWpn==WEAPON_VELOCITY)
          createWeapon(play.curWpn);
      }
    }
  }

  if(player.dir==-1) // continue screen
  {
    cd2--;
    if(pInput[INPUT_A1])
      cd2-=2;

    if(cd2<=0)
    {
      cd1--;
      cd2=80;
      play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
    }

    if(cd1==-1)       // didn't continue, gameover
    {
      stopMOD();
      pauseStat=0;
      player.dir=-2;
    }

    if(key[KEY_ENTER]) // continued
    {
      play.health=1;
      play.lives=3;

      if(gOpt.skillMode==0)
        play.lives++;

      play.score=0;
      play.invunStat=160;
      player.dir=0;
      player.stat=0;
      play.refNum=3; redrawStatus=1;
      play.shotTimer=0;
      play.shotNum=0;

      player.y=256;

      if(play.curWpn==WEAPON_VELOCITY)
        createWeapon(play.curWpn);

      pauseStat=0;

      play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);
    }

    sprintf(cdText,"%i.%i",cd1,cd2);

    rectfill(sprPlay[12],11,19,96,27,16);
    drawText(sprPlay[12],cdText,11,19,64);

    return;
  }

  if(player.dir<=-2) // game over, count down
  {
    player.dir--;

    if(player.dir<=-320)
      mainMenuInit();
  }

  // hit detection for player and player shadow + layers

  player.drawShadow=888;

  for(y=0; y<maxbg; y++)
  {
    if(bg[y].stat!=-1)
    {
      if(player.z<bg[y].ground && player.z>bg[y].gDepth && play.invunStat==0)
      {
        b=calctX(player.x+12+bg[y].hoff,player.z);

        if(bg[y].hoff!=0)
        {
          if(b>bg[y].mapWp)
            b-=bg[y].mapWp;
          else if(b<=0-bg[y].mapWp)
            b+=bg[y].mapWp;
        }

        b/=bg[y].tsize;
        b=(int)b;

        c=calctY(player.y+6,player.z);
        c/=bg[y].tsize;
        c=(int)c;

        if(b>=bg[y].mapW)
          b-=bg[y].mapW;

        d=b+(((bg[y].mapH-c)+bg[y].toff)*bg[y].mapW);

        if((tile[tileStat[bg[y].map[d]].tile]!=NULL || bg[y].map[d]==TILE_SOLID) && tileStat[bg[y].map[d]].trans!=2)
        {
          play.health-=2;
          play.sTimer=2;
        }
      }

      if(player.z>=bg[y].ground && bg[y].noShadow==0)
      {
        b=calctX(player.x+bg[y].hoff,bg[y].ground);

        if(bg[y].hoff!=0)
        {
          if(b>bg[y].mapWp)
            b-=bg[y].mapWp;
          else if(b<=0-bg[y].mapWp)
            b+=bg[y].mapWp;
        }

        b/=bg[y].tsize;
        b=(int)b;

        c=calctY(player.y,bg[y].ground);
        c/=bg[y].tsize;
        c=(int)c;

        if(b>=bg[y].mapW)
          b-=bg[y].mapW;

        d=b+(((bg[y].mapH-c)+bg[y].toff)*bg[y].mapW);

        if(tile[bg[y].map[d]]!=NULL || bg[y].map[d]==TILE_SOLID)
          player.drawShadow=y;
      }
    }
  }

  // check for death

  if(play.health<=0 && player.stat!=-1 && invun==0)
  {
    player.tlimit=666;
    player.stat=-1;
    play.health=-1;

    play.refBtn=0;
    for(x=0; x<4; x++)
      rs[x].stat=-1;

    makeExp(player.x,player.y,player.z,1); makeExp(player.x,player.y,player.z,1);
    makeShrapDef(player.x+12,player.y+16,player.z,playDef[1].com[11],0);
    playSample(playDef[0].com[3],128);

    player.dir=1;
    play.lives--; redrawStatus=1;
    play.lostLife=0;
    play.dalCombo=0;
    play.dalComboBonus=0;

    if(play.curWpn==WEAPON_VELOCITY)
      destroyWeapon(play.curWpn);

    for(x=0; x<8; x++)
      pInput[x]=0;

    copyActP(1);
  }

  // reflect shields

  for(x=0; x<4; x++)
  {
    if(rs[x].stat!=-1)
    {
      // progress size

      rs[x].size+=rs[x].charge;

      if(rs[x].charge>0)
        rs[x].charge-=0.1;
      else
        rs[x].charge-=0.0225;

      if(rs[x].size<=0)
        rs[x].stat=-1;

      // check for enemy shots to reflect

      x2=(player.x+12)-rs[x].size;
      y2=(player.y+16)-rs[x].size;
      d=rs[x].size*2;

      for(y=0; y<maxthing; y++)
      {
        if(thing[y].stat==0)
        {
          if(thingDef[thing[y].type].com[THINGDEF_ISESHOT]!=0 && thingDef[thing[y].type].com[THINGDEF_RSINVUN]==0)
          {
            if(hit(x2,y2,0,
                   thing[y].x,thing[y].y,thing[y].z,
                   d,d,64,
                   thing[y].hrX2-thing[y].hrX1,thing[y].hrY2-thing[y].hrY1,thing[y].hrZ2))
            {
              if(tPshotCount>256)
              {
                clearThing(y); continue;
              }

              thing[y].z=0;
              thing[y].sx*=-1.6; thing[y].sy*=-1.6; thing[y].sz*=-1.6;
              thing[y].gx*=-1.6; thing[y].gy*=-1.6; thing[y].gz*=-1.6;

              if(thing[y].dirRot==0)
              {
                thing[y].rot*=-1;
                thing[y].srot*=-1;
              }

              thing[y].dTimer=256;
              thing[y].type=play.rShotType;
              copyActT(y,thingAct[play.rShotType].com[THINGACT_INITACT]);

              tPshotCount++;
            }
          }
        }
      }
    }
  }
}

void doPlayerShoot()
{
  int x,y;
  float z,tx,ty,tz,dx,dy,dz;

  if(pInput[INPUT_A1])
  {
    if(play.shotTimer==0) // main weapon
    {
      play.shotNum++;
      if(play.shotNum==play.shotMax)
      {
        play.shotTimer=play.shotTimerReload*2;
        play.shotNum=0;
      }
      else
        play.shotTimer=play.shotTimerReload;

      circ[2].life=4;
      if(play.shotNum%2!=0) // main shot and backshot
      {
        initThing(findEmptyT(), player.x+9,player.y-3,player.z, 0,-4,0, 0,play.shotType,0,thingDef[play.shotType].com[THINGDEF_INITACT],1);
        play.sCreated++;

        for(x=0; x<maxthing; x++) // find a thing to hit for backshot
        {
          if(thing[x].stat!=-1 && thing[x].stat!=1 && thing[x].shield>0)
          {
            if(thing[x].hitPshot==1 && thing[x].y>player.y && thing[x].y>300 && thing[x].z==0)
            {
              initThing(findEmptyT(), player.x+10,player.y+8,player.z, 0,4,0, 0,play.shotType2,0,thingDef[play.shotType2].com[THINGDEF_INITACT],1); // backshot
              goto doneShot;
            }
          }
        }
        doneShot:;
      }
      else // smaller twin shots
      {
        initThing(findEmptyT(), player.x+2,player.y+6,player.z, 0,-4,0, 0,play.shotType2,0,thingDef[play.shotType2].com[THINGDEF_INITACT],1);
        initThing(findEmptyT(), player.x+18,player.y+6,player.z, 0,-4,0, 0,play.shotType2,0,thingDef[play.shotType2].com[THINGDEF_INITACT],1);
      }
      playSample(0,128);
    }

    if(play.bombTimer==0) // bombs
    {
      play.bombTimer=play.bombTimerReload;

      for(x=0; x<maxthing; x++) // find a thing to hit for bomb
      {
        if(thing[x].stat!=-1 && thing[x].stat!=1 && thing[x].shield>0)
        {
          if(thing[x].hitPshot==1 && thingDef[thing[x].type].com[THINGDEF_ABOMB]==1)
          {
            if(hit2(player.x,player.y-280,thing[x].x+thing[x].hrX1,thing[x].y+thing[x].hrY1,
               24,280,thing[x].hrX3,thing[x].hrY3))
            {
              tx=thing[x].x+thing[x].w2;
              ty=thing[x].y+thing[x].h2;
              tz=thing[x].z-1;

              z=abs(tx-player.x+8)+abs(ty-player.y+13)+abs(tz-player.z);
              z=z*0.25; if(z==0) z=1;

              dx=(tx-player.x+8)/z;
              dy=(ty-player.y+13)/z;
              dz=(tz-player.z)/z;

              y=findEmptyT();
              initThing(y,player.x+8,player.y+13,player.z, 0,dy,dz, 0,play.bombType,0,thingDef[play.bombType].com[THINGDEF_INITACT],1);
              thing[y].tChase=x;
            }
          }
        }
      }
    }

    if(play.wpn[play.curWpn].timer==0) // secondary weapons
    {
      if(play.wpn[play.curWpn].wpnType==1)
      {
        play.wpn[play.curWpn].timer=play.wpn[play.curWpn].timerReload;

        if(play.curWpn==WEAPON_VELOCITY)
        {
          doVCFire();
          makeCircle(play.wpn[play.curWpn].mainThing,playDef[1].com[8]);
        }

        if(play.curWpn==WEAPON_LASER)
        {
          y=findEmptyT();
          initThing(y,player.x+12,player.y-3,player.z, 0,-6,0, 0,play.wpn[play.curWpn].shotType,0,thingDef[play.wpn[play.curWpn].shotType].com[THINGDEF_INITACT],1);
          thing[y].rot=play.wpn[play.curWpn].angle;
          thing[y].dirRot=1;

          if(play.wpn[2].level==3 || play.wpn[2].level==4)
            copyActT(y,playDef[6].com[8]);
          if(play.wpn[2].level==5 || play.wpn[2].level==6)
            copyActT(y,playDef[6].com[9]);
          if(play.wpn[2].level>=7)
            copyActT(y,playDef[6].com[10]);

          thing[y].x-=thing[y].w2;

          circ[0].oColor=13;
          circ[0].size=10;
          circ[0].life=4;

          playSample(playDef[6].com[7],128);
        }

        if(play.curWpn==WEAPON_MISSLES)
        {
          y=findEmptyT();
          initThing(y,player.x+12,player.y+12,player.z, 0,-1,0, 0,play.wpn[play.curWpn].shotType,0,thingDef[play.wpn[play.curWpn].shotType].com[THINGDEF_INITACT],1);

          if(play.wpn[3].level==3 || play.wpn[3].level==4)
            copyActT(y,playDef[7].com[8]);
          if(play.wpn[3].level==5 || play.wpn[3].level==6)
            copyActT(y,playDef[7].com[9]);
          if(play.wpn[3].level>=7)
            copyActT(y,playDef[7].com[10]);

          thing[y].x-=thing[y].w2;

          thing[y].gy=-0.08;
          if(rand()%2==0)
          {
            thing[y].rot=((rand()%16)+16);
            thing[y].srot=-0.6;
          }
          else
          {
            thing[y].rot=((rand()%16)+16)*-1;
            thing[y].srot=0.6;
          }

          thing[y].dirRot=1;
          thing[y].dTimer=256;

          circ[0].oColor=14;
          circ[0].size=14;
          circ[0].life=4;

          playSample(playDef[7].com[7],128);
        }

        if(play.curWpn==WEAPON_IMPLOSION)
        {
          y=findEmptyT();
          initThing(y,player.x+12,player.y-8,player.z, 0,-8,0, 0,play.wpn[play.curWpn].type,0,thingDef[play.wpn[play.curWpn].type].com[THINGDEF_INITACT],1);

          thing[y].x-=thing[y].w2;
          thing[y].shield=999;

          thing[y].tChase=play.wpn[play.curWpn].mainThing;
          copyAMT(y,playDef[1].com[9]);

          circ[0].oColor=24;
          circ[0].size=12;
          circ[0].life=2;
          circ[0].vib=3;
        }

        if(play.curWpn==WEAPON_PLASMA)
        {
               if(player.act==2 || player.act==6) // half-left
            z=-3;
          else if(player.act==3) // left
            z=-6;
          else if(player.act==4 || player.act==7) // half-right
            z=3;
          else if(player.act==5) // right
            z=6;
          else                   // straight
            z=0;

          z+=(10-(rand()%20))/100;

          y=findEmptyT();
          initThing(y,player.x+12,player.y-8,player.z, z,-10.5,0, 0,play.wpn[play.curWpn].shotType,0,thingDef[play.wpn[play.curWpn].shotType].com[THINGDEF_INITACT],1);

          if(play.wpn[5].level==3 || play.wpn[5].level==4)
            copyActT(y,playDef[9].com[8]);
          if(play.wpn[5].level==5 || play.wpn[5].level==6)
            copyActT(y,playDef[9].com[9]);
          if(play.wpn[5].level>=7)
            copyActT(y,playDef[9].com[10]);

          thing[y].x-=thing[y].w2;

          thing[y].rot=rand()%256;
          thing[y].srot=1.6;
          thing[y].shield=999;

          circ[0].oColor=10;
          circ[0].size=12;
          circ[0].life=2;
          circ[0].vib=3;

          playSample(playDef[9].com[7],128);
        }
      }
    }
  }
  else if(!pInput[INPUT_A1])
  {
    if(play.shotTimer==0)
      play.shotNum=0;
  }

  if(pInput[INPUT_A2])
  {
    if(play.refBtn==0 && play.refNum>0)
    {
      playSample(playDef[0].com[4],128);

      for(x=0; x<4; x++)
      {
        if(rs[x].stat==-1)
        {
          rs[x].stat=0;
          rs[x].size=22;
          rs[x].charge=5;
          goto madeRs;
        }
      }
      madeRs:

      play.refNum--; redrawStatus=1;
      play.refBtn=1;
    }
  }

  if(!pInput[INPUT_A2])
  {
    play.refBtn=0;
  }

  if(pInput[INPUT_A3])
  {
    if(play.wpnBtn==0)
    {
      if(play.curWpn==play.wpn1)
      {
        destroyWeapon(play.wpn1);
        createWeapon(play.wpn2);
        play.curWpn=play.wpn2;
      }
      else if(play.curWpn==play.wpn2)
      {
        destroyWeapon(play.wpn2);
        createWeapon(play.wpn1);
        play.curWpn=play.wpn1;
      }

      playSample(playDef[0].com[5],128);
      play.wpnBtn=1;
    }
  }

  if(!pInput[INPUT_A3])
  {
    play.wpnBtn=0;
  }
}

void doPlayerInput()
{
  #ifdef xop_debug
  if(key[KEY_H])
    player.z-=1;

  else if(key[KEY_Y])
    player.z+=1;

  if(key[KEY_N])
    player.z=0;
  #endif

  if(player.y>-8)
  {
    if(pInput[INPUT_U] && (pInput[INPUT_L] || pInput[INPUT_R])) 
      player.y-=play.spd2;
    else if(pInput[INPUT_U])
      player.y-=play.spd1;
  }

  if(player.y<270)
  {
    if(pInput[INPUT_D] && (pInput[INPUT_L] || pInput[INPUT_R]))
      player.y+=play.spd2;
    else if(pInput[INPUT_D])
      player.y+=play.spd1;
  }

  if(pInput[INPUT_L])
  {
    if(player.x>8)
    {
      if(pInput[INPUT_L] && (pInput[INPUT_D] || pInput[INPUT_U]))
        player.x-=play.spd2;
      else if(pInput[INPUT_L])
        player.x-=play.spd1;
    }
    if(player.stat!=MOVE_LEFT)
    {
      copyActP(play.actlist[ACT_LEFT]);
      player.stat=MOVE_LEFT;
    }
  }
  else if(pInput[INPUT_R])
  {
    if(player.x<372)
    {
      if(pInput[INPUT_R] && (pInput[INPUT_D] || pInput[INPUT_U]))
        player.x+=play.spd2;
      else if(pInput[INPUT_R])
        player.x+=play.spd1;
    }
    if(player.stat!=MOVE_RIGHT)
    {
      copyActP(play.actlist[ACT_RIGHT]);
      player.stat=MOVE_RIGHT;
    }
  }
  else
  {
    if(player.stat==MOVE_LEFT)
      copyActP(play.actlist[ACT_UNLEFT]);
    if(player.stat==MOVE_RIGHT)
      copyActP(play.actlist[ACT_UNRIGHT]);
    player.stat=MOVE_STILL;
  }

  doPlayerShoot();
}

void copyActP(int aNum)
{
  player.sprite=actPlay[aNum].sprite;
  player.tlimit=actPlay[aNum].timerLimit;
  player.offX=actPlay[aNum].offX;
  player.offY=actPlay[aNum].offY;

  player.act=aNum;
  player.next=actPlay[aNum].next;

  player.timer=0;

  // change circles

  if(actPlay[aNum].c0x!=666)
  {
    circ[3].x=actPlay[aNum].c0x; // engine 1
    circ[3].y=actPlay[aNum].c0y;

    circ[1].x=actPlay[aNum].c1x; // engine 2
    circ[1].y=actPlay[aNum].c1y;

    circ[2].x=actPlay[aNum].c2x; // shot circle 1
    circ[2].y=actPlay[aNum].c2y;

    circ[0].x=actPlay[aNum].c2x; // shot circle 2
    circ[0].y=actPlay[aNum].c2y;
  }
}

void doPlayerWeapon(int tNum)
{
  int wNum,y,b;
  float tx,ty,a,z;

  if(thing[tNum].type!=play.wpn[play.curWpn].type && thing[tNum].type!=play.wpn[play.curWpn].shotType)
    return;

  if(play.curWpn==WEAPON_BOTS)
  {
    wNum=WEAPON_BOTS;

    thing[tNum].timer++;

    if(thing[tNum].timer>=40) // shoot and move
    {
      thing[tNum].timer=0;

      if(pInput[INPUT_A1]) // shoot a bot shot (hehe)
      {
        y=findEmptyT();
        initThing(y,thing[tNum].x+4,thing[tNum].y,thing[tNum].z-0.1, 0,-3.5,0, 0,play.wpn[wNum].shotType,0,thingDef[play.wpn[wNum].shotType].com[THINGDEF_INITACT],1);

        if(play.wpn[0].level==3 || play.wpn[0].level==4)
          copyActT(y,playDef[4].com[8]);
        if(play.wpn[0].level==5 || play.wpn[0].level==6)
          copyActT(y,playDef[4].com[9]);
        if(play.wpn[0].level>=7)
          copyActT(y,playDef[4].com[10]);

        thing[y].srot=16;

        makeCircle(tNum,1);
      }

      // destination is player position w/ random amount

      tx=(play.wpn[wNum].distance/2)-(rand()%play.wpn[wNum].distance);
      tx+=(player.x+8);
      ty=(play.wpn[wNum].distance/2)-(rand()%play.wpn[wNum].distance);
      ty+=(player.y+12);
      a=42;

      z=abs(tx-thing[tNum].x)+abs(ty-thing[tNum].y);
      a/=100; z=z*a; if(z==0) z=1;

      thing[tNum].sx=(tx-thing[tNum].x)/z;
      thing[tNum].sy=(ty-thing[tNum].y)/z;

      if(thing[tNum].sx>0)
        thing[tNum].gx=-0.015;
      else
        thing[tNum].gx=0.015;

      if(thing[tNum].sy>0)
        thing[tNum].gy=-0.015;
      else
        thing[tNum].gy=0.015;
    }
  }

  if(play.curWpn==WEAPON_VELOCITY)
  {
    wNum=WEAPON_VELOCITY;

    a=1; // rotation speed

    if(pInput[INPUT_L])
    {
      if(thing[tNum].rot>-25)
      {
        if(thing[tNum].rot>0)
          thing[tNum].rot-=a*3.5; // move faster if on the other side
        else
          thing[tNum].rot-=a;
      }
    }
    else if(pInput[INPUT_R])
    {
      if(thing[tNum].rot<25)
      {
        if(thing[tNum].rot<0)
          thing[tNum].rot+=a*3.5; // move faster if on the other side
        else
          thing[tNum].rot+=a;
      }
    }
    else
    {
      b=0;
      if(thing[tNum].rot>0)
      {
        thing[tNum].rot-=a*2;
        b=1;
      }
      if(thing[tNum].rot<0)
      {
        if(b==1)
          thing[tNum].rot=0;
        else
          thing[tNum].rot+=a*2;
      }
    }

    rotPos(7-thing[tNum].w2,(-21+(play.wpn[wNum].timer/11))-thing[tNum].h2,thing[tNum].rot/41);

    thing[tNum].x=player.x+rx+thing[tNum].w2;
    thing[tNum].y=player.y+ry+thing[tNum].h2;

    if(play.wpn[1].level==3 || play.wpn[1].level==4)
      copyActT(tNum,playDef[5].com[8]);
    if(play.wpn[1].level==5 || play.wpn[1].level==6)
      copyActT(tNum,playDef[5].com[9]);
    if(play.wpn[1].level>=7)
      copyActT(tNum,playDef[5].com[10]);
  }

  if(play.curWpn==WEAPON_IMPLOSION)
  {
    wNum=WEAPON_IMPLOSION;

    thing[tNum].shield=99999;

    y=play.wpn[wNum].mainThing;

    if(thing[y].type!=play.wpn[wNum].shotType || thing[y].stat==-1)
    {
      destroyWeapon(wNum);
      createWeapon(wNum);
      y=play.wpn[wNum].mainThing;
    }

    // for implosion chain

    if(thing[tNum].type==play.wpn[wNum].type)
    {
      if(gCount%2==0 && thing[y].tLink!=-1)
      {
        b=(thing[y].w2+thing[y].h2)+20;

        if(hit2(thing[y].x,thing[y].y,thing[tNum].x,thing[tNum].y,
                b,b,thing[tNum].hrX2,thing[tNum].hrY2))
        {
          clearThing(tNum);
          play.wpn[wNum].distance+=play.wpn[wNum].timerReload;
        }
      }

      return;
    }

    // for implosion circle

    if(thing[tNum].tLink==-1) // if not attached to a target
    {
      thing[tNum].x=player.x+5;
      thing[tNum].y=-1024;
      thing[tNum].z=0;
      thing[tNum].sx=0;
      thing[tNum].sy=0;
      thing[tNum].sz=0;
      thing[tNum].zScale=0;

      thing[tNum].hrX1=0;
      thing[tNum].hrX2=128;
      thing[tNum].hrX3=128;
      thing[tNum].hrY1=0;
      thing[tNum].hrY2=128;
      thing[tNum].hrY3=128;
      thing[tNum].w2=0;
      thing[tNum].h2=0;
    }
    else // if attached to a target
    {
      y=thing[tNum].tLink;

      if(thing[y].rot!=64 && thing[y].rot!=128 && thing[y].rot!=192)
      {
        thing[y].x+=(float)thing[y].zScale/2;
        thing[y].y+=(float)thing[y].zScale/2;
        thing[y].zScale=0-(rand()%(6+play.wpn[wNum].level));
        thing[y].x-=(float)thing[y].zScale/2;
        thing[y].y-=(float)thing[y].zScale/2;
      }

      if(play.wpn[4].level==1 || play.wpn[4].level==2)
        copyActT(tNum,playDef[8].com[11]);
      if(play.wpn[4].level==3 || play.wpn[4].level==4)
        copyActT(tNum,playDef[8].com[8]);
      if(play.wpn[4].level==5 || play.wpn[4].level==6)
        copyActT(tNum,playDef[8].com[9]);
      if(play.wpn[4].level>=7)
        copyActT(tNum,playDef[8].com[10]);

      thing[tNum].zScale=(-128-(play.wpn[wNum].distance/14))+(thing[y].w2+thing[y].h2)+(play.wpn[wNum].level*2)+12;
      thing[tNum].zScale+=rand()%(int)((thing[tNum].zScale+128)/4);

      b=thing[tNum].zScale/2;
      thing[tNum].x=(thing[y].x+(thing[y].w2-b))-64; thing[tNum].x-=2.5;
      thing[tNum].y=(thing[y].y+(thing[y].h2-b))-64; thing[tNum].x-=2.5;
      thing[tNum].z=thing[y].z;
      thing[tNum].rot=rand()%256;

      thing[tNum].hrX1=0;
      thing[tNum].hrX2=thing[tNum].zScale+128;
      thing[tNum].hrX3=thing[tNum].zScale+128;
      thing[tNum].hrY1=0;
      thing[tNum].hrY2=thing[tNum].zScale+128;
      thing[tNum].hrY3=thing[tNum].zScale+128;

      thing[tNum].w2=thing[y].w2+1;
      thing[tNum].h2=thing[y].h2+1;

      play.wpn[wNum].distance--;
      if(play.wpn[wNum].distance<=0 || thing[tNum].x<bgPosX-thing[tNum].w2*2 || thing[tNum].x>280+bgPosX)
        hideImplosion();

      if(gCount%38==0)
      {
        playSample(playDef[8].com[7],128);
        makeShrapDef(thing[y].x+thing[y].w2,thing[y].y+thing[y].h2,thing[y].z,playDef[1].com[10],y);
      }
    }
  }
}

void createWeapon(int wNum)
{
  int x,y;

  if(wNum==WEAPON_BOTS) // bots
  {
    play.wpn[wNum].distance=100;

    for(x=0; x<4; x++)
    {
      y=findEmptyT();
      initThing(y,player.x+5,player.y+9,player.z, 0,0,0, 0,play.wpn[wNum].type,0,thingDef[play.wpn[wNum].type].com[THINGDEF_INITACT],1);
      thing[y].tlimit=666;
      thing[y].timer=x*10;
    }
  }

  if(wNum==WEAPON_VELOCITY) // velocity cannon
  {
    y=findEmptyT();
    initThing(y,-640,-640,player.z, 0,0,0, 0,play.wpn[wNum].shotType,0,thingDef[play.wpn[wNum].shotType].com[THINGDEF_INITACT],1);

    if(play.wpn[1].level==3 || play.wpn[1].level==4)
      copyActT(y,playDef[5].com[8]);
    if(play.wpn[1].level==5 || play.wpn[1].level==6)
      copyActT(y,playDef[5].com[9]);
    if(play.wpn[1].level>=7)
      copyActT(y,playDef[5].com[10]);

    thing[y].tLink=-1;
    thing[y].tLinkType=-1;
    thing[y].shield=90000;

    play.wpn[wNum].mainThing=y;
  }

  if(wNum==WEAPON_LASER) // laser
  {
    play.wpn[wNum].distance=0;
    play.wpn[wNum].angle=0;
  }

  if(wNum==WEAPON_MISSLES) // missles
  {
    
  }

  if(wNum==WEAPON_IMPLOSION) // implosion
  {
    y=findEmptyT();
    initThing(y,player.x,-1024,player.z, 0,0,0, 0,play.wpn[wNum].shotType,0,thingDef[play.wpn[wNum].shotType].com[THINGDEF_INITACT],1);

    if(play.wpn[4].level==1 || play.wpn[4].level==2)
      copyActT(y,playDef[8].com[11]);
    if(play.wpn[4].level==3 || play.wpn[4].level==4)
      copyActT(y,playDef[8].com[8]);
    if(play.wpn[4].level==5 || play.wpn[4].level==6)
      copyActT(y,playDef[8].com[9]);
    if(play.wpn[4].level>=7)
      copyActT(y,playDef[8].com[10]);

    thing[y].tLink=-1;
    thing[y].tLinkType=-1;
    thing[y].shield=90000;

    play.wpn[wNum].mainThing=y;
  }

  if(wNum==WEAPON_PLASMA) // plasma
  {
    
  }
}

void destroyWeapon(int wNum)
{
  int x;

  if(wNum==WEAPON_BOTS || wNum==WEAPON_VELOCITY || wNum==WEAPON_IMPLOSION)
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].type==play.wpn[wNum].type && wNum!=WEAPON_IMPLOSION)
        clearThing(x);
      if(thing[x].type==play.wpn[wNum].shotType && wNum!=WEAPON_BOTS)
        clearThing(x);

      if(wNum==WEAPON_IMPLOSION)
      {
        if(thing[x].type==play.wpn[wNum].type)
          thing[x].amTimerLimit=666;
      }
    }
  }
}

int upgradeWeapon(int wNum, int dalAmt)
{
  int lvlUpNum;

  if(play.wpn[wNum].level>=9)
    return 0;

  lvlUpNum=0;
  play.wpn[wNum].dalUpCount+=dalAmt;

  while(play.wpn[wNum].dalUpCount>=play.wpn[wNum].dalUpgrade) // upgrade the weapon
  {
    play.wpn[wNum].dalUpCount-=play.wpn[wNum].dalUpgrade;
    play.wpn[wNum].damageUp+=play.wpn[wNum].damage/6;
    play.wpn[wNum].level++;
    lvlUpNum++;
  }

  return lvlUpNum;
}

void hideImplosion() // this is about as close as yer gettin to OO around here :p
{
  int x,y;

  y=play.wpn[4].mainThing;

  x=thing[y].tLink;
  if(x!=-1)
  {
    thing[x].x+=(float)thing[x].zScale/2;
    thing[x].y+=(float)thing[x].zScale/2;
    thing[x].zScale=0;
  }

  for(x=0; x<maxthing; x++)
  {
    if(thing[x].type==play.wpn[4].type && thing[x].y<thing[y].y+thing[y].w2)
      clearThing(x);
  }

  thing[y].tLink=-1;
  thing[y].y=-1024;
  thing[y].hrX2=128;
  thing[y].hrY2=128;
}

void doVCFire()
{
  int y,tNum;
  float xPos,yPos;
  tNum=play.wpn[1].mainThing;

  rotPos(3,0,thing[tNum].rot/41);
  xPos=thing[tNum].x+rx;
  yPos=thing[tNum].y+ry;

  rotPos(0,-4,thing[tNum].rot/41);

  while(xPos>0 && xPos<400 && yPos>0)
  {
    xPos+=rx;
    yPos+=ry;

    y=findEmptyT();
    initThing(y,xPos,yPos,player.z, 0,0,0, 0,play.wpn[1].type,0,thingDef[play.wpn[1].type].com[THINGDEF_INITACT],2);
    thing[y].dTimer=3;
    thing[y].rot=thing[tNum].rot;
  }

  playSample(playDef[5].com[7],128);
}