#ifndef xop_h_play
#define xop_h_play

#include "thing.h"

typedef struct weaponObj
{
  int type;     // thing type for main object
  int shotType; // thing type for fired object
  int wpnType;  // type of weapon
  int timer;
  int timerReload;
  int num;
  int max;
  int level;
  int distance;
  int fSound;
  int mainThing;
  int dalUpgrade;
  int dalUpCount;
  float angle;
  float weight;
  float damage;
  float damageUp;
} weaponObj;

typedef struct playObj
{
    int control;
    int origCont;
    int keydef[10];
    int joydef[6];
    int actlist[8];

    int dalType;
    int dalSilvType;

    int shotType;
    int shotType2;
    int shotTimer;
    int shotTimerReload;
    int shotNum;
    int shotMax;
    int shotLevel;
    float shotDamage;

    int bombType;
    int bombTimer;
    int bombTimerReload;
    int bombLevel;
    float bombDamage;

    struct weaponObj wpn[8];

    int curWpn;
    int wpn1,wpn2;
    int wpnBtn;

    int rShotType;
    int rShotLevel;
    float rShotDamage;

    int refNum;
    int refBtn;

    int health;
    int dal;
    int dalCombo;
    int dalComboBonus;
    int silvDal;
    int sTimer;
    int lives;
    int invunStat;
    int lostLife;

    float eCreated;   // total enemies created
    float eDestroyed; // total enemies destroyed

    float sCreated;   // total shots created
    float sDestroyed; // total shots destroyed

    float speed,spd1,spd2;

    unsigned long score;
} playObj;

typedef struct rsObj
{
  int stat;
  float charge,size;
} rsObj;

struct tObj player;
struct playObj play;
struct rsObj rs[4];

void doPlayer();
void doPlayerShoot();
void doPlayerInput();    // called from doInput();
void copyActP(int aNum);

void doPlayerWeapon(int tNum);
void createWeapon(int wNum);
void destroyWeapon(int wNum);
int upgradeWeapon(int wNum, int dalAmt);

void hideImplosion();
void doVCFire();

#endif