#ifndef xop_h_system
#define xop_h_system

typedef struct gameOpt
{
  int gameMode,vMode,skillMode,skillVar,randMode,expMode,soundVol,musicVol,
      noJoyDetect,noSound,noMusic;

  char game[8];
  int level;
  int lComp,lSkip;
  int lOrder[16];
} gameOpt;

typedef struct actObj
{
    int sprite;
    int timerLimit;
    int next;

    int hrX1,hrY1;
    int hrX2,hrY2;
    int hrX1b,hrX2b;
    int hrW,hrH;

    int c0x,c0y,c1x,c1y,c2x,c2y;

    int offX,offY;

    int w2,h2;

    int movement;
} actObj;

typedef struct datObj
{
  int com[maxdatcom];
  int loaded;
} datObj;

typedef struct highScoreObj
{
  unsigned long score;
  int skill;
  int lComp;
  char name[4];
} highScoreObj;

volatile int sCount;
int sCountDrawOk;

unsigned int gCount;
int sMax,tMax,tCount,tPshotCount,tPshotHitCount,bgCount,quakeAmt,sZoom,bgPosX,showRects,dirtyScreen;
int introCount,introSign,gStat,showShield,pauseStat,sprMainOff,flashMode;
int sXoff,sYoff,palOk,redrawStatus,closeButton;

int invun,powerup,backDoor,backDoorLevel,soundOff; // special stuff

int sndPlay[maxsound];

float rx,ry,shieldAdd;

char lvlDesc[32];

struct gameOpt gOpt;

struct actObj actPlay[16];
//struct actObj actMain[maxact];
actObj *actMain;

struct datObj script[maxscript];
struct datObj thingDef[maxdat2];
struct datObj thingAct[maxdat2];
struct datObj shotDef[maxdat];
struct datObj moveDef[maxdat];
struct datObj circleDef[maxdat];
struct datObj linkDef[maxdat];
struct datObj expDef[maxdat];
struct datObj shrapDef[maxdat];
struct datObj playDef[16];

datObj *thingDefP;
datObj *thingActP;

struct highScoreObj hs[hsSize+4];
struct highScoreObj hs2[hsSize+4];

SAMPLE *snd[maxsound];
JGMOD *gMusic;

void initSystem();             // called once
void loadGameData();

void initGame();               // called at start of new game
void gameLoop();               // main game loop
void doQuit();                 // frees memory, shows quit message

void closeWindow();

void doStdInput();

/*__inline*/ int calctX(float X, float Z); // gives 3d-to-2d x variable
/*__inline*/ int calctY(float Y, float Z); // gives 3d-to-2d y variable
/*__inline*/ float calctXF(float X, float Z); // gives 3d-to-2d x variable
/*__inline*/ float calctYF(float Y, float Z); // gives 3d-to-2d y variable

/*__inline*/ int hit(int x1, int y1, int z1, int x2, int y2, int z2, int xs1, int ys1, int zs1, int xs2, int ys2, int zs2); // hit detect
/*__inline*/ int hit2(int x1, int y1, int x2, int y2, int xs1, int ys1, int xs2, int ys2); // simpler hit detect
             int hitpp(BITMAP *sprite1, BITMAP *sprite2, int x1, int y1, int x2, int y2);
/*__inline*/ void rotPos(float x, float y, float t); // rotate position

/*__inline*/ int comp(const int *i, const int *j);                      // used for sorts
/*__inline*/ int compL(const unsigned long *i, const unsigned long *j); // used for highscore

void sCountAdd();           // FPS counter stuff
void sCountAdd_end();
void resetCounter();
void resetCounter_end();
void waitCounter();
void waitCounter_end();
/*__inline*/ void blitToScreen();

void restoreDisplay();
void drawGameBorder();
int setScreenRes(int col, int res);

void playSample(int theSnd, int panning);
int getStereoPan(int posX);
void setTrans(int stat);    // changes transparency
BITMAP *readPNG(char *fName);
FILE *openPackedFile(char *fName);
void openMOD(char *fName);
void stopMOD();
/*__inline*/ char* getPath(char *fPath);   // returns path with gOpt.game added to it
void screenShot();             // takes screenshot
void giveFlashColor(AL_CONST PALETTE pal, int x, int y, RGB *rgb);
void giveFlashColorRed(AL_CONST PALETTE pal, int x, int y, RGB *rgb);
void setGamePal();
int getColor(int theCol);
int makeRGBfromPal(int palCol);
void putpixel8(BITMAP *theBmp, int x, int y, int c);
int getpixel8(BITMAP *theBmp, int x, int y);

void bombOut(int error, int num);       // used for errors
void bombOutText(int error, char *text);

#endif