/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Thing functions (huge!)
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
#include "tmake.h"
#include "draw.h"
#include "level.h"
//#include "input.h"
#include "shrap.h"
#include "play.h"
//#include "file.h"
//#include "unpack.h"
//#include "menu.h"
#include "circ.h"

void initThing(int tNum, float ix, float iy, float iz, float isx, float isy, float isz, 
               int idir, int itype, int istat, int iact, float ishield)
{
  memset((tObj *)thing+tNum,0,sizeof(tObj)); // clear the object

  thing[tNum].x=ix; thing[tNum].y=iy; thing[tNum].z=iz;
  thing[tNum].sx=isx; thing[tNum].sy=isy; thing[tNum].sz=isz;
  thing[tNum].stat=istat; thing[tNum].type=itype; thing[tNum].dir=idir;

  if(ishield==999)
    ishield=900000;
  if(ishield==1 || ishield==0)
    ishield=0.2;
  if(ishield>=900 && ishield<=999)
    ishield=(ishield-900)/10;

  thing[tNum].shield=ishield;
  thing[tNum].sMax=ishield;

  if(thingDef[itype].com[THINGDEF_SHADOW]==0)
    thing[tNum].drawShadow=-1;

  thing[tNum].groundHit=thingAct[itype].com[THINGACT_GROUNDHIT];
  thing[tNum].hitPshot=thingDef[itype].com[THINGDEF_HITPSHOT];
  thing[tNum].hrZ2=thingDef[itype].com[THINGDEF_ZDEPTH];

  thing[tNum].circ[0]=-1; thing[tNum].circ[1]=-1; thing[tNum].circ[2]=-1; thing[tNum].circ[3]=-1;
  thing[tNum].circ[4]=-1; thing[tNum].circ[5]=-1; thing[tNum].circ[6]=-1; thing[tNum].circ[7]=-1;

  thing[tNum].sTimerLimit=666; thing[tNum].amTimerLimit=666; thing[tNum].dTimer=666;
  thing[tNum].tLink=-1; thing[tNum].tLink2=-1; thing[tNum].tLink3=-1;
  thing[tNum].tLinkNum=0; thing[tNum].tLinkNumDam=0;
  thing[tNum].tChase=-1;

  copyActT(tNum,iact);
}

/* parts of doThings()

function for player weapons

time to live timer
action timer
shot timer
automovement timer

speed movement
gravity movement

links
visible damage

hit detection for player + thing distance
hit detection for player + things
hit detection for things + things
hit detection for things + bg
hit detection for thing shadows + bg
out of bounds detection

*/

void doThings()
{
  int x;

  for(x=0; x<maxthing; x++)
  {
    if(thing[x].stat!=-1)
    {
      thingDefP=thingDef+thing[x].type;
      thingActP=thingAct+thing[x].type;

      if(thing[x].flash==1)
        thing[x].flash=0;

      if(thingDefP->com[THINGDEF_PLAYWPN]==1)
        doPlayerWeapon(x);

      doThingTimers(x);
      if(thing[x].stat==-1) continue;
      doThingMovement(x);
      if(thing[x].stat==-1) continue;
      doThingLinks(x);
      if(thing[x].stat==-1) continue;
      doThingHit(x);
    }
  }
}

void doThingTimers(int tNum)
{
  register int x=tNum;

  // death timer

  if(thing[x].dTimer!=666)
  {
    thing[x].dTimer--;
    if(thing[x].dTimer==0)
    {
      killThing(x);
      if(thing[x].stat==-1)
        return;
    }
  }

  // action timer

  if(thing[x].tlimit!=666)
  {
    thing[x].timer++;

    if(thing[x].timer==thing[x].tlimit)
    {
      if(thing[x].next==thingActP->com[THINGACT_INITACT])
        thing[x].stat=STAT_NORMAL;

      if(thing[x].next==0)
      {
        clearThing(x);
        return;
      }
      else
        copyActT(x,thing[x].next);
    }
  }

  // shot timer

  if(thing[x].sTimerLimit!=666)
  {
    thing[x].sTimer++;

    if(thing[x].sTimer==thing[x].sTimerLimit)
    {
      if(thing[x].sNext==0) // if it's the end of this shot pattern, set wait period
      {
        thing[x].sTimer=0;

        if(thing[x].sWait==888)
          thing[x].sTimerLimit=rand()%172-(gOpt.skillVar*16);
        else if(thing[x].sWait==999)
          thing[x].sTimerLimit=64000;
        else
          thing[x].sTimerLimit=thing[x].sWait;

        if(thing[x].sCutoffNext==0)
          thing[x].sNext=thing[x].sType;
        else
          thing[x].sNext=thing[x].sCutoffNext;

        thing[x].sRotInc=0;
        thing[x].sSpdInc=0;
        thing[x].sCutoffNext=0;
      }
      else // if still shooting this shot pattern
      {
        doThingShoot(x,thing[x].sNext);

        if(thing[x].sCutoff!=0)
        {
          thing[x].sCutoff--;

          if(thing[x].sCutoff<=0) // if end of cutoff
          {
            thing[x].sTimer=0;

            if(thing[x].sWait==888)
          thing[x].sTimerLimit=rand()%172-(gOpt.skillVar*16);
            else if(thing[x].sWait==999)
          thing[x].sTimerLimit=64000;
            else
          thing[x].sTimerLimit=thing[x].sWait;

            if(thing[x].sCutoffNext==0)
          thing[x].sNext=thing[x].sType;
            else
          thing[x].sNext=thing[x].sCutoffNext;

            thing[x].sRotInc=0;
            thing[x].sSpdInc=0;
            thing[x].sCutoffNext=0;
          }
        }
      }
    }
  }

  // shot disable

  if(thingActP->com[THINGACT_RDISABLE]!=0)
    if(thing[x].y>thingActP->com[THINGACT_RDISABLE])
      thing[x].sTimerLimit=666;

  // automovement timer

  if(thing[x].amTimerLimit!=666)
  {
    thing[x].amTimer++;

    if(thing[x].amTimer==thing[x].amTimerLimit)
    {
      if(thing[x].amNext==0)
        thing[x].amTimerLimit=666;
      else
        copyAMT(x,thing[x].amNext);
    }
  }
}

void doThingMovement(int tNum)
{
  register int x=tNum;

  // add player speed constantly

  if(thingDefP->com[THINGDEF_ADDSPEED]==1)
    thing[x].y+=play.speed;

  // speed movement

  if(thing[x].dirRot==1) // thing rotation effects direction
  {
    rotPos(thing[x].sx,thing[x].sy,thing[x].rot/41);

    if(thing[x].dir==0)
      thing[x].x+=rx;
    if(thing[x].dir==1)
      thing[x].x-=rx;

    thing[x].y+=ry;
  }
  else
  {
    if(thing[x].dir==0)
      thing[x].x+=thing[x].sx;
    if(thing[x].dir==1)
      thing[x].x-=thing[x].sx;

    thing[x].y+=thing[x].sy;
  }
  thing[x].z+=thing[x].sz;
  thing[x].rot+=thing[x].srot;

  // gravity movement

  if(thing[x].gx>0.8)
  {
    if(thing[x].x>thing[x].tx)
      thing[x].sx-=thing[x].gx-0.8;
    else
      thing[x].sx+=thing[x].gx-0.8;
  }
  else
    thing[x].sx+=thing[x].gx;

  if(thing[x].gy>0.8)
  {
    if(thing[x].y>thing[x].ty)
      thing[x].sy-=thing[x].gy-0.8;
    else
      thing[x].sy+=thing[x].gy-0.8;
  }
  else
    thing[x].sy+=thing[x].gy;

  thing[x].sz+=thing[x].gz;
  thing[x].srot+=thing[x].grot;

  // speed limiter

  if(thing[x].slimit!=0)
  {
    if(thing[x].sx>thing[x].slimit)
      thing[x].sx=thing[x].slimit;
    if(thing[x].sx<0-thing[x].slimit)
      thing[x].sx=0-thing[x].slimit;

    if(thing[x].sy>thing[x].slimit)
      thing[x].sy=thing[x].slimit;
    if(thing[x].sy<0-thing[x].slimit)
      thing[x].sy=0-thing[x].slimit;

    if(thing[x].sz>thing[x].slimit)
      thing[x].sz=thing[x].slimit;
    if(thing[x].sz<0-thing[x].slimit)
      thing[x].sz=0-thing[x].slimit;
  }
}

void doThingLinks(int tNum)
{
  register int x=tNum;
  int d,e;
  float trans;

  if(thing[x].tLink!=-1)
  {
    if(thing[x].tLinkType==0 || thing[x].tLinkType==1) // static link
    {
      thing[x].sx=thing[thing[x].tLink].sx;
      thing[x].sy=thing[thing[x].tLink].sy;
      thing[x].sz=thing[thing[x].tLink].sz;

      thing[x].gx=thing[thing[x].tLink].gx;
      thing[x].gy=thing[thing[x].tLink].gy;
      thing[x].gz=thing[thing[x].tLink].gz;

      if(thingDef[thing[thing[x].tLink].type].com[THINGDEF_ADDSPEED]==1
      && thingDef[thing[x].type].com[THINGDEF_ADDSPEED]!=1)
        thing[x].y+=play.speed;
    }

    if(thing[x].tLinkType==2)          // semi-linked
    {
      thing[x].x-=thing[x].tx;
      thing[x].y-=thing[x].ty;
      thing[x].z-=thing[x].tz;

      thing[x].x+=thing[thing[x].tLink].x;
      thing[x].y+=thing[thing[x].tLink].y;
      thing[x].z+=thing[thing[x].tLink].z;

      thing[x].tx=thing[thing[x].tLink].x;
      thing[x].ty=thing[thing[x].tLink].y;
      thing[x].tz=thing[thing[x].tLink].z;
    }

    if(thing[x].tLinkType==3)          // free link
    {
      
    }

    if(thing[x].tLinkType==4)          // chain link
    {
      trans=1-(thing[x].tLinkPos/thing[thing[x].tLink].tz);

      rotPos(thingAct[thing[thing[x].tLink].type].com[THINGACT_LINKOFFX],thingAct[thing[thing[x].tLink].type].com[THINGACT_LINKOFFY],thing[thing[x].tLink].rot/41); d=rx; e=ry;
      rotPos(thingAct[thing[thing[x].tLink2].type].com[THINGACT_LINKOFFX],thingAct[thing[thing[x].tLink2].type].com[THINGACT_LINKOFFY],thing[thing[x].tLink2].rot/41);

      thing[x].x=((thing[thing[x].tLink].x+d)*trans)+((thing[thing[x].tLink2].x+rx)*(1-trans));
      thing[x].y=((thing[thing[x].tLink].y+e)*trans)+((thing[thing[x].tLink2].y+ry)*(1-trans));
      thing[x].z=((thing[thing[x].tLink].z)*trans)+(thing[thing[x].tLink2].z*(1-trans));
    }

    if(thing[x].tLinkType==5)          // snake link
    {
      thing[x].x=thing[thing[x].tLink2].x;
      thing[x].y=thing[thing[x].tLink2].y;
      thing[x].z=thing[thing[x].tLink2].z;
      thing[x].rot=thing[thing[x].tLink2].rot;
    }

    if(thing[x].tLinkType==6)          // dissipating snake
    {
      trans=1-(thing[x].tLinkPos/thing[thing[x].tLink].tz);

      thing[x].x=(thing[thing[x].tLink].x*trans)+(thing[thing[x].tLink2].x*(1-trans));
      thing[x].y=(thing[thing[x].tLink].y*trans)+(thing[thing[x].tLink2].y*(1-trans));
      thing[x].z=(thing[thing[x].tLink].z*trans)+(thing[thing[x].tLink2].z*(1-trans));

      thing[x].x=(thing[x].x*trans)+(thing[thing[x].tLink3].x*(1-trans));
      thing[x].y=(thing[x].y*trans)+(thing[thing[x].tLink3].y*(1-trans));
      thing[x].z=(thing[x].z*trans)+(thing[thing[x].tLink3].z*(1-trans));
      thing[x].rot=(thing[x].rot*trans)+(thing[thing[x].tLink3].rot*(1-trans));
    }

    if(thing[x].tLinkType==7) // gravity link
    {
      if(thing[x].x+thing[x].w2>thing[thing[x].tLink].x+thing[thing[x].tLink].w2)
        thing[x].sx-=0.04;
      else
        thing[x].sx+=0.04;

      if(thing[x].y+thing[x].h2>thing[thing[x].tLink].y+thing[thing[x].tLink].h2)
        thing[x].sy-=0.04;
      else
        thing[x].sy+=0.04;

      if(thing[x].sx>3)
        thing[x].sx=3;
      if(thing[x].sx<-3)
        thing[x].sx=-3;

      if(thing[x].sy>3)
        thing[x].sy=3;
      if(thing[x].sy<-3)
        thing[x].sy=-3;
    }

    if(thing[x].tLinkType==8)          // dissipating snake 2
    {
      trans=1-(thing[x].tLinkPos/thing[thing[x].tLink].tz);

      thing[x].x=(thing[thing[x].tLink].x*trans)+(thing[thing[x].tLink2].x*(1-trans));
      thing[x].y=(thing[thing[x].tLink].y*trans)+(thing[thing[x].tLink2].y*(1-trans));
      thing[x].z=(thing[thing[x].tLink].z*trans)+(thing[thing[x].tLink2].z*(1-trans));

      thing[x].x=(thing[x].x*trans)+(thing[thing[x].tLink3].x*(1-trans));
      thing[x].y=(thing[x].y*trans)+(thing[thing[x].tLink3].y*(1-trans));
      thing[x].z=(thing[x].z*trans)+(thing[thing[x].tLink3].z*(1-trans));
      thing[x].rot=(thing[x].rot*trans)+(thing[thing[x].tLink3].rot*(1-trans));
    }

    if(thing[x].tLinkType==999) // attached to player
    {
      thing[x].x=(player.x+12)-thing[x].w2;
      thing[x].y=(player.y+16)-thing[x].h2;
      thing[x].z=player.z;
    }

    if(thing[x].tLink<maxthing && thing[x].tLink>0)
    {
      if(thing[thing[x].tLink].flash==1 && thing[x].hitPshot==0) // if master link is flashing, flash as well
        thing[x].flash=1;

      if(linkDef[thing[x].tLinkSrc].com[23]==1)
        thing[x].rot=thing[thing[x].tLink].rot;

      if(linkDef[thing[x].tLinkSrc].com[23]==2)
        thing[x].rot=thing[thing[x].tLink2].rot;

      if(linkDef[thing[x].tLinkSrc].com[23]==3)
      {
        if(thing[x].rot!=thing[thing[x].tLink].rot)
        {
          rotPos(thing[x].x-thing[thing[x].tLink].x,thing[x].y-thing[thing[x].tLink].y,thing[x].rot-thing[thing[x].tLink].rot);
          thing[x].x+=rx;
          thing[x].y+=ry;
          thing[x].rot=thing[thing[x].tLink].rot;
        }
      }
    }
  }

  // visible damage

  if(thing[x].madeDamage!=0) // make thing flash depending on how much it's damaged
  {
    thing[x].flashCount++;

    if(thing[x].flashCount%32==0 && thing[x].madeDamage==1)
      thing[x].flash=1;
    if(thing[x].flashCount%24==0 && thing[x].madeDamage==2)
      thing[x].flash=1;
  }

  if((thing[x].shield<=thing[x].sMax/2 && thing[x].madeDamage==0)
  || (thing[x].shield<=thing[x].sMax/4 && thing[x].madeDamage==1))
  {
    if(thing[x].madeDamage==0)
    {
      thing[x].madeDamage=1;

      if(thingActP->com[THINGACT_DMGAMT]>4) // amt for shield less than 1/2
        copyAMT(x,thingActP->com[THINGACT_DMGAMT]);
    }
    else
    {
      thing[x].madeDamage=2;
    }

    if(thing[x].tLinkNumDam!=0) // make visible damage link
      makeLink(x,thing[x].tLinkNumDam);
  }
}

void doThingHit(int tNum)
{
  register int x=tNum,y;
  float b,c; int d,e,f,g,h;

  // stuff to skip hit detection every other game loop

  if(gCount%3==0 && thing[x].type==play.rShotType)
    return;

  if(gCount%2==0 
  && thing[x].type!=play.dalType
  && thingDefP->com[THINGDEF_ISPSHOT]!=2
  && thingDefP->com[THINGDEF_ISESHOT]==0)
    return;

  if(thing[x].shield<=0 || thing[x].stat==1)
    goto skipHit;

  // hit detection for player + thing distance

  if(thing[x].rangeAMT!=0)
  {
    d=thing[x].range/2;
    if(hit((player.x+12)-d,(player.y+16)-d,player.z,
    thing[x].x,thing[x].y,thing[x].z,
    thing[x].range,thing[x].range,d,
    thing[x].hrX2,thing[x].hrY2,thing[x].hrZ2))
    {
      copyAMT(x,thing[x].rangeAMT);
      if(thingDefP->com[THINGDEF_RANGEAMT]==1)
        thing[x].rangeAMT=0;
    }
  }

  // hit detection for player + things

  h=thingDefP->com[THINGDEF_COLLISION];
  if((h==COLLISION_PLAYER || h==COLLISION_BOTH) && player.stat!=-1)
  {
    if(thingDefP->com[THINGDEF_POWERUP]!=0)
    {
      d=2; e=6; g=20; // bigger hit detect range for dal/powerups
    } 
    else 
    {
      if(play.invunStat!=0)
        goto skipPhit;

      d=11; e=17; g=3; // normal hit detect range
    }

    if(thing[x].z==0) // simpler hit detect
    {
      if(hit2(player.x+d,player.y+e,thing[x].x+thing[x].hrX1,thing[x].y+thing[x].hrY1,
              g,g,thing[x].hrX3,thing[x].hrY3))
        goto didPhit;
    }
    else // full hit detect
    {
      if(hit(player.x+d,player.y+e,player.z, 
             thing[x].x+thing[x].hrX1,thing[x].y+thing[x].hrY1,thing[x].z, 
             g,g,6,thing[x].hrX3,thing[x].hrY3,thing[x].hrZ2))
        goto didPhit;
    }

    goto skipPhit; // if it didn't hit, skip

    didPhit:

    play.health-=thingDefP->com[THINGDEF_COLDAMAGE];

    if(play.health>0 && thingDefP->com[THINGDEF_COLDAMAGE]>0)
    {
      play.sTimer=5;
      playSample(playDef[0].com[6],128);
    }

    doThingPowerup(x,thingDefP->com[THINGDEF_POWERUP]);

    thing[x].shield-=2;
    if(thing[x].shield<=0)
    {
      killThing(x);
      return;
    }
    else
    {
      thing[x].flash=1;

      if(thingActP->com[THINGACT_HITACT]>0)
      {
        copyActT(x,thingActP->com[THINGACT_HITACT]);
        thing[x].stat=STAT_HIT;
      }
    }
  }
  skipPhit:

  // hit detection for things + things

  if(h==COLLISION_ENEMY || h==COLLISION_BOTH)
  {
    for(y=0; y<tMax; y++)
    {
      if(thing[y].stat!=-1)
      {
        if(thing[y].hitPshot==1 && thing[y].stat!=1)
        {
          if(thing[y].z==0) // simpler hit detect
          {
            d=thing[y].x+thing[y].hrX1; e=thing[y].y+thing[y].hrY1;
            f=thing[x].x; g=thing[x].y;

            if(d>f+thing[x].hrX2 || f>d+thing[y].hrX3
            || e>g+thing[x].hrY2 || g>e+thing[y].hrY3)
              continue;

            goto didHit;
          }
          if(thing[y].z>-64) // full hit detect
          {
            if(hit(thing[y].x+thing[y].hrX1,thing[y].y+thing[y].hrY1,thing[y].z,
                   thing[x].x,thing[x].y,thing[x].z,
                   thing[y].hrX3,thing[y].hrY3,thing[y].hrZ2,
                   thing[x].hrX2,thing[x].hrY2,thing[x].hrZ2))
              goto didHit;
          }

          continue; // if it didn't hit, continue the loop

          didHit: 

          if(thing[y].tLink==x || y==x) // stupid rare scenarios with objects hitting themselves and their links
            continue;

          // subtract damage from target thing shield

          d=thing[x].type;

          if(d==play.shotType || d==play.shotType2) // normal shots
          {
            thing[y].shield-=play.shotDamage;

            if(thing[x].type==play.shotType)
              play.sDestroyed++;

            goto doneDamage;
          }
          if(d==play.bombType) // bombs
          {
            thing[y].shield-=play.bombDamage;
            goto doneDamage;
          }
          if(d==play.rShotType) // reflect shots
          {
            if(thingDef[thing[y].type].com[THINGDEF_RSINVUN]!=1)
              thing[y].shield-=play.rShotDamage;
            goto doneDamage;
          }
          for(f=0; f<6; f++) // weapon shots
          {
            if(d==play.wpn[f].shotType)
            {
              thing[y].shield-=play.wpn[f].damage+play.wpn[f].damageUp;

              if(play.curWpn==WEAPON_IMPLOSION && thing[x].tLink!=y)
                thing[y].shield+=(play.wpn[f].damage+play.wpn[f].damageUp)/2;

              goto doneDamage;
            }
          }

          if(d==play.wpn[WEAPON_VELOCITY].type) // velocity cannon
          {
            thing[y].shield-=(play.wpn[1].damage+play.wpn[1].damageUp)/2;

            goto doneDamage;
          }

          if(d==play.wpn[WEAPON_IMPLOSION].type) // implosion chain
          {
            thing[y].shield-=(play.wpn[4].damage+play.wpn[4].damageUp)/5;

            if(play.curWpn==WEAPON_IMPLOSION && thing[play.wpn[4].mainThing].tLink==-1 && thing[y].x>0 && thing[y].x<400 && thing[y].shield>=0.5) // lock implosion onto this thing
            {
              thing[play.wpn[4].mainThing].tLink=y;
              play.wpn[4].distance=8;
            }

            goto doneDamage;
          }

          thing[y].shield-=thingDefP->com[THINGDEF_COLDAMAGE]/10; // last resort

          doneDamage:

          if(thing[y].shield<=0) // if it was killed
          {
            killThing(y);

            if(thingDefP->com[THINGDEF_ISPSHOT]!=0)
            {
              play.eDestroyed++;
              play.score+=(thingDef[thing[y].type].com[THINGDEF_POINTS]*100)+(gOpt.skillVar*10); redrawStatus=1;
              if(thing[x].type==play.rShotType)
                play.score+=40;
            }
          }
          else // if it was damaged
          {
            if(thingDefP->com[THINGDEF_ISPSHOT]==1) // impact shots
            {
              play.score+=9+rand()%3; redrawStatus=1;

              thing[y].flash=1;

              if(thingAct[thing[y].type].com[THINGACT_HITSND]!=0)
                playSample(thingAct[thing[y].type].com[THINGACT_HITSND],getStereoPan(thing[y].x+thing[y].w2));
            }
            else if(thingDefP->com[THINGDEF_ISPSHOT]==2) // pierce shot
            {
              if(rand()%10==0)
              { play.score+=1; redrawStatus=1; }

              if(gCount%2==0)
                thing[y].flash=1;
            }

            if(thingAct[thing[y].type].com[THINGACT_HITACT]>0)
            {
              copyActT(y,thingAct[thing[y].type].com[THINGACT_HITACT]);
              thing[y].stat=STAT_HIT;
            }

            if(thingAct[thing[y].type].com[THINGACT_HITAMT]>0)
              copyAMT(y,thingAct[thing[y].type].com[THINGACT_HITAMT]);
          }

          thing[x].flash=1;
          thing[x].shield--;
          if(thing[x].shield<=0)
          {
            killThing(x);
            return;
          }
        }
      }
    }
  }

  // hit detection for things + bg

  if(thing[x].groundHit==0)
    goto skipHit;

  for(e=0; e<bgCount; e++)
  {
    y=oSort[e].num;

    if(bg[y].stat!=-1)
    {
      if(thing[x].z-(thing[x].hrZ2/2)<=bg[y].ground && thing[x].z+(thing[x].hrZ2/2)>=bg[y].gDepth)
      {
        b=calctX(thing[x].x+thing[x].w2+bg[y].hoff,thing[x].z);

        if(bg[y].hoff!=0)
        {
          if(b>bg[y].mapWp)
            b-=bg[y].mapWp;
          else if(b<=0-bg[y].mapWp)
            b+=bg[y].mapWp;
        }

        b/=bg[y].tsize;
        b=(int)b;

        c=calctY(thing[x].y+thing[x].h2,thing[x].z);
        c/=bg[y].tsize;
        c=(int)c;

        d=b+(((bg[y].mapH-c)+bg[y].toff)*bg[y].mapW);

        if((tile[tileStat[bg[y].map[d]].tile]!=NULL || bg[y].map[d]==TILE_SOLID) && tileStat[bg[y].map[d]].trans!=2) // if collision
        {
          if(thing[x].groundHit>2) // make ground explosion
          {
            if((tile[bg[y].map[d+1]]!=NULL || bg[y].map[d+1]==TILE_SOLID)
            && (tile[bg[y].map[d-1]]!=NULL || bg[y].map[d-1]==TILE_SOLID)
            && (tile[bg[y].map[d+bg[y].mapW]]!=NULL || bg[y].map[d+bg[y].mapW]==TILE_SOLID)
            && (tile[bg[y].map[d-bg[y].mapW]]!=NULL || bg[y].map[d-bg[y].mapW]==TILE_SOLID))
            {
              expDef[thing[x].groundHit].com[2]=(bg[y].ground+(rand()%2)+2)-thing[x].z;
              makeExpDef(x,thing[x].groundHit);
            }
          }

          if(thing[x].stat!=1)
            killThing(x);
          else
            clearThing(x);

          return;
        }
      }
    }
  }
  skipHit:

  // hit detection for thing shadows + bg

  if(thing[x].drawShadow!=-1)
  {
    thing[x].drawShadow=888;

    for(e=0; e<bgCount; e++)
    {
      y=oSort[e].num;

      if(bg[y].stat!=-1 && bg[y].noShadow==0 && thing[x].z>=bg[y].ground)
      {
        b=calctX(thing[x].x+thing[x].w2+bg[y].hoff,bg[y].ground);

        if(bg[y].hoff!=0)
        {
          if(b>bg[y].mapWp)
            b-=bg[y].mapWp;
          else if(b<=0-bg[y].mapWp)
            b+=bg[y].mapWp;
        }

        b/=bg[y].tsize;
        b=(int)b;

        c=calctY(thing[x].y+thing[x].h2,bg[y].ground);
        c/=bg[y].tsize;
        c=(int)c;

        if(b>=bg[y].mapW)
          b-=bg[y].mapW;

        d=b+(((bg[y].mapH-c)+bg[y].toff)*bg[y].mapW);

        if(tile[bg[y].map[d]]!=NULL || bg[y].map[d]==TILE_SOLID)
          thing[x].drawShadow=y;
      }
    }
  }

  // out of bounds detection

  d=thing[x].z;
  if(d>0)
    d=0;
  if(thingDefP->com[THINGDEF_ISPSHOT]==1)
  {
    if(thing[x].x<0-thing[x].hrX2 || thing[x].x>400
    || thing[x].y<0-thing[x].hrY2 || thing[x].y>300)
      clearThing(x);
  }
  else if(thingDefP->com[THINGDEF_NOBOUND]==0)
  {
    if(thing[x].x<0-(thing[x].hrX2*2)+d || thing[x].x>400+(thing[x].hrX2*2)-d ||
       thing[x].y<0-(thing[x].hrY2*2)+d || thing[x].y>300+(thing[x].hrY2*2)-d ||
       thing[x].z<zdepth0 || thing[x].z>zdepth)
      clearThing(x);
  }
  else if(thingDefP->com[THINGDEF_NOBOUND]==1)
  {
    if(thing[x].x<0-(thing[x].hrX2*64)+d || thing[x].x>400+(thing[x].hrX2*64)-d ||
       thing[x].y<0-(thing[x].hrY2*64)+d || thing[x].y>300+(thing[x].hrY2*64)-d ||
       thing[x].z<zdepth0 || thing[x].z>zdepth)
      clearThing(x);
  }
  else if(thingDefP->com[THINGDEF_NOBOUND]==2)
  {
    if(thing[x].y>300+(thing[x].hrY2*4)-d ||
       thing[x].z<zdepth0 || thing[x].z>zdepth)
      clearThing(x);
  }
  else if(thingDefP->com[THINGDEF_NOBOUND]==3)
  {
    if(thing[x].y<0-(thing[x].hrY2*4)-d ||
       thing[x].z<zdepth0 || thing[x].z>zdepth)
      clearThing(x);
  }
  else if(thingDefP->com[THINGDEF_NOBOUND]==4)
  {
    if(thing[x].y>300+(thing[x].hrY2*12)-d ||
       thing[x].z<zdepth0 || thing[x].z>zdepth)
      clearThing(x);
  }
}  

void doThingPowerup(int tNum, int pType)
{
  int oldDal=play.dal,lvlUp1,lvlUp2,dalAdd;

  if(pType==1)
  {
    play.dal+=100;
    play.dalCombo+=16;
  }
  if(pType==2)
  {
    play.dal+=500;
    play.dalCombo+=16;

    if(gOpt.gameMode==0)
      play.dalComboBonus+=100;
    if(gOpt.gameMode==1)
      play.dalComboBonus+=200;
  }
  if(pType==3)
  {
    play.silvDal+=100;
    play.dal+=play.silvDal;
    play.dalCombo+=16;
  }
  if(pType==4)
  {
    if(play.refNum<6)
      play.refNum++;
    else
      play.score+=5000;
  }
  if(pType==5)
  {
    if(play.lives<6)
      play.lives++;
    else
      play.lives+=5000;
  }

  if(oldDal!=play.dal) // check for added dal
  {
    dalAdd=play.dal-oldDal;

    if(play.wpn1==play.curWpn) // current weapon gets 75% of dal
    {
      lvlUp1=upgradeWeapon(play.wpn1,dalAdd/1.3333);
      lvlUp2=upgradeWeapon(play.wpn2,dalAdd/4);
    }
    else
    {
      lvlUp1=upgradeWeapon(play.wpn1,dalAdd/4);
      lvlUp2=upgradeWeapon(play.wpn2,dalAdd/1.3333);
    }

    if(lvlUp1!=0 || lvlUp2!=0) // gained a level
    {
      initThing(findEmptyT(),player.x-24,player.y-8,0,-2,0,0,1,play.dalType,1,playDef[2].com[5],0);
      playSample(playDef[0].com[7],128);
    }

    play.score+=play.dalComboBonus;
    if(gOpt.gameMode==0)
      play.dalComboBonus+=100;
    if(gOpt.gameMode==1)
      play.dalComboBonus+=200;

    if(play.dalCombo>16)
      play.dalCombo=16;
  }

  redrawStatus=1;
}

void doThingShoot(int tNum, int sNum)
{
  float dx,dy,dz,tx,ty,tz,tx2,ty2,tz2,sinTheta,theta,rnum,r,a,z;
  int x,y;

  if(sNum<=0 || thing[tNum].stat==-1 || thing[tNum].stat==1)
    return;

  if(shotDef[sNum].loaded==0)
    bombOut(32,sNum);

  // set timer variables

  thing[tNum].sTimer=0;
  thing[tNum].sTimerLimit=shotDef[sNum].com[1];
  thing[tNum].sNext=shotDef[sNum].com[2];
  if(thing[tNum].sCutoff==0 && shotDef[sNum].com[16]!=0)
    thing[tNum].sCutoff=shotDef[sNum].com[16]+gOpt.skillVar;
  if(thing[tNum].sCutoff<=0 && shotDef[sNum].com[16]!=0) // check for ugly bug
    thing[tNum].sCutoff=1;

  if(shotDef[sNum].com[27]!=0)
    thing[tNum].sCutoffNext=shotDef[sNum].com[27]; // cutoff next

  if(shotDef[sNum].com[24]!=0)
    thing[tNum].sWait=shotDef[sNum].com[24];       // replace shot delay

  if(thingAct[thing[tNum].type].com[THINGACT_FIREACT]>0 && thing[tNum].stat!=STAT_SHOOTING)
  {
    copyActT(tNum,thingAct[thing[tNum].type].com[THINGACT_FIREACT]);
    thing[tNum].stat=STAT_SHOOTING;
  }

  if(shotDef[sNum].com[8]!=0 && thing[tNum].tid!=shotDef[sNum].com[8]) // make thing with tid shoot
  {
    for(x=0; x<tMax; x++)
    {
      if(thing[x].stat!=-1)
      {
        if(thing[x].tid==shotDef[sNum].com[8] && x!=tNum)
          doThingShoot(x,thing[x].sType);

        if(thing[x].tid==shotDef[sNum].com[8]-900)
          thing[x].sTimerLimit=666;
      }
    }
  }

  if(shotDef[sNum].com[30]!=0)
    makeShrapDef(thing[tNum].x+thing[tNum].w2,thing[tNum].y+thing[tNum].h2,thing[tNum].z,shotDef[sNum].com[30],tNum);

  if(thingDef[thing[tNum].type].com[THINGDEF_FC]==0) // make circle
  {
    if(shotDef[sNum].com[15]!=0)
    {
      if(shotDef[sNum].com[15]<0)
      {
        x=findEmptyC();
        makeCircle(tNum,shotDef[sNum].com[15]*-1);
        circ[x].x=shotDef[sNum].com[11];
        circ[x].y=shotDef[sNum].com[12];

        if(thing[tNum].dir==1)
          circ[x].x=sprMain[thing[tNum].sprite]->w-(shotDef[sNum].com[11]+4);
      }
      else
        makeCircle(tNum,shotDef[sNum].com[15]);
    }
  }
  else
    makeCircle(tNum,thingDef[thing[tNum].type].com[THINGDEF_FC]);

  if(shotDef[sNum].com[31]>0)
    playSample(shotDef[sNum].com[31],getStereoPan(thing[tNum].x+thing[tNum].w2)); // play sound

  // if player is dead or invunerable, or the shot type to create is 0, leave

  if(player.stat==-1 || play.invunStat!=0 || shotDef[sNum].com[0]==0)
  {
    if(thing[tNum].sTimerLimit==0)
      doThingShoot(tNum,thing[tNum].sNext);
    return;
  }

  for(x=0; x<=shotDef[sNum].com[19]; x++) // main loop to make bullets
  {
    // position 1 (destination)

    tx=shotDef[sNum].com[3];
    ty=shotDef[sNum].com[4];
    tz=shotDef[sNum].com[5];

    if(shotDef[sNum].com[13]==1) // use speed, so divide by 10
    {
      tx/=10;

      if(ty==999)
        ty=play.speed;
      else
        ty/=10;

      if(tz!=999)
        tz/=10;
    }

    if(shotDef[sNum].com[3]==700) // player x
      tx=player.x+8;
    if(shotDef[sNum].com[3]==701) // player x - random position add x/2
      tx=(player.x+8)-(shotDef[sNum].com[6]/2);
    if(shotDef[sNum].com[3]==702) // thing x
      tx=thing[tNum].x+thing[tNum].w2;

    if(shotDef[sNum].com[4]==700) // player y
      ty=player.y+12;
    if(shotDef[sNum].com[4]==701) // player y - random position add y/2
      ty=(player.y+12)-(shotDef[sNum].com[7]/2);
    if(shotDef[sNum].com[4]==702) // thing y
      ty=thing[tNum].y+thing[tNum].h2;

    if(shotDef[sNum].com[5]==700) // player z
      tz=player.z;

    // random position add

    if(shotDef[sNum].com[13]==1)
      y=10;
    else
      y=1;

    if(shotDef[sNum].com[6]!=0)
    {
      if(shotDef[sNum].com[6]>0)
        tx+=(float)(rand()%shotDef[sNum].com[6])/y;
      else
        tx-=(float)(rand()%(shotDef[sNum].com[6]*-1))/y;
    }
    if(shotDef[sNum].com[7]!=0)
    {
      if(shotDef[sNum].com[7]>0)
        ty+=(float)(rand()%shotDef[sNum].com[7])/y;
      else
        ty-=(float)(rand()%(shotDef[sNum].com[7]*-1))/y;
    }
    /*if(shotDef[sNum].com[8]!=0)
    {
      if(shotDef[sNum].com[8]>0)
        tz+=(float)(rand()%shotDef[sNum].com[8])/y;
      else
        tz-=(float)(rand()%(shotDef[sNum].com[8]*-1))/y;
    }*/

    // position 2 (starting point)

    if(shotDef[sNum].com[11]==888)
      tx2=(thing[tNum].x+(thing[tNum].w2))-(actMain[thingDef[shotDef[sNum].com[0]].com[THINGDEF_INITACT]].hrX2/2);
    else
      tx2=thing[tNum].x+shotDef[sNum].com[11];

    if(shotDef[sNum].com[12]==888)
      ty2=(thing[tNum].y+(thing[tNum].h2))-(actMain[thingDef[shotDef[sNum].com[0]].com[THINGDEF_INITACT]].hrY2/2);
    else
      ty2=thing[tNum].y+shotDef[sNum].com[12];

    if(tz==999) // if z speed is 999, set it to 0
    {
      tz=0;
      tz2=0;
    }
    else
      tz2=thing[tNum].z;

    // override for position 2

    if(thingAct[thing[tNum].type].com[THINGACT_SHOTOFFX]!=0)
      tx2=thing[tNum].x+thingAct[thing[tNum].type].com[THINGACT_SHOTOFFX];

    if(thingAct[thing[tNum].type].com[THINGACT_SHOTOFFY]!=0)
      ty2=thing[tNum].y+thingAct[thing[tNum].type].com[THINGACT_SHOTOFFY];

    // direction flip

    if(thing[tNum].dir==1 && shotDef[sNum].com[21]==0 && shotDef[sNum].com[11]!=888)
      tx2+=sprMain[thing[tNum].sprite]->w-((shotDef[sNum].com[11]*2)-4);

    // rotate shot based on thing rotation

    if(shotDef[sNum].com[21]!=0)
    {
      rotPos(tx2-(thing[tNum].x+thing[tNum].w2),ty2-(thing[tNum].y+thing[tNum].h2),thing[tNum].rot/41);

      tx2=rx+thing[tNum].x+thing[tNum].w2;
      ty2=ry+thing[tNum].y+thing[tNum].h2;
    }

    // speed

    if(shotDef[sNum].com[9]==0)
      a=thingDef[thing[tNum].type].com[THINGDEF_SHOTSPEED];
    else
      a=shotDef[sNum].com[9];

    // random speed add

    if(shotDef[sNum].com[10]!=0)
    {
      if(shotDef[sNum].com[10]>0)
        a+=rand()%shotDef[sNum].com[10];
      else
        a-=rand()%(shotDef[sNum].com[10]*-1);
    }

    if(shotDef[sNum].com[13]==0) // direction
    {
      a-=(float)gOpt.skillVar*2.5;
      a+=thing[tNum].sSpdInc;
      a+=shotDef[sNum].com[17]*x;
      if(a<20)
        a=20;

      z=abs(tx-tx2)+abs(ty-ty2)+abs(tz-tz2);
      a/=100; z=z*a; if(z==0) z=1;

      dx=(tx-tx2)/z;
      dy=(ty-ty2)/z;
      dz=(tz-tz2)/z;
    }
    else // speed
    {
      dx=tx;
      dy=ty;
      dz=tz;
    }

    // rotate direction

    if(shotDef[sNum].com[28]==999) // special to reverse rotation increment
      thing[tNum].sRotInc*=-1;

    rnum=((float)shotDef[sNum].com[14]/41)+(((float)shotDef[sNum].com[18]*x)/41)+((float)thing[tNum].sRotInc/41);
    if(shotDef[sNum].com[21]==2)
      rnum+=thing[tNum].rot/41;
    if(rnum!=0)
    {
      rotPos(dx,dy,rnum);
      dx=rx; dy=ry;
    }

    if(shotDef[sNum].com[28]!=999) // if it's not 999, add it, else, reverse the rotation back to normal
      thing[tNum].sRotInc+=shotDef[sNum].com[28];
    else
      thing[tNum].sRotInc*=-1;

    thing[tNum].sSpdInc+=shotDef[sNum].com[29];

    // make it

    tz=shotDef[sNum].com[0];
    //if(dx==0 && dy==0 && dz==0)
    //  tz=0;
    if(tx2<-8+bgPosX || tx2>280+bgPosX || ty2<-8 || ty2>300)
      tz=0;
    if(tz!=0)
    {
      y=findEmptyT();
      initThing(y,tx2,ty2,tz2, dx,dy,dz, 0,tz,0,thingAct[(int)tz].com[THINGACT_INITACT],1);

      if(thing[tNum].dir==1 && shotDef[sNum].com[13]==1)
        thing[y].sx*=-1;

      thing[y].dirRot=shotDef[sNum].com[26];

      if(shotDef[sNum].com[25]!=0)
      {
        if(shotDef[sNum].com[25]<0)
          copyAMT(tNum,shotDef[sNum].com[25]*-1);
        else
          copyAMT(y,shotDef[sNum].com[25]);
      }

      // rotation

      thing[y].srot=(float)shotDef[sNum].com[22]/10;

      thing[y].rot=shotDef[sNum].com[20];
      if(thing[y].rot==888)
        thing[y].rot=rand()%256;

      if(thing[y].rot==889)
        thing[y].rot=thing[tNum].rot;

      if(thing[y].rot==700 || thing[y].rot==999)
      {
        if(thing[y].rot==700)
        { 
          tx=player.x+12;
          ty=player.y+16;
        }

        if(thing[y].rot==999)
        {
          rotPos(tx,ty,rnum);
          tx=rx; ty=ry;
        }

        dx=tx-thing[y].x;
      	dy=ty-thing[y].y;

      	r=sqrt((dx*dx)+(dy*dy));
        if(r==0)
      	  sinTheta=dy;
        else
          sinTheta=dy/r;
      	theta=asin(sinTheta);

        if(player.x<thing[y].x)
	        thing[y].rot=64-(theta*40.8);
	      else
	        thing[y].rot=(theta*40.8)-64;
      }

      if(gOpt.randMode==1 && thingDef[thing[y].type].com[THINGDEF_ISESHOT]!=2) // stuff to make shot patterns random
      {
        // change shot velocity randomly

        thing[y].sx+=(float)(50-rand()%100)/100;
        thing[y].sy+=(float)(50-rand()%100)/100;

        // change shot speed randomly

        a=(thing[y].sx+thing[y].sy)/3;
        if((int)a!=0)
        {
          thing[y].sx+=(float)((a*10)-rand()%((int)(a*20)))/100;
          thing[y].sy+=(float)((a*10)-rand()%((int)(a*20)))/100;
        }

        // change delay between shots randomly

        if(thing[tNum].sTimerLimit!=666 && thing[tNum].sTimerLimit>=4)
        {
          thing[tNum].sTimerLimit+=12-rand()%24;
          if(thing[tNum].sTimerLimit<=0)
            thing[tNum].sTimerLimit=1;
        }
      }
    }
  }

  if(thing[tNum].sTimerLimit==0)
    doThingShoot(tNum,thing[tNum].sNext);
}

void killThing(int tNum)
{
  int x,y,z;

  datObj *thingDefP2;
  datObj *thingActP2;

  if(thing[tNum].stat==-1 || thing[tNum].stat==1)
    return;

  thingDefP2=thingDef+thing[tNum].type;
  thingActP2=thingAct+thing[tNum].type;

  // special to disable implosion

  if(play.curWpn==WEAPON_IMPLOSION)
  {
    y=play.wpn[WEAPON_IMPLOSION].mainThing;    

    if(thing[y].tLink==tNum)
    {
      hideImplosion();
    }
  }

  // check for other things chasing this thing and disable them

  if(thing[tNum].tid!=0)
  {
    for(x=0; x<tMax; x++)
    {
      if(thing[x].tChase==tNum)
        thing[x].amTimerLimit=666;
    }
  }

  // death script

  z=thing[tNum].deathscr;
  if(z!=0)
  {
    if(script[z].com[0]==1 && script[z].com[2]==999) // special to make a thing create script run from the thing position
    {
      script[z].com[2]=thing[tNum].x+thing[tNum].w2;
      script[z].com[3]=thing[tNum].y+thing[tNum].h2;
      script[z].com[4]=thing[tNum].z;
      runScript(z);
      script[z].com[2]=999;
    }
    else
      runScript(z);
  }

  // erase circles

  for(x=0; x<maxtcirc; x++)
  {
    if(thing[tNum].circ[x]!=-1)
      circ[thing[tNum].circ[x]].life=-1;

    thing[tNum].circ[x]=-1;
  }

  // play death sound

  if(thingActP2->com[THINGACT_DEATHSND]>0)
    playSample(thingActP2->com[THINGACT_DEATHSND],getStereoPan(thing[tNum].x+thing[tNum].w2));

  // death circle

  if(thingActP2->com[THINGACT_DCIRC]>0)
    makeCircle(tNum,thingActP2->com[THINGACT_DCIRC]);

  // explosion

  if(thingActP2->com[THINGACT_EXPTYPE]>0)
    makeExpDef(tNum,thingActP2->com[THINGACT_EXPTYPE]);

  // powerup explosion

  if(thingActP2->com[THINGACT_POWEXP]>0)
    makeExpDef(tNum,thingActP2->com[THINGACT_POWEXP]);

  // shrapnel

  if(thingActP2->com[THINGACT_SHRAPTYPE]>0)
    makeShrapDef(thing[tNum].x+thing[tNum].w2,thing[tNum].y+thing[tNum].h2,thing[tNum].z,thingActP2->com[THINGACT_SHRAPTYPE],tNum);

  // kill master thing

  if(thing[tNum].tLink!=-1)
  {
    if(linkDef[thing[thing[tNum].tLink].tLinkNum].com[17]==1)
      killThing(thing[tNum].tLink);
  }

  // kill all things linked to this thing

  if(thing[tNum].tLinkNum!=0 || thing[tNum].tLinkNumDam!=0)
  {
    for(x=0; x<maxthing; x++)
    {
      if(thing[x].stat!=-1)
      {
        if(thing[x].tLink==tNum && thing[x].tLinkType!=1 && thing[x].tLinkType!=-1)
        {
          if(thingActP2->com[THINGACT_DEATHACT]==0)
            thing[x].tLink=-1;

          if(thing[x].stat!=1)
          {
            sndPlay[thingAct[thing[x].type].com[THINGACT_DEATHSND]]=1;
            killThing(x);
          }

          if(thing[x].stat==1 && thingDef[thing[x].type].com[THINGDEF_LINKCLR]==0)
            clearThing(x);
        }
      }
    }
  }

  // clear thing or set to dying

  if(thingActP2->com[THINGACT_DEATHACT]==0)
    thing[tNum].stat=-1;
  else
  {
    thing[tNum].stat=1;
    thing[tNum].shield=-999;
    thing[tNum].sTimerLimit=666; thing[tNum].amTimerLimit=666;

    if(thingDefP2->com[THINGDEF_DSPEED]==1) // set to player speed at death
      thing[tNum].sy=play.speed;

    if(thingDefP2->com[THINGDEF_SDEAD]==0) // disable shadow
      thing[tNum].drawShadow=-1;

    copyActT(tNum,thingActP2->com[THINGACT_DEATHACT]); // death act

    if(thingActP2->com[THINGACT_DEATHAMT]!=0)
      copyAMT(tNum,thingActP2->com[THINGACT_DEATHAMT]); // death amt
  }
}

void clearThing(int tNum)
{
  int x;

  if(thing[tNum].stat==-1)
    return;

  for(x=0; x<maxtcirc; x++)
  {
    if(thing[tNum].circ[x]!=-1)
      circ[thing[tNum].circ[x]].life=-1;

    thing[tNum].circ[x]=-1;
  }

  // explosion

  if(thingAct[thing[tNum].type].com[THINGACT_CLEAREXP]>0)
    makeExpDef(tNum,thingAct[thing[tNum].type].com[THINGACT_CLEAREXP]);

  // clear all things linked to this thing

  if(thing[tNum].tLinkNum>0 || thing[tNum].tLinkNumDam>0 || thing[tNum].tLinkSrc>0)
  {
    for(x=0; x<maxthing; x++)
    {
      if((thing[x].tLink==tNum || thing[x].tLink2==tNum || thing[x].tLink3==tNum) && x!=tNum)
        clearThing(x);
    }
  }

  thing[tNum].stat=-1;
}

void copyActT(int tNum, int aNum)
{
  thing[tNum].sprite=actMain[aNum].sprite;
  thing[tNum].tlimit=actMain[aNum].timerLimit;
  thing[tNum].offX=actMain[aNum].offX;
  thing[tNum].offY=actMain[aNum].offY;
  thing[tNum].w2=actMain[aNum].w2;
  thing[tNum].h2=actMain[aNum].h2;

  thing[tNum].act=aNum;
  thing[tNum].next=actMain[aNum].next;

  thing[tNum].timer=0;

  // copy hit retangle

  if(thing[tNum].dir==0)
  {
    thing[tNum].hrX1=actMain[aNum].hrX1;
    thing[tNum].hrX2=actMain[aNum].hrX2;
  }
  if(thing[tNum].dir==1)
  {
    thing[tNum].hrX1=actMain[aNum].hrX1b;
    thing[tNum].hrX2=actMain[aNum].hrX2b;
  }

  thing[tNum].hrY1=actMain[aNum].hrY1;
  thing[tNum].hrY2=actMain[aNum].hrY2;

  thing[tNum].hrX3=thing[tNum].hrX2-thing[tNum].hrX1;
  thing[tNum].hrY3=thing[tNum].hrY2-thing[tNum].hrY1;

  // movement

  if(actMain[aNum].movement!=0)
  {
    if(actMain[aNum].movement==999)
      thing[tNum].amTimerLimit=666;
    else
      copyAMT(tNum,actMain[aNum].movement);
  }

  // change circles

  if(actMain[aNum].c0x==666)
  {
    if(thing[tNum].circ[0]!=-1)
    {
      circ[thing[tNum].circ[1]].x=actMain[aNum].c1x;
      circ[thing[tNum].circ[1]].y=actMain[aNum].c1y;
    }

    if(thing[tNum].circ[1]!=-1)
    {
      circ[thing[tNum].circ[2]].x=actMain[aNum].c2x;
      circ[thing[tNum].circ[2]].y=actMain[aNum].c2y;
    }
  }

  // suicide!

  if(actMain[aNum].c0x==777)
  {
    if(thing[tNum].stat==1)
      clearThing(tNum);
    else
      killThing(tNum);
  }

  // set shield

  if(actMain[aNum].c0x==1)
  {
    thing[tNum].shield=actMain[aNum].c0y;
  }

  // add random to timerlimit

  if(actMain[aNum].c0x==2)
    if(actMain[aNum].c0y!=0 && thing[tNum].tlimit!=666)
      thing[tNum].tlimit+=rand()%actMain[aNum].c0y;
}

void copyAMT(int tNum, int amNum)
{
  float sx,sy,sz,x,y,srot,r,sinTheta,theta;
  int a,b,rotX=0,rotY=0,rDir=0;

  if(moveDef[amNum].loaded==0)
    bombOut(32,amNum);

  if(moveDef[amNum].com[27]!=0 && rand()%2==1) // random replacement
    amNum=moveDef[amNum].com[27];

  if(moveDef[amNum].com[25]==0) // set timers
  {
    thing[tNum].amTimer=0;
    thing[tNum].amTimerLimit=moveDef[amNum].com[1];
    if(thing[tNum].amTimerLimit==0)
      thing[tNum].amTimerLimit=666;
    if(thing[tNum].amTimerLimit==999)
      thing[tNum].amTimerLimit=64000;
    thing[tNum].amNext=moveDef[amNum].com[2];
  }

  // speed x,y,z,rot

  sx=moveDef[amNum].com[3];
  sy=moveDef[amNum].com[4];
  sz=moveDef[amNum].com[5];
  srot=moveDef[amNum].com[7];

  if(moveDef[amNum].com[19]!=702)
    thing[tNum].slimit=(float)(moveDef[amNum].com[19])/10;

  if(moveDef[amNum].com[3]!=702) // speed x
  {
    if(moveDef[amNum].com[3]==703)
      sx=thing[tNum].sx*-1;
    else
    {
      if(moveDef[amNum].com[8]!=0)
        sx+=(float)(rand()%(moveDef[amNum].com[8]*10))/10;

      if(moveDef[amNum].com[15]==0)
        sx/=10;
      else
        sx/=100;
    }
    thing[tNum].sx=sx;
  }
  if(moveDef[amNum].com[4]!=702) // speed y
  {
    if(moveDef[amNum].com[4]==703)
      sy=thing[tNum].sy*-1;
    else
    {
      if(moveDef[amNum].com[9]!=0)
        sy+=(float)(rand()%(moveDef[amNum].com[9]*10))/10;

      if(moveDef[amNum].com[15]==0)
        sy/=10;
      else
        sy/=100;
    }
    thing[tNum].sy=sy;
  }
  if(moveDef[amNum].com[5]!=702) // speed z
  {
    if(moveDef[amNum].com[5]==703)
      sz=thing[tNum].sz*-1;
    else
    {
      if(moveDef[amNum].com[10]!=0)
        sz+=(float)(rand()%(moveDef[amNum].com[10]*10))/10;

      if(moveDef[amNum].com[15]==0)
        sz/=10;
      else
        sz/=100;
    }
    thing[tNum].sz=sz;
  }

  // gravity x,y,z

  if(moveDef[amNum].com[11]!=702)
  {
    thing[tNum].gx=(float)(moveDef[amNum].com[11])/1000;

    if(thing[tNum].gx>0.8 && thing[tNum].tx==0)
      thing[tNum].tx=thing[tNum].x;
  }
  if(moveDef[amNum].com[12]!=702)
  {
    thing[tNum].gy=(float)(moveDef[amNum].com[12])/1000;

    if(thing[tNum].gy>0.8 && thing[tNum].ty==0)
      thing[tNum].ty=thing[tNum].y;
  }
  if(moveDef[amNum].com[13]!=702)
    thing[tNum].gz=(float)(moveDef[amNum].com[13])/1000;
  if(moveDef[amNum].com[14]!=702)
    thing[tNum].grot=(float)(moveDef[amNum].com[14])/1000;

  // rotate to player/thing

  a=moveDef[amNum].com[6];
  if(a==888)
    a=rand()%256;
  if(a>=700 && a!=702 && srot!=702 && srot!=0) // rotate towards a thing
  {
    if((a==800 && thing[tNum].tChase==-1) || ((a==801 || a==802) && thing[tNum].tLink==-1))
    {
      srot=0;
      goto skipRot;
    }
    if(a==700) // rotate towards player
    {
      rotX=player.x+12;
      rotY=player.y+16;
      rDir=0;
    }
    if(a==701) // rotate away from player
    {
      rotX=player.x+12;
      rotY=player.y+16;
      rDir=1;
    }
    if((a==800 || a==803) && thing[tNum].tChase!=-1) // rotate towards tChase
    {
      b=thing[tNum].tChase;
      rotX=thing[b].x+thing[b].w2;
    	rotY=thing[b].y+thing[b].h2;
      rDir=0;
    }
    if(a==801 && thing[tNum].tLink!=-1) // rotate towards master thing
    {
      b=thing[tNum].tLink;
      rotX=thing[b].x+thing[b].w2;
    	rotY=thing[b].y+thing[b].h2;
      rDir=0;
    }
    if(a==802 && thing[tNum].tLink!=-1) // rotate away from master thing
    {
      b=thing[tNum].tLink;
      rotX=thing[b].x+thing[b].w2;
    	rotY=thing[b].y+thing[b].h2;
      rDir=1;
    }

    x=rotX-(thing[tNum].x+thing[tNum].w2);
    y=rotY-(thing[tNum].y+thing[tNum].h2);

    r=sqrt((x*x)+(y*y));
    if(r==0)
      sinTheta=y;
    else
      sinTheta=y/r;
  	theta=asin(sinTheta);

    if(rotX<=thing[tNum].x)
	    r=64-(theta*40.74);
	  else
	    r=(theta*40.74)-64;

    if(moveDef[amNum].com[15]==0)
      srot/=10;
    else
      srot/=100;

    if(rDir==0)
    {
      if(thing[tNum].rot>r)
        thing[tNum].rot-=srot;
      if(thing[tNum].rot<r)
        thing[tNum].rot+=srot;
    }
    else
    {
      if(thing[tNum].rot>r)
        thing[tNum].rot+=srot;
      if(thing[tNum].rot<r)
        thing[tNum].rot-=srot;
    }

    if(a==803)
      thing[tNum].rot=r;

    srot=0;
  }
  skipRot:

  if(srot!=702)
  {
    if(moveDef[amNum].com[15]==0)
      srot/=10;
    else
      srot/=100;

    thing[tNum].srot=srot;
  }

  thing[tNum].x+=moveDef[amNum].com[16]; // offset
  thing[tNum].y+=moveDef[amNum].com[17];
  thing[tNum].z+=moveDef[amNum].com[18];

  if(moveDef[amNum].com[0]!=0) // make new link
    makeLink(tNum,moveDef[amNum].com[0]);

  if(moveDef[amNum].com[20]!=0) // circle
    makeCircle(tNum,moveDef[amNum].com[20]);

  if(moveDef[amNum].com[23]!=0) // shrapnel
    makeShrapDef(thing[tNum].x+thing[tNum].w2,thing[tNum].y+thing[tNum].h2,thing[tNum].z,moveDef[amNum].com[23],tNum);

  if(moveDef[amNum].com[24]!=0) // explosion
    makeExpDef(tNum,moveDef[amNum].com[24]);

  if(moveDef[amNum].com[26]!=0) // set shot pattern
  {
    thing[tNum].sType=moveDef[amNum].com[26];

    if(thing[tNum].sTimerLimit==666)
    {
      thing[tNum].sTimer=0;
      thing[tNum].sTimerLimit=2;
      thing[tNum].sNext=thing[tNum].sType;
      thing[tNum].sCutoff=0;
    }
  }

  if(moveDef[amNum].com[28]==1) // add player speed
    thing[tNum].sy+=play.speed;

  if(moveDef[amNum].com[29]!=0) // play sound
    playSample(moveDef[amNum].com[29],getStereoPan(thing[tNum].x+thing[tNum].w2));

  thing[tNum].sprRot=moveDef[amNum].com[30];

  if(moveDef[amNum].com[21]==1)
    thing[tNum].dirRot=0;
  if(moveDef[amNum].com[21]==2)
    thing[tNum].dirRot=1;

  if(moveDef[amNum].com[22]!=0 && thing[tNum].tChase==-1) // find tid for thing chase
  {
    for(a=0; a<maxthing; a++)
    {
      if(thing[a].stat!=-1 && thing[a].stat!=1 && thing[a].tid==moveDef[amNum].com[22])
      {
        thing[a].tChase=a;
        goto foundThing;
      }
    }
  }
  foundThing:

  if(moveDef[amNum].com[31]!=0) // make thing with this tid shoot
  {
    for(a=0; a<maxthing; a++)
    {
      if(thing[a].tid==moveDef[amNum].com[31])
      {
        doThingShoot(a,thing[a].sNext);
      }
      if(thing[a].tid==moveDef[amNum].com[31]-900)
      {
        thing[a].sTimerLimit=666;
        thing[a].sNext=thing[a].sType;
      }
    }

    if(moveDef[amNum].com[31]==999) // make self stop shooting
    {
      thing[tNum].sTimerLimit=666;
      thing[tNum].sNext=thing[tNum].sType;
    }

    if(moveDef[amNum].com[31]==998) // suicide!
    {
      if(thing[tNum].stat==1)
        clearThing(tNum);
      else
        killThing(tNum);
    }
  }
}

void sortThings()
{
  int x;

  tCount=0;

  // put in player

  oSort[tCount].num=600;
  oSort[tCount].key=player.z+4;
  tCount++;

  // put in lower shrapnel

  oSort[tCount].num=700;
  oSort[tCount].key=-64;
  tCount++;

  // put in higher shrapnel

  oSort[tCount].num=701;
  oSort[tCount].key=999;
  tCount++;

  // put in backgrounds

  for(x=0; x<maxbg; x++)
  {
    if(bg[x].stat!=-1)
    {
      oSort[tCount].num=800+x;
      oSort[tCount].key=bg[x].ground;
      tCount++;
    }
  }

  // put in things

  for(x=0; x<maxthing; x++)
  {
    if(thing[x].stat!=-1 && tCount<maxthing)
    {
      oSort[tCount].num=x;
      oSort[tCount].key=thing[x].z+thingDef[thing[x].type].com[THINGDEF_HIGHDRAW];
      tCount++;
    }
  }

  // shake n bake :P

  qsort(oSort, tCount, sizeof(sortObj),(int(*)(const void *, const void *)) comp);
}

int findEmptyT()
{
  int x;

  for(x=0; x<maxthing; x++)
  {
    if(thing[x].stat==-1)
      return x;
  }

  return maxthing-1;
}

int findEmptyTOffset(int offset)
{
  int x;

  for(x=offset; x<maxthing; x++)
  {
    if(thing[x].stat==-1)
      return x;
  }

  return maxthing-1;
}